<?php
/**
 * newss.php
 * Users Management
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles@santucci.fr>
 * @license  http://www.php.net/license/3_01.txt  PHP License 3.01
 * */     
define("PATHBASE","../");
define("PATH_IMG","../images/");
require_once PATHBASE.'header.php';

$targetFile='news.php?';
$cnx=new connexion_db(PATHBASE);

$displayTable=true;

// get user cases management
// param for news ID
if (isset($_REQUEST['news_id_for_manager']))
{
  $paramFieldKey='news_id';
  $paramFieldValue=$_REQUEST['news_id_for_manager'];
}
include PATHBASE.'user_switch_cases.php';

// check token  
if (appUtils::checkToken())
{        
// action allowed  
  switch ($_REQUEST['action'])
  {
    case 'delete':
      // delete news
      $request->sqlGet("DELETE FROM framework_news WHERE news_id=".$_REQUEST['id_to_delete']);?>
      <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_object_deleted);?></div><?php  	
    break;
	  
    case 'modify':
      $request=new sqlRequest("SELECT news_id,news_content,news_link 
                               FROM framework_news 
                               WHERE news_id=".$_REQUEST['id_to_modify'],$cnx->num);
      $news=$request->getObject();   
      // Get news form
      $form_legend=TextFormat($legend_changing_f.' '.lcfirst($text_news));
      include 'news_form.php';
      // Do not dipaly the newss list table
      $displayTable=false;  	
    break;	
     
    case 'submit_modify':
      // Update news with data from the form
      $request=new sqlRequest("UPDATE framework_news
                               SET news_content='".$cnx->escape_string($_POST['form_item_content'])."',
                                   news_link='".$_POST['form_item_link']."'
                               WHERE news_id=".$_POST['news_id'],$cnx->num);?>
      <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_object_updated);?></div><?php
    break;  
     
    case 'new':
      // create an empty standard news object
      $news=new stdClass();
      $news->news_content='';
      $news->news_link='';
      $news->news_id=0;
      // Get the standard news form        
      $form_legend=TextFormat($legend_creation_f.' '.lcfirst($text_news));
      include 'news_form.php';
      $displayTable=false;
    break;
    
    case 'submit_new':
      // create news
      $request=new sqlRequest("INSERT INTO framework_news (news_content,news_link,news_date,news_language) 
                               VALUES ('".$cnx->escape_string($_POST['form_item_content'])."',
                                       '".$_POST['form_item_link']."',NOW(),'".$_SESSION['language']."')",$cnx->num); ?>        
      <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_object_created);?></div><?php
    break;
  }  	 
}

  if ($displayTable)
  {
    // set token  
    appUtils::initToken(); 
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());      
          
    displayButton(TextFormat($button_new_news),'',$targetFile.'&action=new','tsc_awb_small tsc_awb_blue tsc_flat');	
      
    $sqlNews="SELECT * FROM framework_news
              WHERE news_language='".$_SESSION['language']."'"; 
    $request=new sqlRequest($sqlNews,$cnx->num); 	  	     
    $request->countRows();
    $pageNumbering=new changePage('page_news',$request->rowCount,$targetFile,PATH_IMG,getParameter('PGNUBR',$cnx->num));
           
    $sortColumn=new sortColumn('news_sort',$targetFile,PATH_IMG);
    $pageNumbering->displayNavigator(TextFormat($text_no_item));?>
     <table class="zebraTable" >
       <tr> 
         <th><?php TextDisplay($text_date);  $sortColumn->displaySortButtons('news_date');?></th>
         <th><?php TextDisplay($text_news);  ?></th>
         <th><?php TextDisplay($text_link);  $sortColumn->displaySortButtons('user_name');?></th>         
         <th><center><a href="#" tooltip="<?php TextDisplay($text_management);?>"><img src="<?php echo PATH_IMG;?>tools.png" border="0" /></a></center></th>       
       </tr><?php
       $request->sqlGet($sqlNews.$sortColumn->returnSqlOrderBy().$pageNumbering->returnSqlLimit(),$cnx->num); 	  	     
       $resultsArray=$request->getArrayFields();       
       for ($i=0;$i<count($resultsArray);$i++)
       { ?>
         <tr <?php if (fmod($i,2)==1) { echo 'class="alt"'; }?>>
           <td><?php TextDisplay(format_date($resultsArray[$i]['news_date']));?></td>
           <td><?php echo $resultsArray[$i]['news_content'];?></td>
    	   <td><?php echo $resultsArray[$i]['news_link'];?></td>
           <td class="nowrap">
           <center>
               <a href="<?php echo $targetFile;?>&action=modify&id_to_modify=<?php echo $resultsArray[$i]['news_id'];?>" tooltip="<?php TextDisplay($action_modify);?>"><img src="<?php echo PATH_IMG;?>edit.png" border=0 /></a>
               <a href="<?php echo $targetFile;?>&action=delete&id_to_delete=<?php echo $resultsArray[$i]['news_id'];?>" tooltip="<?php TextDisplay($action_delete);?>" onclick="return confirm('<?php TextDisplay($msg_confirm_delete_object);?>');"><img src="<?php echo PATH_IMG;?>delete.png" border=0 /></a>
           </center>
           </td>                      
         </tr><?php
       }?>
     </table><?php
  }

$cnx->close();  

require_once PATHBASE.'footer.php';?>

