<?php
/**
 * Users management : form to create and modify
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:users
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
 
  // Set variable to use the form for administration purpose
  $myProfile=!isset($myProfile) ? false :$myProfile;
  // Get global profiles list
  $request=new sqlRequest("SELECT profile_id,profile_name 
                           FROM ".PARAM_DB_PREFIX."framework_profiles 
                           WHERE profile_type='GLOBAL' 
                           ORDER BY profile_name ",$cnx->num);
  $profiles_list=$request->getArrayFields();  
  
  // Get languages list
  $request->sqlGet("SELECT langs.language_tag,language_name 
                    FROM ".PARAM_DB_PREFIX."framework_languages langs  
                    WHERE language_status=1 
                    ORDER BY langs.language_tag"); 
  $languagesList=$request->getArrayFields();  
  
  // If it's a new user, allow fields to be updated
  if ($_REQUEST['action']=='modify' && !$myProfile)
  {
    $displayReadonlyFields=$user->user_connection_mode=='LDAP';
	$displaySubmitButton=true;
	$checkForm=!$displayReadonlyFields;
  }
  else
  {
    $displayReadonlyFields=(getParameter('LDAP',$cnx->num) && $myProfile &&  $user->user_connection_mode=='LDAP');
    $checkForm=!$displayReadonlyFields;
    $displaySubmitButton=true;
  }
  
  // get list of themes by listing folders in the theme directory
  // the name of the theme is the name of the folder
  $themesList=array();
  //get list of directories 
  $themesDirectory=opendir(PATHBASE.'themes');
  while($dirName = readdir($themesDirectory)) 
  {
    // if name is a real directory, it is a theme  
    if($dirName!='.' && $dirName!='..')
    {
      //load themes array  
      $themesList[]=$dirName;
    }
  }
  // sort array of themes
  sort($themesList);
  // close the directory pointer
  closedir($themesDirectory);  
  
  // init $displayPasswordInputsInForm to false if not exist
  $displayPasswordInputsInForm= isset($displayPasswordInputsInForm) ? $displayPasswordInputsInForm : false;
  ?>  
  
      <form  class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>&action=submit_<?php echo $_REQUEST['action'];?>" method="post" enctype="multipart/form-data" name="form_user">
          <?php appUtils::insertTokenInForm();?><?php
          if (isset($paramFieldKey))
          {?>
            <input type="hidden" name="<?php echo $paramFieldKey;?>" value="<?php echo $paramFieldValue;?>" /><?php
          }?>
       <fieldset class="fieldset">
        <legend class="legend"><?php echo $form_legend;?></legend>
         <label class="label required_field200"  ><?php TextDisplay($text_login);?></label>
         <input class="<?php if($_REQUEST['action']!='create_user') { echo 'readonly';} else{ echo 'std';} ?>_form_field" name="form_item_login" id="form_item_login" type="text" size="25" value="<?php echo $user->user_login;?>" <?php if($_REQUEST['action']!='create_user') { echo 'readonly="readonly"';} ?> /><div class="clearleft"></div>
         <label class="label required_field200" ><?php TextDisplay($text_firstname);?></label>
         <input class="<?php if ($displayReadonlyFields) { echo 'readonly';} else{ echo 'std';} ?>_form_field" name="form_item_firstname" type="text" size="30"  value="<?php echo $user->user_firstname;?>" <?php if ($displayReadonlyFields) { echo 'readonly="readonly"';} ?> /><div class="clearleft"></div>
         <label class="label required_field200" ><?php TextDisplay($text_name);?></label>
         <input class="<?php if ($displayReadonlyFields) { echo 'readonly';} else{ echo 'std';} ?>_form_field" name="form_item_name" type="text" size="30"  value="<?php echo $user->user_name;?>" <?php if ($displayReadonlyFields) { echo 'readonly="readonly"';} ?> /><div class="clearleft"></div>
         <label class="label required_field200" ><?php TextDisplay($text_email);?></label>
         <input class="<?php if ($displayReadonlyFields) { echo 'readonly';} else{ echo 'std';} ?>_form_field" name="form_item_email" type="text" size="30"  value="<?php echo $user->user_mail;?>" <?php if ($displayReadonlyFields) { echo 'readonly="readonly"';} ?> /><div class="clearleft"></div>
         
	 <label class="label required_field200" ><?php TextDisplay($text_language);?></label><?php
           if ($myProfile) 
	   { 
             for ($i=0;$i<count($languagesList);$i++)
             {	
               if ($languagesList[$i]['language_tag']==$user->user_language) 
	       {?>
		 <input class="readonly_form_field" readonly="readonly" type="text" size="15" value="<?php echo $languagesList[$i]['language_name'];?>" />
                 <input name="form_item_language" type="hidden" value="<?php echo $user->user_language;?>">    <?php
	         break;
	       }
             }
           }
           else
           {?>
             <select name="form_item_language" class="std_form_field_liste" ><?php
             for ($i=0;$i<count($languagesList);$i++)
             {?>
               <option  value="<?php echo $languagesList[$i]['language_tag'];?>" <?php if ($languagesList[$i]['language_tag']==$user->user_language) {echo 'selected="selected"';}?> ><?php echo $languagesList[$i]['language_name'];?></option><?php
             }?>
             </select><?php  
           }  ?>
          <div class="clearleft"></div>  		 
		 
         <label class="label required_field200" ><?php TextDisplay($text_profile);?></label><?php
	     if ($myProfile) 
	     { 
	       for ($i=0;$i<count($profiles_list);$i++)
               {
		 if ($profiles_list[$i]['profile_id']==$user->user_profile_id_fk) 
		 {?>
		   <input class="readonly_form_field" readonly="readonly" type="text" size="25" value="<?php echo $profiles_list[$i]['profile_name'];?>" /><?php
		   break;
		 }
               }
	     }
	     else
	     {?>
               <select name="form_item_profile" class="std_form_field_liste" ><?php
                for ($i=0;$i<count($profiles_list);$i++)
                {?>
                  <option  value="<?php echo $profiles_list[$i]['profile_id'];?>" <?php if ($profiles_list[$i]['profile_id']==$user->user_profile_id_fk) {echo 'selected="selected"';}?> ><?php echo $profiles_list[$i]['profile_name'];?></option><?php
                }?>  
               </select><?php
             }?>  <div class="clearleft"></div>  		 <?php
		 
	     if ($myProfile) 
	     { ?>
                <label class="label required_field200" ><?php TextDisplay($text_theme);?></label>

           <select name="form_item_theme" class="std_form_field_liste" ><?php
             for ($i=0;$i<count($themesList);$i++)
             {?>
               <option  value="<?php echo $themesList[$i];?>" <?php if ($themesList[$i]==$user->user_theme) {echo 'selected="selected"';}?> ><?php echo $themesList[$i];?></option><?php
             }?>
           </select>		 
           <div class="clearleft"></div>  		 <?php
	     }?> 
         <br /><?php
         // if necessary (user creation when not using user activation system), add password inputs
         if ($displayPasswordInputsInForm && $displayPasswordForm)
         {
           // load only inputs  
           $useAsForm=false;  
           include 'user_password_form.php';  
         } ?><br /><?php
         // display Sbumit button if form needs to be validated
         if ($displaySubmitButton) 
	 {
	   if ($checkForm)
	   {
	     displayButton(TextFormat($button_submit),'',"javascript:CheckFormUser('".PATHBASE."','".$_REQUEST['action']."',".($displayPasswordInputsInForm && $displayPasswordForm ?1:0).")",'tsc_awb_medium tsc_awb_green tsc_flat');	
	   } 
	   else
	   {
	     displayButton(TextFormat($button_submit),'','javascript:document.form_user.submit()','tsc_awb_medium tsc_awb_green tsc_flat');	
	   } 		 
           if (!$myProfile)
           { 
             displayButton(TextFormat($button_cancel),'',$targetFile,'tsc_awb_medium tsc_awb_orange tsc_flat');	
	   }
	 }?>

       </fieldset><div class="clearleft"></div>
      </form>