<?php
/**
 * Users Management
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     
define("PATHBASE",'../');
require PATHBASE.'header.php';

$targetFile='users.php?';
$cnx=new connexion_db();

$displayTable=true;
$displayPasswordForm=!(getParameter('USACT',$cnx->num));

include PATHBASE.'user_switch_cases.php';

// check token  
if (appUtils::checkToken())
{        
  // action allowed 
  switch ($_REQUEST['action'])
  {
    case 'delete':
          $request=new sqlRequest("SELECT * 
                                   FROM ".PARAM_DB_PREFIX."framework_users 
                                   WHERE user_login='".$_REQUEST['id_to_delete']."'",$cnx->num);
          $user=$request->getObject();      
  	  $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."framework_users 
                            WHERE user_login='".$_REQUEST['id_to_delete']."'");?>
  	  <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_object_deleted);?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php  	
    break;
	  
    case 'modify_user':
          $request=new sqlRequest("SELECT * FROM ".PARAM_DB_PREFIX."framework_users WHERE user_login='".$_REQUEST['id_to_modify']."'",$cnx->num);
          $user=$request->getObject();      
          // if password is managed by LDAP
          if($user->user_connection_mode=='LDAP')
          {  
            // display message?>
            <div class="MessageBox InformationMessageBox"><?php TextDisplay($msg_password_not_locally_managed);?></div><?php
          }      
          // Get user form
          $form_legend=TextFormat($legend_changing_m.' '.lcfirst($text_user));
          include 'user_form.php';
          // display password form if allowed by settings and if user is LOCAL
          if ($displayPasswordForm && $user->user_connection_mode=='LOCAL')
          {
            // use standard form with user  
            $userLoginToChange=$_REQUEST['id_to_modify'];  
            include 'user_password_form.php';
          }  
          // Do not display the users list table
          $displayTable=false;  	
    break;	
     
    case 'search_ldap_uid':	
    case 'search_ldap':
      // include form to search the LDAP
      include 'ldap_form_search.php';
      $displayTable=false;
    break;
	
    case 'add_user_from_ldap':
          $request=new sqlRequest("SELECT * FROM ".PARAM_DB_PREFIX."framework_users WHERE user_login='".$_REQUEST['username']."'",$cnx->num);
          $request->countRows();
          if ($request->rowCount!=0)
	  {?>
            <div class="MessageBox WarningMessageBox"><?php TextDisplay($msg_user_already_exists);?></div>	  <?php
	  }
	  else
	  {
	    // Get default profile
	    $request->sqlGet("SELECT profile_id,profile_name 
                              FROM ".PARAM_DB_PREFIX."framework_profiles 
                              WHERE profile_tag IN('STD','GRP_MNG') 
                              ORDER BY profile_name ");
	    $request->getObject();
	    $defaultProfileId=$request->objet->profile_id;
	    // Get LDAP data
            // get LDAP settings from DB  
            $request=new sqlRequest("SELECT parameter_tag_id_fk,parameter_value 
                                     FROM ".PARAM_DB_PREFIX."framework_parameters 
                                     WHERE parameter_tag_id_fk LIKE 'LDP%'",$cnx->num);
            $ldapData=$request->getArrayFieldsOneField();
            // build the constants
            define("LDAP_SERVER",$ldapData['LDPSRV']);
            define("LDAP_PORT",$ldapData['LDPPRT']);
            define("LDAP_BASE_DN",$ldapData['LDPBDN']);
            define("LDAP_UID_FIELD",$ldapData['LDPUID']);
            define("LDAP_NAME_FIELDS_NAME",$ldapData['LDPNAM']);
            define("LDAP_NAME_FIELDS_FIRSTNAME",$ldapData['LDPFNM']);
            define("LDAP_NAME_FIELDS_FULLNAME",$ldapData['LDPFUN']);
            define("LDAP_ATTRIBUTES",$ldapData['LDPATT']);
            define("LDAP_ALL_ATTRIBUTES",$ldapData['LDPAAT']);
            define("LDAP_BIND_DN",$ldapData['LDPBID']);
            define("LDAP_BIND_PASS",$ldapData['LDPBIP']);
            define("LDAP_USER_OBJECTCLASS",$ldapData['LDPOBJ']);             
            // create connection
	    $ldapConnection=new mtLdap();
  	    // get user data
	    $userData=$ldapConnection->getData($_REQUEST['username']);	  
 	    $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."framework_users (user_login,user_name,user_firstname,user_mail,user_password,
		                                          user_profile_id_fk,user_creation_date,user_status_id_fk,
					                  user_connection_mode,user_theme,user_confirmed) 
	                     VALUES ('".strtolower($_REQUEST['username'])."','".$userData->lastname."','".$userData->firstname."',
		                     '".$userData->mail."','',".$defaultProfileId.",'".aujourdhui()."',
				     (SELECT status_id FROM ".PARAM_DB_PREFIX."framework_status WHERE status_target_object='USR' ANd status_order=1),
				     'LDAP','".getParameter('THEME',$cnx->num)."',1)");?>
	    <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_object_created);?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
	  }
    break;
        
    case 'change_status':
	  $wkf=new workflow('USR',PARAM_DB_PREFIX.'framework_workflows',PARAM_DB_PREFIX.'framework_status',PARAM_DB_PREFIX.'framework_workflows_transitions',$_SESSION['language'],PATHBASE);
          $wkf->change_object_status($_REQUEST['user_login'],$_REQUEST['new_status_id']);?>
	  <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_status_changed);?></div><?php
    break;	
    
    case 'reset_password':
          // reset key  
          $userConfirmationKey=md5('key'.$_GET['user2reset'].time());
          // get user details  
          // protect input
          $formLogin=substr($_GET['user2reset'],0,LG_MAX_LOGIN);  
          $userToReset=new appUser($cnx->num,$formLogin);  
    
          // update user confirmation requested date 
          $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."framework_users 
                           SET user_confirmed=0,
                               user_confirmation_key_stamp=NOW(),
                               user_confirmation_key='".$userConfirmationKey."' 
                           WHERE user_login='".$_GET['user2reset']."'");
          // send email
          //Create a new PHPMailer instance
          $mail = new PHPMailer;
          //Set who the message is to be sent from
          $mail->setFrom(getParameter('FROMML',$cnx->num),getParameter('FROMNM',$cnx->num));
          //Set who the message is to be sent to
          $mail->addAddress($userToReset->email, $userToReset->firstname.' '.$userToReset->lastname);
          //Set the subject line
          $mail->Subject =  str_replace('__APP__',$appName,file_get_contents(PATHBASE.'/mails/'.$userToReset->language.'_subject_reset_password.txt'));
          //Read an HTML message body from an external file, convert referenced images to embedded,
          // build URL
          $urlToValidate=getServerROOT().getParameter('APDIR',$cnx->num).'validate.php?k='.$userConfirmationKey.'&lg='.$userToReset->language;
          //convert HTML into a basic plain-text alternative body
          $messageBody=file_get_contents(PATHBASE.'/mails/'.$userToReset->language.'_contents_reset_password.html');
          // set name in mail
          $messageBody=str_replace('__NAME__',$userToReset->firstname.' '.$userToReset->lastname,$messageBody);
          // set link in mail
          $messageBody=str_replace('__LINK__',$urlToValidate,$messageBody);
          // set app in mail
          $messageBody=str_replace('__APP__',$appName,$messageBody);
          
          $mail->msgHTML($messageBody, dirname(__FILE__));
     
          //send the message, check for errors
          if (!$mail->send()) 
          {
            echo "Mailer Error: " . $mail->ErrorInfo;
          } 
          else 
          {?>
    	    <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_password_reset);?></div>  
            <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php            
          }
    break;
  }  	 
}

  if ($displayTable)
  {
    // get parameter regarding type of password management : direct or only by email
    $manageUserPasswordByEmail=getParameter('USACT',$cnx->num);
    // set token  
    appUtils::initToken(); 
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());  
    // set workflow for users
    $wkf=new workflow('USR',PARAM_DB_PREFIX.'framework_workflows',PARAM_DB_PREFIX.'framework_status',PARAM_DB_PREFIX.'framework_workflows_transitions',$_SESSION['language'],PATHBASE);
    $wkf->set_profile(PARAM_DB_PREFIX.'framework_workflows_transitions_profiles','profile_id_fk',$_SESSION['user_profile']);
    // display button for adding an user
    displayButton(TextFormat($button_new_user),'',$targetFile.'&action=create_user','tsc_awb_small tsc_awb_blue tsc_flat');	     
    if (getParameter('LDAP',$cnx->num))
    {
       displayButton(TextFormat($button_new_user_ldap),'',$targetFile.'&action=search_ldap','tsc_awb_small tsc_awb_purple tsc_flat');
    }  ?>
     <div class="clearleft"></div><?php
	 
    // display filters 
    $filtres=new filters(PATHBASE,$pathImages);
    $filtres->add_field('filter_user_login',$text_login,'string','user_login');     	
    $filtres->add_field('filter_user_name',$text_name,'string','user_name');     	
    $filtres->add_field('filter_user_mail',$text_email,'string','user_mail');     	

    $filtres->display($targetFile,$button_filter,$text_filter_inactive);
	 
    // SQL request for users
    $sqlUsers="SELECT user_login,user_name,user_firstname,user_confirmed,
                      user_mail,user_mail,profile_name,user_connection_mode, profile_id,
                      user_confirmation_key_stamp, user_language,status_translation_value  
	       FROM ".PARAM_DB_PREFIX."framework_status,
                    ".PARAM_DB_PREFIX."framework_status_translations,".PARAM_DB_PREFIX."framework_users 
	       LEFT JOIN ".PARAM_DB_PREFIX."framework_profiles ON user_profile_id_fk=profile_id 
	       WHERE status_translation_language='".$_SESSION['language']."' 
                 AND user_status_id_fk=status_id_fk 
                 AND status_id_fk=status_id ".$filtres->return_sql_filter();

   
    $request=new sqlRequest($sqlUsers,$cnx->num); 	  	     
    $request->countRows();
    // start page numbering object
    $pageNumbering=new changePage('page_users',$request->rowCount,$targetFile,$pathImages,getParameter('PGNUBR',$cnx->num));
           
    // start column sorting object
    $sortColumn=new sortColumn('user_sort',$targetFile,$pathImages);
    $pageNumbering->displayNavigator(TextFormat($text_no_item));?>
     <table class="zebraTable">
       <tr>
         <th><?php TextDisplay($text_login);  $sortColumn->displaySortButtons('user_login');?></th>
         <th><?php TextDisplay($text_firstname);  $sortColumn->displaySortButtons('user_firstname');?></th>
         <th><?php TextDisplay($text_name);  $sortColumn->displaySortButtons('user_name');?></th><?php
           if ($manageUserPasswordByEmail)
           {?>
             <th><?php TextDisplay($text_user_confirmed);  $sortColumn->displaySortButtons('user_confirmed');?></th>
             <th></th><?php
           }?>  
         <th><?php TextDisplay($text_email);  $sortColumn->displaySortButtons('user_mail');?></th>
	 <th><?php TextDisplay($text_language);  $sortColumn->displaySortButtons('user_language');?></th>
	 <th><?php TextDisplay($text_profile);  $sortColumn->displaySortButtons('profile_name');?></th>
	 <th><?php TextDisplay($text_connection_mode);  $sortColumn->displaySortButtons('user_connection_mode');?></th>
   
	 <th><?php TextDisplay($text_status); ?></th>         
	 <th><center><a href="#" tooltip="<?php TextDisplay($text_workflow);?>"><img src="<?php echo $pathImages;?>workflow.gif" border="0"  /></a></center></th>		 
         <th><center><a href="#" tooltip="<?php TextDisplay($text_management);?>"><img src="<?php echo $pathImages;?>tools.png" border="0" /></a></center></th>       
       </tr><?php
       $request->sqlGet($sqlUsers.$sortColumn->returnSqlOrderBy().$pageNumbering->returnSqlLimit(),$cnx->num); 	  	     
       $resultsArray=$request->getArrayFields();       
       for ($i=0;$i<count($resultsArray);$i++)
       { ?>
         <tr>
           <td><?php echo $resultsArray[$i]['user_login'];?></td>
           <td><?php echo $resultsArray[$i]['user_firstname'];?></td>
           <td><?php echo $resultsArray[$i]['user_name'];?></td><?php
             if ($manageUserPasswordByEmail)
             {?>
           <td><?php // display picture for confirmation

               if ($resultsArray[$i]['user_confirmed'])
               {?>
                 <img src="<?php echo $pathImages;?>tick.png" border="0"  /><?php
               }
               else
               {?>
                 <img src="<?php echo $pathImages;?>error.png" border="0"  /><?php  
               }

               // if confirmation date is overdue, display a "reset activation" icon, that will resend a mail and add 48h for activation
               $today=new DateTime();
               $keyValidityDate=new DateTime($resultsArray[$i]['user_confirmation_key_stamp']);
               // add 48h to key date
               $keyValidityDate->add(new DateInterval("PT48H"));
               // check if time of check is before due date
               if ($today>$keyValidityDate && !$resultsArray[$i]['user_confirmed'])  
               {
                 echo ' '.$text_key_no_more_valid;  
               }?>
           </td>
           <td><?php
             if ($resultsArray[$i]['user_connection_mode']=='LOCAL')
             {?>
               <a href="<?php echo $targetFile;?>&action=reset_password&user2reset=<?php echo $resultsArray[$i]['user_login'];?>" tooltip="<?php TextDisplay($action_reset_pass);?>" onclick="return confirm('<?php TextDisplay($msg_confirm_reset_pass);?>');"><img src="<?php echo $pathImages;?>reset_password.png" border=0 /></a><?php
             }?>
           </td><?php
             }?>
           <td><a href="mailto:<?php echo $resultsArray[$i]['user_mail'];?>" class="mailto_link"><?php echo $resultsArray[$i]['user_mail'];?></a></td>
	   <td><?php echo $resultsArray[$i]['user_language'];?></td>
	   <td><?php 
	     if ($resultsArray[$i]['profile_id']==0)
	     {
	       TextDisplay($text_std_profile);
	     }
	     else
	     {
	       echo $resultsArray[$i]['profile_name'];
	      }?>
	   </td>
	   <td><?php echo $resultsArray[$i]['user_connection_mode'];?></td>
	   <td><?php echo $resultsArray[$i]['status_translation_value'];?></td>
           <td class="nowrap"><center><?php
           if ($resultsArray[$i]['user_login']!=$_SESSION['login'])
           {           
	     $status_list=$wkf->etats_suivants_tablo($resultsArray[$i]['user_login']);
	     for ($k=0;$k<count($status_list);$k++)
	     {?>
	       <a href="<?php echo $targetFile;?>&action=change_status&new_status_id=<?php echo $status_list[$k]['status_id']; ?>&user_login=<?php echo $resultsArray[$i]['user_login'];?>" tooltip="<?php TextDisplay($action_change_status.' : '.$status_list[$k]['status_value']);?>"><img src="<?php echo $pathImages.$status_list[$k]['status_icon'];?>" border="0"  /></a><?php
	     }
           }?></center>
	   </td> 		   
           <td class="nowrap"><center><?php
              if ($resultsArray[$i]['user_login']!=$_SESSION['login'])
              {?>
                <a href="<?php echo $targetFile;?>&action=modify_user&id_to_modify=<?php echo $resultsArray[$i]['user_login'];?>" tooltip="<?php TextDisplay($action_delete);?>"><img src="<?php echo $pathImages;?>edit.png" border=0 /></a>
                <a href="<?php echo $targetFile;?>&action=delete&id_to_delete=<?php echo $resultsArray[$i]['user_login'];?>" tooltip="<?php TextDisplay($action_delete);?>" onclick="return confirm('<?php TextDisplay($msg_confirm_delete_object);?>');"><img src="<?php echo $pathImages;?>delete.png" border=0 /></a><?php
              }?></center>
           </td>                      
         </tr><?php
       }?>
     </table><?php
  }

$cnx->close();  

require_once PATHBASE.'footer.php';?>