<?php
/**
 * Columns template management
 *
 * PHP versions 4 and 5
 *
 * @framework_ Scripts
 * @package  ProjectMngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     
define("PATHBASE",'../');
require_once PATHBASE.'header.php';
// set var for current file to use in actions
$targetFile='app_columns.php?';
// init DB connexion
$cnx=new connexion_db();

$displayTable=true;

// check token  
if (appUtils::checkToken())
{        
  // action allowed    
  switch ($_REQUEST['action'])
  {
    case 'delete':
      // delete and display message  
      $request=new sqlRequest("DELETE FROM kados_template_columns WHERE column_tag='".$_REQUEST['id_to_delete']."'",$cnx->num);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_deleted;?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;
	
    case 'new_column':
      // display form to create a new column ?>
      <form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>&action=submit_new" method="post" enctype="multipart/form-data" name="form_column">
       <fieldset class="fieldset">
         <legend class="legend"><?php echo $legend_creation_f.' '.lcfirst($text_column);?></legend>
         <?php appUtils::insertTokenInForm();?>
         <label class="label required_field50" ><?php echo $text_tag;?></label>
         <input class="std_form_field" name="form_item_tag" type="text" size="5" maxlength="5" value="" /><div class="clearleft"></div>			 
         <label class="label required_field50" ><?php echo $text_name;?></label>
         <input class="std_form_field" name="form_item_name" type="text" size="15" maxlength="15" value="" /><div class="clearleft"></div>
         <label class="label length50" ><?php echo $text_description;?></label>
	     <input class="std_form_field" name="form_item_description" size="60" maxlength="100" value="" type="text">	  <div class="clearleft"></div>		 
         <br /><?php
           displayButton($button_submit,'','javascript:CheckFormColumn(1)','tsc_awb_medium tsc_awb_green tsc_flat');	
           displayButton($button_cancel,'',$targetFile,'tsc_awb_medium tsc_awb_orange tsc_flat');	?>
	  
       </fieldset><div class="clearleft"></div>
      </form><?php
      $displayTable=false;
    break;
  
    case 'submit_new':
      // create a new column  
      $wkf=new workflow('COL','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
      $request=new sqlRequest("INSERT INTO kados_template_columns (column_tag,column_name,column_usage,column_status_id_fk) 
                               VALUES ('".$_POST['form_item_tag']."',
	                               '".formatStringForDB($_POST['form_item_name'])."',
				       '".formatStringForDB($_POST['form_item_description'])."',
				       ".$wkf->init_statut().")",$cnx->num);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_created;?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php	
    break;
  
    case 'modify':
      // display form to update a column  
  	  $request=new sqlRequest("SELECT column_tag,column_name,column_usage FROM kados_template_columns WHERE column_tag='".$_REQUEST['id_to_modify']."'",$cnx->num);
      $column=$request->getObject();?>
      <form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>&action=submit_modify" method="post" enctype="multipart/form-data" name="form_column">
       <fieldset class="fieldset">
         <legend class="legend"><?php echo $legend_changing_f.' '.lcfirst($text_column).' : '.$column->column_tag;?></legend>
         <?php appUtils::insertTokenInForm();?>
         <input type="hidden" name="form_item_tag" value="<?php echo $_REQUEST['id_to_modify'];?>">
         <label class="label required_field50" ><?php echo $text_name;?></label>
         <input class="std_form_field" name="form_item_name" type="text" size="15" maxlength="15" value="<?php echo $column->column_name;?>" /><div class="clearleft"></div>
         <label class="label length50" ><?php echo $text_description;?></label>
	     <input class="std_form_field" name="form_item_description" size="60" maxlength="100" value="<?php echo $column->column_usage;?>" type="text">	  <div class="clearleft"></div>	
         <br /><?php
           displayButton($button_submit,'','javascript:CheckFormColumn(0)','tsc_awb_medium tsc_awb_green tsc_flat');	
           displayButton($button_cancel,'',$targetFile,'tsc_awb_medium tsc_awb_orange tsc_flat');	?>
	
       </fieldset><div class="clearleft"></div>
      </form><?php
      $displayTable=false;  	
    break;	
     
    case 'submit_modify':
      // record updated column
  	  $request=new sqlRequest("UPDATE kados_template_columns 
	                        SET column_name='".formatStringForDB($_POST['form_item_name'])."',column_usage='".formatStringForDB($_POST['form_item_description'])."' 
	                        WHERE column_tag='".$_REQUEST['form_item_tag']."'",$cnx->num);?>
  	  <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_updated;?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;  
     
    case 'change_status':
      // change column status  
      $wkf=new workflow('COL','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
      // use workflow to set new status  
      $wkf->change_object_status($_REQUEST['column_tag'],$_REQUEST['new_status_id']);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_status_changed;?></div><?php
    break;			 
  }  	 
}
  // display results
  if ($displayTable)
  {
    // set token  
    appUtils::initToken();
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());      
    
    // set workflow for columns
    $wkf=new workflow('COL','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
    $wkf->set_profile('framework_workflows_transitions_profiles','profile_id_fk',$_SESSION['user_profile']);
  
    // init sql for columns
    $sqlColumns="SELECT column_tag,column_name,column_usage,column_status_id_fk FROM kados_template_columns"; 
    $request=new sqlRequest($sqlColumns,$cnx->num); 	  	     
    $request->countRows();
    // set page numbering object
    $pageNumbering=new changePage('page_columns',$request->rowCount,$targetFile,$pathImages,getParameter('PGNUBR',$cnx->num));
    
    // init srting object
    $sortColumn=new sortColumn('columns_sort',$targetFile,$pathImages);
    // button to create a new column	 
    displayButton($button_new_column,'',$targetFile.'&action=new_column','tsc_awb_small tsc_awb_blue tsc_flat');	
	 
     $pageNumbering->displayNavigator($text_no_item);?>
     <table class="zebraTable">
       <tr>
         <th><?php echo $text_tag; $sortColumn->displaySortButtons('column_tag');?></th> 
         <th><?php echo $text_name; $sortColumn->displaySortButtons('column_name');?></th>
         <th><?php echo $text_description;?></th>
		 <th><?php echo $text_status;?></th>
		 <th><center><a href="#" tooltip="<?php TextDisplay($text_workflow);?>"><img src="<?php echo $pathImages;?>workflow.gif" border="0"  /></a></center></th>		 
         <th><center><a href="#" tooltip="<?php echo $text_management;?>"><img src="<?php echo $pathImages;?>tools.png" border="0" /></a></center></th>       
       </tr><?php
       // get columns and attributes
       $request=new sqlRequest($sqlColumns.$sortColumn->returnSqlOrderBy().$pageNumbering->returnSqlLimit(),$cnx->num);
       $resultsArray=$request->getArrayFields();
       // display list       
       for ($i=0;$i<count($resultsArray);$i++)
       {?>
         <tr>
           <td><?php echo $resultsArray[$i]['column_tag'];?></td>
           <td><?php echo $resultsArray[$i]['column_name'];?></td>
           <td><?php echo $resultsArray[$i]['column_usage'];?></td>
		   <td><?php echo $wkf->valeur_etat($resultsArray[$i]['column_status_id_fk']); ?></td>			 
           <td class="nowrap"><center><?php
		     $status_list=$wkf->etats_suivants_tablo($resultsArray[$i]['column_tag']);
			 for ($k=0;$k<count($status_list);$k++)
			 {?>
			     <a href="<?php echo $targetFile;?>&action=change_status&new_status_id=<?php echo $status_list[$k]['status_id']; ?>&column_tag=<?php echo $resultsArray[$i]['column_tag'];?>" tooltip="<?php TextDisplay($action_change_status.' : '.$status_list[$k]['status_value']);?>"><img src="<?php echo $pathImages.$status_list[$k]['status_icon'];?>" border="0"  /></a><?php
			 }?></center>
		   </td> 	
           <td class="nowrap">
		    <center>
		     <a href="<?php echo $targetFile;?>&action=modify&id_to_modify=<?php echo $resultsArray[$i]['column_tag'];?>" tooltip="<?php TextDisplay($action_delete);?>"><img src="<?php echo $pathImages;?>edit.png" border=0 /></a><?php
			 $request->sqlGet("SELECT COUNT(project_id_fk) AS nbProjects 
			                  FROM kados_projects_columns 
							  WHERE column_tag_fk='".$resultsArray[$i]['column_tag']."'");
			 $request->getObject();
			 if ($request->objet->nbProjects==0)
             {?>
               <a href="<?php echo $targetFile;?>&action=delete&id_to_delete=<?php echo $resultsArray[$i]['column_tag'];?>" tooltip="<?php TextDisplay($action_delete);?>" onclick="return confirm('<?php echo $msg_confirm_delete_object;?>');"><img src="<?php echo $pathImages;?>delete.png" border=0 /></a><?php
             }?>
		    </center>
		   </td>
         </tr><?php
       }?>
     </table><?php
  }
// close connexion to DB
$cnx->close();  
// display footer for page
require_once PATHBASE.'footer.php';?>