<?php
/**
 * Tags template management
 *
 * PHP versions 4 and 5
 *
 * @framework_ Scripts
 * @package  ProjectMngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     
define("PATHBASE",'../');
require_once PATHBASE.'header.php';
$targetFile='template_tags.php?';
$cnx=new connexion_db();

$displayTable=true;

// init an array for names of postit
// easier to ue in form
$postitTypeTable['US']=$text_US;
$postitTypeTable['TASK']=$text_task;	

  switch ($_REQUEST['action'])
  {
    case 'delete':
      // delete tag from DB. No impact  
      $request=new sqlRequest("DELETE FROM kados_tags WHERE tag_id=".intval($_REQUEST['id_to_delete']),$cnx->num);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_deleted;?></div>          
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;

    case 'new_tag':
      // init colors table  
      $colors=array();
      $request->sqlGet("SELECT color_name FROM kados_colors");
      $colors=$request->getArrayFirstFieldOnly();

      // init form vars
      $legendLabel=$legend_creation_m.' '.lcfirst($text_tag);
      // create new empty object for tag
      $tagData=new stdClass();
      $tagData->tag_label='';
      $tagData->tag_color=$colors[0];
      $tagData->tag_postit_type='US';
      $tagData->tag_type='ALL_MAND';
      $tagId=-1;
      // get postit color types
      $request->sqlGet("SELECT use_color_id AS use_color_id_fk,tag_id_fk,
	                       CONCAT(use_color_meaning,' (',color,')') AS postit_meaning 
                        FROM kados_colors_uses 
                        LEFT JOIN kados_tags_allocations ON color_use_id_fk=use_color_id 
                                                        AND tag_id_fk=".$tagId."
			WHERE use_color_postit_type='".$tagData->tag_postit_type."'");
      $postItColorsList=$request->getArrayFields();      
      // show Type of tag (global mandatory or global optional)
      $showType=true;
      $TagPostitScope='ALL';
      // get form
      include PATHBASE.'forms/form_tag.php';
      $displayTable=false;
    break;
  
    case 'submit_new_tag':
      // init wokflow for tags  
      $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
      // insert values in table  
      $request=new sqlRequest("INSERT INTO kados_tags (tag_label,tag_owner,tag_color,tag_type,tag_status_id_fk,tag_postit_type) 
                               VALUES ('".$_POST['form_item_tag']."',
                                       '".$_SESSION['login']."',
				       '".$_POST['form_item_color']."',
				       '".$_POST['form_item_type']."',
				       ".$wkf->init_statut().",
                                       '".$_POST['form_item_postit_type']."')",$cnx->num);
      // get Id of new tag
      $idNew=$request->getLastId();
      // then link tag to specific postit (or none)
      if (isset($_POST['linkedPostits']))
      {
        // create new links
        for ($i=0;$i<count($_POST['linkedPostits']);$i++)
        {
          $request->sqlGet("INSERT INTO kados_tags_allocations 
                            (color_use_id_fk,tag_id_fk)
                            VALUES (".$_POST['linkedPostits'][$i].",".$idNew.")");
        }
      }       ?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_created;?></div>           
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php	
    break;
  
    case 'modify_tag':
      $tagId=intval($_REQUEST['id_to_modify']);  
      // get selected tag  
      $request=new sqlRequest("SELECT * 
                               FROM kados_tags 
                               WHERE tag_id=".$tagId,$cnx->num);
      $tagData=$request->getObject();
      // init an array with all colors
      $colors=array();
      // get colors
      $request->sqlGet("SELECT color_name FROM kados_colors");
      $colors=$request->getArrayFirstFieldOnly();	
      // get tags groups
      $request->sqlGet("SELECT tag_group_id,tag_group_name 
                        FROM kados_tags_groups 
                        WHERE tag_group_postit_type='".$tagData->tag_postit_type."'");
      $tagsGroups=$request->getArrayFields();       
      // get postit color types
      $request->sqlGet("SELECT use_color_id AS use_color_id_fk,tag_id_fk,
	                       CONCAT(use_color_meaning,' (',color,')') AS postit_meaning 
                        FROM kados_colors_uses 
                        LEFT JOIN kados_tags_allocations ON color_use_id_fk=use_color_id 
                                                        AND tag_id_fk=".$tagId." 
			WHERE use_color_postit_type='".$tagData->tag_postit_type."'");
			/*
                                 UNION
			       (SELECT use_color_id,tag_id_fk,object_color_meaning AS postit_meaning 
			        FROM kados_projects_colors,kados_colors,kados_colors_uses  
                                LEFT JOIN kados_tags_allocations ON color_use_id_fk=use_color_id 
			        WHERE project_id_fk=".$_SESSION['current_project_id']."
		 	          AND color_id_fk=color_id 
                                  AND use_color_postit_type=object_type 
                                  AND color=color_name 
                                  AND use_color_lock=0 
			          AND object_type='".strtoupper($shortItemType)."'");	       
                         */
      $postItColorsList=$request->getArrayFields();
      // init form vars
      $legendLabel=$legend_changing_m.' '.lcfirst($text_tag);
      $showType=true;
      $TagPostitScope='ALL';
      // get form
      include PATHBASE.'forms/form_tag.php';
      $displayTable=false;  	
    break;	
     
    case 'submit_modify_tag':
      // modify tag with new values
      $request=new sqlRequest("UPDATE kados_tags 
	                       SET tag_label='".$_POST['form_item_tag']."',
                                   tag_type='".$_POST['form_item_type']."', 
		                   tag_color='".$_POST['form_item_color']."'    
	                       WHERE tag_id='".$_REQUEST['tag_id']."'",$cnx->num);
      // delete existing links
      $request->sqlGet("DELETE FROM kados_tags_allocations WHERE tag_id_fk=".$_REQUEST['tag_id']);  
      // then link tag to specific postit (or none)
      if (isset($_POST['linkedPostits']))
      {
        // create new links
        for ($i=0;$i<count($_POST['linkedPostits']);$i++)
        {
          $request->sqlGet("INSERT INTO kados_tags_allocations 
                            (color_use_id_fk,tag_id_fk)
                            VALUES (".$_POST['linkedPostits'][$i].",".$_REQUEST['tag_id'].")");
        }
      }  ?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_updated;?></div>           
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;  
     
    case 'change_status':
      $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
      $wkf->change_object_status($_REQUEST['tag_id'],$_REQUEST['new_status_id']);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_status_changed;?></div>
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;			 
  }  	 
  
  if ($displayTable)
  {
    // get workflow for tags  
    $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
    $wkf->set_profile('framework_workflows_transitions_profiles','profile_id_fk',$_SESSION['user_profile']);
    // display button to add a tag (no criteria)
    displayButton($button_new_tag,'',$targetFile.'&action=new_tag','tsc_awb_small tsc_awb_blue tsc_flat');	?>
    <div class="clearleft"></div><?php
  
    // create filters
    $filtres=new filters(PATHBASE,$pathImages);
    // filter for tag name
    $filtres->add_field('filter_tag_name',$text_tag,'string','tag_label');     	
    // filter for tag group
    $filtres->add_field('filter_group',$text_tag_group,'requete','tag_group_id_fk');
    $filtres->define_field_request('filter_group',"tag_group_name",'kados_tags_groups','tag_group_id'," WHERE tag_group_scope='ALL'");
	
    // add filter for tag type
    $filtres->add_field('filter_tag_type',$text_type,'liste','tag_type');
    $filtres->define_field_list('filter_tag_type','ALL_MAND:'.$tagTypeDisplay['ALL_MAND'].',ALL_FREE:'.$tagTypeDisplay['ALL_FREE']);
    
    // add filter for tag postit type
    $filtres->add_field('filter_tag_postit_type',$text_postit_type,'liste','tag_postit_type');
    $filtres->define_field_list('filter_tag_postit_type','US:'.$postitTypeTable['US'].',TASK:'.$postitTypeTable['TASK']);

    // show filters
    $filtres->display($targetFile,$button_filter,$text_filter_inactive);
        
    // get tags list
    $sqlTags="SELECT * 
              FROM kados_tags 
              LEFT JOIN kados_tags_groups ON tag_group_id_fk=tag_group_id 
              WHERE tag_type IN ('ALL_FREE','ALL_MAND')".$filtres->return_sql_filter(); 
    $request=new sqlRequest($sqlTags,$cnx->num); 	  	     
    $request->countRows();
    // start page numebring object
    $pageNumbering=new changePage('page_tags',$request->rowCount,$targetFile,$pathImages,getParameter('PGNUBR',$cnx->num));
    // start sorting object       
    $sortColumn=new sortColumn('tags_sort',$targetFile,$pathImages);    
    
    // display pages navigator
     $pageNumbering->displayNavigator($text_no_item);?>
     <table class="zebraTable">
       <tr>
         <th><?php echo $text_tag; $sortColumn->displaySortButtons('tag_label');?></th>
         <th><?php echo $text_color; ?></th>    
         <th><?php echo $text_tag_group; $sortColumn->displaySortButtons('tag_group_name');?></th>	         
         <th><?php echo $text_linked_postit;?></th>	         
         <th><?php echo $text_type; $sortColumn->displaySortButtons('tag_type');?></th>		 
         <th><?php echo $text_postit_type; $sortColumn->displaySortButtons('tag_postit_type');?></th>		 
	 <th><?php echo $text_status;?></th>
	 <th><center><a href="#" tooltip="<?php TextDisplay($text_workflow);?>"><img src="<?php echo $pathImages;?>workflow.gif" border="0"  /></a></center></th>		 
         <th><center><a href="#" tooltip="<?php echo $text_management;?>"><img src="<?php echo $pathImages;?>tools.png" border="0" /></a></center></th>       
       </tr><?php
       // get tags with page and sorting parameters
       $request=new sqlRequest($sqlTags.$sortColumn->returnSqlOrderBy().$pageNumbering->returnSqlLimit(),$cnx->num);
       $resultsArray=$request->getArrayFields();
              
       // list tags of the current page 
       for ($i=0;$i<count($resultsArray);$i++)
       {
         // get linked postits if any
         $request->sqlGet("SELECT color,use_color_meaning 
                           FROM kados_colors_uses,kados_tags_allocations 
                           WHERE use_color_id=color_use_id_fk 
                             AND tag_id_fk=".$resultsArray[$i]['tag_id']);
         $linkedPostits=$request->getArrayFields();?>
         <tr>
           <td><?php echo $resultsArray[$i]['tag_label'];?></td>  
           <td><div class="colorDisplay <?php echo $resultsArray[$i]['tag_color'];?>"></div></td>
           <td><?php echo $resultsArray[$i]['tag_group_name'];?></td>
           <td><?php
             for ($k=0;$k<count($linkedPostits);$k++)
             {?>
               <div class="<?php echo $linkedPostits[$k]['color'];?>" style="width:auto;height:18px;float:left;margin-left:5px;padding-left:5px;padding-right:5px"><?php echo $linkedPostits[$k]['use_color_meaning'];?></div><?php  
             }?>
           </td>
	   <td><?php echo $tagTypeDisplay[$resultsArray[$i]['tag_type']];?></td>
           <td><?php echo $postitTypeTable[$resultsArray[$i]['tag_postit_type']];?></td>
	   <td><?php echo $wkf->valeur_etat($resultsArray[$i]['tag_status_id_fk']); ?></td>			 
           <td class="nowrap"><center><?php
	      $status_list=$wkf->etats_suivants_tablo($resultsArray[$i]['tag_id']);
	      for ($k=0;$k<count($status_list);$k++)
	      {?>
		<a href="<?php echo $targetFile;?>&action=change_status&new_status_id=<?php echo $status_list[$k]['status_id']; ?>&tag_id=<?php echo $resultsArray[$i]['tag_id'];?>" tooltip="<?php TextDisplay($action_change_status.' : '.$status_list[$k]['status_value']);?>"><img src="<?php echo $pathImages.$status_list[$k]['status_icon'];?>" border="0"  /></a><?php
	      }?></center>
	   </td> 	
           <td class="nowrap">
	      <center>
	      <a href="<?php echo $targetFile;?>&action=modify_tag&id_to_modify=<?php echo $resultsArray[$i]['tag_id'];?>" tooltip="<?php TextDisplay($action_delete);?>"><img src="<?php echo $pathImages;?>edit.png" border=0 /></a><?php
	      $request->sqlGet("SELECT COUNT(tag_id_fk) AS nbTags 
		               FROM kados_tags_postit 
		               WHERE tag_id_fk='".$resultsArray[$i]['tag_id']."'");
	      $request->getObject();
	      if ($request->objet->nbTags==0)
              {?>
                <a href="<?php echo $targetFile;?>&action=delete&id_to_delete=<?php echo $resultsArray[$i]['tag_id'];?>" tooltip="<?php TextDisplay($action_delete);?>" onclick="return confirm('<?php echo $msg_confirm_delete_object;?>');"><img src="<?php echo $pathImages;?>delete.png" border=0 /></a><?php
              }?>
	      </center>
	   </td>
         </tr><?php
       }?>
     </table> <?php
  }

$cnx->close();  

require_once PATHBASE.'footer.php';?>