<?php
/**
 * Actions for issue management  in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
 
if (!isset($otherFieldsInsert))
{
  $otherFieldsInsert='';
  $otherFieldsInsertValues='';
}
 
if (isset($_REQUEST['action']))
{
  switch ($_REQUEST['action'])
  {
    case 'add_issue':
      if(ini_get('magic_quotes_gpc'))
      {
	// If magic_quotes setting is on, strip the leading slashes that are automatically added to the string:
	$_POST['note-body']=stripslashes($_POST['note-body']);
      }

      // Escaping the input data:
      $probability = (int)$_POST['probability'];
      $linkedUs = (int)$_POST['linked_us'];
      $body = formatStringForDB($_POST['note-body']);
      $color = $cnx->escape_string($_POST['color']);
      $zindex = (int)$_POST['zindex'];
	  
      // Get max issue_number for the project
      $request= new sqlRequest("SELECT MAX(issue_number) AS max FROM kados_issues WHERE issue_project_id_fk=".$_SESSION['current_project_id'],$cnx->num);
      $request->getObject();
      $issueNumber=(int)$request->objet->max+1;

      // check if tranformation of risk into a problem is necessary
      if ($probability==100 && $_POST['issue_type']=='risk')
      {
        $_POST['issue_type']='problem';
 	$request->sqlGet("SELECT color FROM kados_colors_uses WHERE use_color_postit_type='PROBLEM'");
	$request->getArrayFirstFieldOnly();
	$color=$request->array[0];
      }
      
      // if link is not empty
      if ($_POST['note_link']!='')
      {    
        // Check if link has an allowed protocol
        if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$_POST['note_link']))
        {
          // then set var for the SQL request  
          $recordFieldLink=',issue_link';
          $recordFieldLinkValue=",'".$_POST['note_link']."'";
        }
        else 
        {
          // display warning message 
          $displayProtocolWarningMsg=true; 
          // empty var
          $recordFieldLink='';
          $recordFieldLinkValue='';
        }      
      }
      else
      {
        // no link to record   
        $recordFieldLink='';
        $recordFieldLinkValue='';
      }      
	  
      /* Inserting a new record in the $tableData DB: */
      $request->sqlGet("INSERT INTO ".$tableData." (issue_number,text,probability,color,".$xPosField.",".$yPosField.",".$zPosField.",status".$otherFieldsInsert.",
	                         issue_type,issue_us_id_fk,issue_creation_date,issue_creator,issue_last_update_date,issue_last_updater".$recordFieldLink.")
				   VALUES (".$issueNumber.",'".$body."','".$probability."','".$color."',".$xInitDefaultPosition.",".$yInitDefaultPosition.",".$zindex.",'NEW'".$otherFieldsInsertValues.",
				           '".$_POST['issue_type']."',".$linkedUs.",'".date('Y-m-d H:i:s')."','".$_SESSION['login']."','".date('Y-m-d H:i:s')."','".$_SESSION['login']."'".$recordFieldLinkValue.")");	  
    break;
 
    case 'update_issue':
      if(ini_get('magic_quotes_gpc'))
      {
        // If magic_quotes setting is on, strip the leading slashes that are automatically added to the string:
        $_POST['note-body']=stripslashes($_POST['note-body']);
      }

      // Escaping the input data:
      $probability = (int)$_POST['probability'];
      $linkedUs = (int)$_POST['linked_us'];
      $body = formatStringForDB($_POST['note-body']);
      $color = $cnx->escape_string($_POST['color']);

      // check if tranformation of risk into a problem is necessary
      if ($probability==100 && $_POST['issue_type']=='risk')
      {
        $_POST['issue_type']='problem';
  	$request->sqlGet("SELECT color FROM kados_colors_uses WHERE use_color_postit_type='PROBLEM'");
	$request->getArrayFirstFieldOnly();
	$color=$request->array[0];
      }
      
      // Check if link has an allowed protocol
      if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$_POST['note_link']) || $_POST['note_link']=='')
      {
        // then set var for the SQL request  
        $updateFieldLink="issue_link='".$_POST['note_link']."',";
      }
      else
      {
        // display warning message  
        $displayProtocolWarningMsg=true; 
        // empty var to keep the current value link
        $updateFieldLink='';
      }   
	  
      // request to update isseu fields
      $request= new sqlRequest("UPDATE ".$tableData." SET text='".$body."',color='".$color."',".$updateFieldLink."
	                          probability=".$probability.",issue_last_update_date='".date('Y-m-d H:i:s')."',
	 			  issue_last_updater='".$_SESSION['login']."',issue_us_id_fk=".$linkedUs." 
				WHERE ".$itemIdName."=".intval($_REQUEST['item_id']),$cnx->num);
    break; 
  }	
}	