<?php
/**
 * Actions for items management  in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
 
// init 
if (!isset($otherFieldsInsert))
{
  $otherFieldsInsert='';
  $otherFieldsInsertValues='';
}

if (!isset($otherFieldsInsertUS))
{
  $otherFieldsInsertUS='';
  $otherFieldsInsertValuesUS='';
}


// Set to nothing the field for ordering by priority. Only used for US
$fieldForPriorityOrder= isset($fieldForPriorityOrder) ? $fieldForPriorityOrder : '';
 
if (isset($_REQUEST['action']))
{
  switch ($_REQUEST['action'])
  {
    case 'del_item':
      // push item in trash  
      $request->sqlGet("UPDATE ".$tableData." SET active=-1 WHERE ".$itemIdName."=".intval($_REQUEST['item_id']));
      // add history items
      if ($simpleItemType=='us' || $simpleItemType=='task')
      {
        // create history object
        $history=new history($cnx->num);
        // status
        $history->addPostitHistory(strtoupper($simpleItemType),intval($_REQUEST['item_id']),'trash_in','', '', $_SESSION['login']);           
      }  
      // deletion of task can have impact on US
      if ($simpleItemType=='task')
      {
        // get US id
        $request->sqlGet("SELECT us_id_fk FROM ".$tableData." WHERE ".$itemIdName."=".intval($_REQUEST['item_id']));
        $request->getObject();
        // store data
        $linkedUsId=$request->objet->us_id_fk;
        // get US status
        $request->sqlGet("SELECT status FROM kados_user_stories WHERE us_id=".$linkedUsId);
        $request->getObject();
        // store data
        $oldUsStatus=$request->objet->status;
        // recompute US status with task situation
        $newUsStatus=usComputeStatus($linkedUsId,$oldUsStatus);
        // if US new status different from old one
        if ($newUsStatus!=$oldUsStatus)
        {
          // update STatus
          $request->sqlGet("UPDATE kados_user_stories SET status='".$newUsStatus."' WHERE us_id=".$linkedUsId);                   
          // add history for US status 
          $history=new history($cnx->num);
          // log history
          $history->addPostitHistory('US',$linkedUsId,'status', $oldUsStatus, $newUsStatus,$_SESSION['login']);
        }          
      }

      // deletion of action can have impact on Issue
      if ($simpleItemType=='action')
      {
        // get US id
        $request->sqlGet("SELECT issue_id_fk FROM ".$tableData." WHERE ".$itemIdName."=".intval($_REQUEST['item_id']));
        $request->getObject();
        $linkedIssueId=$request->objet->issue_id_fk;
        // get US status
        $request->sqlGet("SELECT status FROM kados_issues WHERE issue_id=".$linkedIssueId);
        $request->getObject();
        $oldIssueStatus=$request->objet->status;
        // recompute Issue status with task situation
        $request->sqlGet("SELECT COUNT(action_id) AS nb,status FROM kados_actions WHERE active=1 AND issue_id_fk=".$linkedIssueId." GROUP BY status");
        $actionsByStatus=$request->getArrayFields();        
        // use actions sitaution to compute issue status
        if (count($actionsByStatus)==0)
        {
          // update STatus
          $request->sqlGet("UPDATE kados_issues SET status='NEW' WHERE issue_id=".$linkedIssueId);                   
        }
        else if(count($actionsByStatus)>1) 
        {    
          // update STatus
          $request->sqlGet("UPDATE kados_issues SET status='PROG' WHERE issue_id=".$linkedIssueId);                   
        }          
        else if (count($actionsByStatus)==1 && $actionsByStatus[0]['status']==$boardFinalStatusTag)
        {
          // update STatus
          $request->sqlGet("UPDATE kados_issues SET status='2CHK' WHERE issue_id=".$linkedIssueId);                   
        }
      }
      
      // if it is a task in a sprint, update roadmap  
      if (isset($_SESSION['current_sprint_id']))
      {
        // set current sprint from session  
        $currentSprintId=$_SESSION['current_sprint_id'];
        // record sprint progress
        require_once PATHBASE.'progress_recording.php';	  
      }	
    break;
	
    case 'order_all_by_number_desc':
      $sortingType=' DESC';
    case 'order_all_by_number':
      // order items by numbers  
      $fieldForOrder=$fieldForSorting;  
    case 'order_all_compact':
      $_SESSION['dashboard_display_mode']='compact';
      // compute available space for shifting item on the left before stepping over the column limit
      $availableSpaceForItemXShift=$columnWidth-$itemWidth-5-$xInitDefaultPosition;
      // init column name (that is to say field that is managed in the board) to start comparison in the items list below
      $columnTmp='no_value';
      // set reference y position if not set
      $yposRef=isset($_REQUEST['ypos_ref']) ? $_REQUEST['ypos_ref'] : 45;
      $altRef=0;
      // get all items
      $request= new sqlRequest("SELECT ".$itemIdName.",".$managedField.",".$zPosField." AS zindex 
                             FROM ".$tableData." 
                             WHERE active=1 ".$clauseWhereElements."
	   	             ORDER BY ".$managedField.",".$fieldForOrder." ".(isset($sortingType)? $sortingType : 'ASC'),$cnx->num);
      $resultArray=$request->getArrayFields();
      // init z position var
      $zposNew=1;

      // if column is wide enough to reorder items with a right shift after each item
      if ($availableSpaceForItemXShift>20)
      {
	for ($i=0;$i<count($resultArray);$i++)
        {
          // if working on a new column (since items are ordered by column, we can use that algo
	  if ($columnTmp!=$resultArray[$i][$managedField])
	  {
            // reinit ypos  
  	    $ypos=$yposRef;
            // update status var (in fact column)
	    $columnTmp=$resultArray[$i][$managedField];
            // reinit shift value
	    $alt=$altRef;
	  }
          // update item in database
          $request->sqlGet("UPDATE ".$tableData." 
                           SET ".$xPosField."=".($xInitDefaultPosition+$alt).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." 
                           WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
          // shift y position
  	  $ypos+=$itemYShift;
          // shift x position
	  $alt+=7;
          // if the x shift does not allow the next item to be in the column
          // reinit the x position at the beginning of the column
	  if ($alt-$altRef>$availableSpaceForItemXShift)
	  {
	    $alt=0;
	    $ypos+=$itemHeight-35;
  	  }
	}  
      }
      else
      {
        // column is not wide enough to shift items while setting y position for each
        // just display item one after another without shifting x position  
        for ($i=0;$i<count($resultArray);$i++)
        {
          // if working on a new column (since items are ordered by column, we can use that algo            
          if ($columnTmp!=$resultArray[$i][$managedField])
	  {
            // reinit y position  
	    $ypos=$yposRef;
            // update status var (in fact column)
	    $columnTmp=$resultArray[$i][$managedField];
	  }
          // update item in database
          $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
          // shift y position
	  $ypos+=$itemYShift;
	}	  
      }
    break;

    case 'order_all_extended':
      $_SESSION['dashboard_display_mode']='extended';
      // compute available space for putting extra "columns"
      $columnsOfPostit=floor($columnWidth/($itemWidth+10));
      // init column name (that is to say field that is managed in the board) to start comparison in the items list below      
      $columnTmp='no_value';
      $yposRef=isset($_REQUEST['ypos_ref']) ? $_REQUEST['ypos_ref'] : 45;
      // get all items
      $request= new sqlRequest("SELECT ".$itemIdName.",".$managedField.",".$zPosField." AS zindex 
                             FROM ".$tableData." 
                             WHERE active=1 ".$clauseWhereElements."
	                     ORDER BY ".$managedField.",".$fieldForOrder." ASC",$cnx->num);
      $resultArray=$request->getArrayFields();
	  
      $zposNew=1;
      $xCol=0;
      for ($i=0;$i<count($resultArray);$i++)
      {
	if ($columnTmp!=$resultArray[$i][$managedField])
	{
	  $ypos=$yposRef;
	  $columnTmp=$resultArray[$i][$managedField];
	  $xCol=0;
	}
        $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition+($itemWidth+10)*$xCol++).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
	if ($xCol==$columnsOfPostit)
	{
	  $ypos+=$itemHeight+25;
	  $xCol=0;
	}  
      }
    break;	

    case 'order_all_priority':
      $_SESSION['dashboard_display_mode']='priority';
      $_SESSION['display_priority']='block';
      // compute available space for putting extra "columns"
      $columnsOfPostit=floor($columnWidth/($itemWidth+10));
      $status='no_value';
      $yposRef=isset($_REQUEST['ypos_ref']) ? $_REQUEST['ypos_ref'] : 45;
      // get all items
      $request= new sqlRequest("SELECT ".$itemIdName.",".$managedField.",".$zPosField." AS zindex 
                             FROM ".$tableData." 
                             WHERE active=1 ".$clauseWhereElements."
			     ORDER BY ".$managedField.",".$fieldForPriorityOrder,$cnx->num);
      $resultArray=$request->getArrayFields();
	  
      $zposNew=1;	  
      $xCol=0;
      for ($i=0;$i<count($resultArray);$i++)
      {
	if ($status!=$resultArray[$i][$managedField])
	{
	  $ypos=$yposRef;
	  $status=$resultArray[$i][$managedField];
	  $xCol=0;
	}
        $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition+($itemWidth+10)*$xCol++).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
	if ($xCol==$columnsOfPostit)
	{
	  $ypos+=$itemHeight+10;
	  $xCol=0;
	}  
      }
    break;	
    
    case 'order_all_business_value':
    case 'order_all_business_value_desc':
    case 'order_all_complexity_desc':
    case 'order_all_complexity':
      $filterAction['order_all_business_value']='business_value ASC';
      $filterAction['order_all_business_value_desc']='business_value DESC';
      $filterAction['order_all_complexity']='complexity ASC';
      $filterAction['order_all_complexity_desc']='complexity DESC';
      $_SESSION['dashboard_display_mode']='extended';  
      // compute available space for putting extra "columns"
      $columnsOfPostit=floor($columnWidth/($itemWidth+10));
      $status='no_value';
      $yposRef=isset($_REQUEST['ypos_ref']) ? $_REQUEST['ypos_ref'] : 45;
      // get all items
      $request= new sqlRequest("SELECT ".$itemIdName.",".$managedField.",".$zPosField." AS zindex 
                             FROM ".$tableData." 
                             WHERE active=1 ".$clauseWhereElements."
			     ORDER BY ".$managedField.",".$filterAction[$_REQUEST['action']],$cnx->num);
      $resultArray=$request->getArrayFields();
	  
      $zposNew=1;	  
      $xCol=0;
      for ($i=0;$i<count($resultArray);$i++)
      {
	if ($status!=$resultArray[$i][$managedField])
	{
	  $ypos=$yposRef;
	  $status=$resultArray[$i][$managedField];
	  $xCol=0;
	}
        $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition+($itemWidth+10)*$xCol++).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
	if ($xCol==$columnsOfPostit)
	{
	  $ypos+=$itemHeight+10;
	  $xCol=0;
	}  
      }
    break;    

    case 'us_status_change':
      // get US status
      $request->sqlGet("SELECT status 
                        FROM kados_user_stories 
                        WHERE us_id=".$_REQUEST['us_id']);        
      $request->getObject();
      $realStatus=$request->objet->status;
      // Change in US status  
      $setDateClause='';
      // if status is done, the date must be set as finished
      if (strtoupper($_REQUEST['new_status'])=='DONE')  
      {
        $setDateClause=",us_date_finished=DATE('".date('Y-m-d H:i:s')."')";
      }
      // SQL update for US
      $request->sqlGet("UPDATE kados_user_stories 
	               SET status='".strtoupper($_REQUEST['new_status'])."'".$setDateClause." 
	               WHERE us_id=".$_REQUEST['us_id']);
      // add history for parent US
      $historyObject=new history($cnx->num);
      $historyObject->addPostitHistory('US',$_REQUEST['us_id'],'status',$realStatus,strtoupper($_REQUEST['new_status']), $_SESSION['login']);      
      // update roadmap
      include PATHBASE.'progress_log.php';  
    break;

    case 'issue_status_change':
      // update status for an issue
      $request->sqlGet("UPDATE kados_issues 
	               SET status='".strtoupper($_REQUEST['new_status'])."' 
	               WHERE issue_id=".$_REQUEST['issue_id']); 
    break;

    case 'assign':
      // get previous task leader
      $request= new sqlRequest("SELECT ".$fieldLeader." 
                                FROM ".$tableData." 
                                WHERE ".$itemIdName."=".intval($_REQUEST['item_id']),$cnx->num);
      $request->getArrayFirstFieldOnly();  
      if ($request->array[0]!=$_REQUEST['username'])
      {
        // assign task to an user    
        $request->sqlGet("UPDATE ".$tableData." 
  	                  SET ".$fieldLeader."='".$_REQUEST['username']."' 
                          WHERE ".$itemIdName."=".intval($_REQUEST['item_id']));
        // log an history item
        $historyObject=new history($cnx->num);
        $historyObject->addPostitHistory(strtoupper($simpleItemType),intval($_REQUEST['item_id']),'task_leader',$request->array[0],$_REQUEST['username'], $_SESSION['login']);
      }  
    break;    
    
    case 'add_tag':
      // add tag to a postit  
      // create object tag
      $tagAdd=new tag($cnx->num);        
      // add tag
      $tagAdd->addToPostit(intval($_REQUEST['item_id']),$_REQUEST['tag2add_id'],strtoupper($simpleItemType));
      // log an history item
      $historyObject=new history($cnx->num);
      $historyObject->addPostitHistory(strtoupper($simpleItemType),intval($_REQUEST['item_id']),'add_tag','',$_REQUEST['tag2add_id'], $_SESSION['login']);
    break;
	
    case 'remove_tag':
      // remove tag from a postit  
      // create object tag
      $tagAdd=new tag($cnx->num);        
      // remove tag
      $tagAdd->removeFromPostit(intval($_REQUEST['item_id']),$_REQUEST['tag2remove_id'],strtoupper($simpleItemType));        
      // log an history item
      $historyObject=new history($cnx->num);
      $historyObject->addPostitHistory(strtoupper($simpleItemType),intval($_REQUEST['item_id']),'remove_tag',$_REQUEST['tag2remove_id'],'', $_SESSION['login']);
    break;
	
    case 'order_all_tasks_by_number':
      $fieldForOrder=$fieldForSorting;  
    case 'order_all_tasks_compact':
      if ($_REQUEST['tasks2order']!='')  
      {     
        // init array for list of tasks  
        $usToOrder=array();
        // get list of ID tasks from URI
        $usToOrder=explode('_',$_REQUEST['tasks2order']);
            
        // for each task
        for ($nbUs=0;$nbUs<count($usToOrder);$nbUs++)
        {
          // set var with task ID  
          $_REQUEST['object_id']=$usToOrder[$nbUs];
          // get tasks settings
          // that allows to have var used in the SQL request 
          include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
          // set mode to compact
          $_SESSION['dashboard_display_mode']='compact';
	  // compute available space for shifting item on the left before stepping over the column limit
	  $availableSpaceForItemXShift=$columnWidth-$itemWidth-5-$xInitDefaultPosition;
          // init vars
          $status='no_value';
  	  $yposRef=isset($_REQUEST['ypos_ref']) ? $_REQUEST['ypos_ref'] : 45;
	  $altRef=0;
          // get all items
	  $request= new sqlRequest("SELECT ".$itemIdName.",".$managedField.",".$zPosField." AS zindex 
	                            FROM ".$tableData." 
                                    WHERE active=1 ".$clauseWhereElements."
	                            ORDER BY ".$managedField.",".$fieldForOrder." ASC",$cnx->num);
          $resultArray=$request->getArrayFields();
          $zposNew=1;
	  
          // if there is enough space in the column
	  if ($availableSpaceForItemXShift>20)
	  {
            // reorder all tasks
	    for ($i=0;$i<count($resultArray);$i++)
            {
	      if ($status!=$resultArray[$i][$managedField])
	      {
  	        $ypos=$yposRef;
		$status=$resultArray[$i][$managedField];
		$alt=$altRef;
	      }
              $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition+$alt).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
    	      $ypos+=$itemYShift;
	      $alt+=7;
	      if ($alt-$altRef>$availableSpaceForItemXShift)
	      {
		$alt=0;
		$ypos+=$itemHeight-35;
  	      }
	    }  
	  }
	  else
	  {
            // if there is not enough space in the column to x-shift 
            // postits 
  	    for ($i=0;$i<count($resultArray);$i++)
            {
              // set postit just with an y-shift  
	      if ($status!=$resultArray[$i][$managedField])
	      {
  	        $ypos=$yposRef;
		$status=$resultArray[$i][$managedField];
              }
              // update the task
              $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
   	      $ypos+=$itemYShift;
            }
	  }
        }  
      }
    break;	

    case 'order_all_tasks_extended':
      if ($_REQUEST['tasks2order']!='')  
      {    
        $usToOrder=array();
        $usToOrder=explode('_',$_REQUEST['tasks2order']);
            
        for ($nbUs=0;$nbUs<count($usToOrder);$nbUs++)
        {
          $_REQUEST['object_id']=$usToOrder[$nbUs];
          include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
          // set session var to extended
          $_SESSION['dashboard_display_mode']='extended';
	  // compute available space for putting extra "columns"
	  $columnsOfPostit=floor($columnWidth/($itemWidth+10));
          $status='no_value';
	  $yposRef=isset($_REQUEST['ypos_ref']) ? $_REQUEST['ypos_ref'] : 45;
          // get all items
	  $request= new sqlRequest("SELECT ".$itemIdName.",".$managedField.",".$zPosField." AS zindex 
	                            FROM ".$tableData." 
                                    WHERE active=1 ".$clauseWhereElements."
		                    ORDER BY ".$managedField.",".$fieldForOrder." ASC",$cnx->num);
          $resultArray=$request->getArrayFields();
	  
          $zposNew=1;
	  $xCol=0;
          for ($i=0;$i<count($resultArray);$i++)
          {
	    if ($status!=$resultArray[$i][$managedField])
	    {
	      $ypos=$yposRef;
	      $status=$resultArray[$i][$managedField];
	      $xCol=0;
            }
            $request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".($xInitDefaultPosition+($itemWidth+10)*$xCol++).",".$yPosField."=".$ypos.",".$zPosField."=".$zposNew++." WHERE ".$itemIdName."=".$resultArray[$i][$itemIdName]);	  
	    if ($xCol==$columnsOfPostit)
	    {
	      $ypos+=$itemHeight+25;
	      $xCol=0;
	    }  
	  }
        }  
      }
    break;	        
        
    case 'filter_feature':
      if ($_REQUEST['filter_feature']=='')  
      {
        unset($_SESSION['feature_filter']);
      }
      else
      {
        $_SESSION['feature_filter']=$_REQUEST['filter_feature'];
      }  
    break;
    
    case 'filter_us_status':
      if (!isset($_REQUEST['filter_us_status']))  
      {
        unset($_SESSION['us_status_filter']);
      }
      else
      {
        $_SESSION['us_status_filter']=true;
      }  
    break;    
    
    case 'filter_stakeholder':
      if ($_REQUEST['filter_stakeholder']=='')  
      {
        unset($_SESSION['stakeholder_filter']);
      }
      else
      {
        $_SESSION['stakeholder_filter']=$_REQUEST['filter_stakeholder'];
      }  
    break;    
    
    case 'filter_search_text_us':
      if ($_REQUEST['filter_search_text_us']=='')  
      {
        unset($_SESSION['search_text_filter_us']);
      }
      else
      {
        $_SESSION['search_text_filter_us']=$_REQUEST['filter_search_text_us'];
      }  
    break;       
    
    case 'filter_search_text_task':
      if ($_REQUEST['filter_search_text_task']=='')  
      {
        unset($_SESSION['search_text_filter_task']);
      }
      else
      {
        $_SESSION['search_text_filter_task']=$_REQUEST['filter_search_text_task'];
      }  
    break;    

    case 'filter_add_to_tag_plus':
      // if array type is minus or plus (protection on session arrays)
      // if not in the session array  
      if (array_search((int)$_POST['add_to_tag_filter'],$_SESSION['tag_filter_plus_'.$_POST['tag_filter_item']])==false)
      {
        // push it into the array  
        array_push($_SESSION['tag_filter_plus_'.$_POST['tag_filter_item']],(int)$_POST['add_to_tag_filter']);
        // If tag is in the other array, get it out
        // get position in array
        $pos=array_search((int)$_POST['add_to_tag_filter'],$_SESSION['tag_filter_minus_'.$_POST['tag_filter_item']]);
        // if exists
        if ($pos>0)
        {
          // delete it from the other array  
          unset($_SESSION['tag_filter_minus_'.$_POST['tag_filter_item']][$pos]);
        }
      }  
    break;
    
    case 'filter_add_to_tag_minus':
      // if array type is minus or plus (protection on session arrays)
      // if not in the session array  
      if (array_search((int)$_POST['add_to_tag_filter'],$_SESSION['tag_filter_minus_'.$_POST['tag_filter_item']])==false)
      {
        // push it into the array  
        array_push($_SESSION['tag_filter_minus_'.$_POST['tag_filter_item']],(int)$_POST['add_to_tag_filter']);
        // If tag is in the other array, get it out
        // get position in array
        $pos=array_search((int)$_POST['add_to_tag_filter'],$_SESSION['tag_filter_plus_'.$_POST['tag_filter_item']]);
        // if exists
        if ($pos>0)
        {
          // delete it from the other array  
          unset($_SESSION['tag_filter_plus_'.$_POST['tag_filter_item']][$pos]);
        }
      }        
    break;
  }
}
  // Remove from TAG FILTER
  if (isset($_GET['remove_from_tag_filter']))
  {
    // if array type is minus or plus (protection on session arrays)  
    if (in_array($_GET['filter_type'],array('minus','plus')))
    {
      // get position of value  
      $pos=array_search((int)$_GET['remove_from_tag_filter'],$_SESSION['tag_filter_'.$_GET['filter_type'].'_'.$_GET['tag_filter_item']]);
      // if exists
      if ($pos>0)
      {
        // delete it form array
        unset($_SESSION['tag_filter_'.$_GET['filter_type'].'_'.$_GET['tag_filter_item']][$pos]);
      }	
    }  
  }
?>