<?php
/**
 * Form (popin) to add an item in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */    
define("PATHBASE",'../');
$pathClasses=PATHBASE.'libraries/classes/';
$pathImages=PATHBASE.'images/';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{
  // include block of classes, functions, and files useful for popin forms
  require_once PATHBASE.'popin_includes.php';
  // get bootstrap to securise use of $_REQUEST var
  require_once PATHBASE.'boards_settings/settings_bootstrap.php';?>

<h3 class="popupTitle"><?php echo $legend_creation_f.' '.lcfirst($text_action);?></h3>

<?php 
// choice color is called, then default color can be set for the preview
// no problem to include the choice color since, its position is absolute
include PATHBASE.'note_color_choice.php';?>
<!-- The preview: -->
<div id="previewNote" class="note <?php echo $defaultColor;?>" style="width:<?php echo $itemWidth;?>px;height:<?php echo $itemHeight;?>px;left:0;top:45px;z-index:1">
	    <div class="item-header">
		  <span class="task_load"></span>
		</div>
	<div class="text_body" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"></div>
	<div class="item-footer">
	  <span class="load_spent"></span>
	  <span class="load2finish"></span>
  </div>		
</div>

<div id="noteData" style="margin-left:<?php echo ($itemWidth+30);?>px;"> <!-- Holds the form -->
<form class="pure-form pure-form-aligned" action="<?php echo $targetFileAction;?><?php echo (isset($_REQUEST['blockId']) ? '&a='.md5(time()).'#Block'.$_REQUEST['blockId'] : '');?>" method="post" enctype="multipart/form-data" name="form_action">
<input type="hidden" name="action" value="add_action" />
<?php
  if ($addHiddenInput)
  {?>
    <input type="hidden" name="object_id" value="<?php echo $_REQUEST['object_id'];?>" /><?php
  }?>
<label class="label required_field"><?php echo $text_action;?></label>
<textarea name="note-body" id="note-body" class="pr-text_body"  cols="40" rows="4"></textarea>
<div class="clearleft"></div>
<label class="label"><?php echo $text_task_load;?></label>
<input type="text" name="note-task_load" id="note-task_load" class="pr-task_load" size="5" maxlength="5" value="" /> <?php echo lcfirst($text_hours);?>
<div class="clearleft"></div>
<label class="label"><?php echo $text_link;?></label>
<input id="note-link" type="text" size="43" name="note_link" value="">
<div class="clearleft"></div>

<input class="colorname" type="hidden" name="color" value="<?php echo $defaultColor;?>" />
<input class="zindexvalue" type="hidden" name="zindex" value="" />
<br />
<?php 
 displayButton($button_submit,'','','action-submit tsc_awb_medium tsc_awb_green tsc_flat');	?>

</form>
</div><?php
}
else
{
  require_once $pathCommons.'functions.php';  ?>
  <script>
    window.location.replace('<?php echo getServerURL();?>/../index.php?warning_message=SESSION_END');
  </script>   <?php
}