<?php
/**
 * Form (popin) to add an item in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */    
define("PATHBASE",'../');
$pathClasses=PATHBASE.'libraries/classes/';
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{
  // include block of classes, functions, and files useful for popin forms
  require_once PATHBASE.'popin_includes.php';
  require_once $pathAppClasses.'project.php';
  // settings need the level of current project
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
  $currentProject->getData();  
  // get bootstrap to securise use of $_REQUEST var
  require_once PATHBASE.'boards_settings/settings_bootstrap.php';

  // Get US number
  $request=new sqlRequest("SELECT us_number 
                           FROM kados_user_stories 
	                   WHERE us_id=".$_REQUEST['object_id'],$cnx->num);
  $request->getObject();?>

<h3 class="popupTitle"><?php echo $legend_creation_f.' '.lcfirst($text_task).' '.$text_for.' US'.$request->objet->us_number;?></h3>
<style>
.chosen-container .chosen-results {
    position: fixed;
    z-index: 23423423423;
    height: 200px;
    width: 300px;
    background-color: white;
    border:solid 1px lightgrey; 
}
</style>
<?php 
// choice color is called, then default color can be set for the preview
// no problem to include the choice color since, its position is absolute
include PATHBASE.'note_color_choice.php';?>
<!-- The preview: -->
<div id="previewNote" class="note <?php echo $defaultColor;?>" style="width:<?php echo $itemWidth;?>px;height:<?php echo $itemHeight;?>px;left:0;top:45px;z-index:1">
	    <div class="item-header">
		  <span class="task_load"></span>
		</div>
	<div class="text_body" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"></div>
	<div class="item-footer">
	  <span class="load_spent"></span>
	  <span class="load2finish"></span>
  </div>		
</div>

<div id="noteData" style="margin-left:<?php echo ($itemWidth+30);?>px;"> <!-- Holds the form -->
<form class="pure-form pure-form-aligned" action="<?php echo $targetFileAction;?><?php echo (isset($_REQUEST['blockId']) ? '&a='.md5(time()).'#Block'.$_REQUEST['blockId'] : '');?>" enctype="multipart/form-data" method="post" name="form_task">
<input type="hidden" name="action" value="add_task" />
<?php
  if ($addHiddenInput)
  {?>
    <input type="hidden" name="object_id" value="<?php echo $_REQUEST['object_id'];?>" /><?php
  }?>
<label class="label required_field"><?php echo $text_task;?></label>
<textarea name="note-body" id="note-body" class="pr-text_body"  cols="40" rows="4"></textarea>
<div class="clearleft"></div>
<?php
if ($currentProject->paramUseTags)
{?>
<div id="selectDiv">
  <select name="linkedTags[]" data-placeholder="<?php TextDisplay($text_choose_tag);?>" multiple class="chosen-select" tabindex="5" id="tag_for_us">
           <option value="0"></option>
      
  </select></div><div class="clearleft"></div>	 <?php
}?>         
<label  class="label"><?php echo $text_task_load;?></label>
<input type="text" name="note-task_load" id="note-task_load" class="pr-task_load" size="5" maxlength="5" value="" /> <?php echo lcfirst($text_hours);?>
<div class="clearleft"></div>
<label  class="label"><?php echo $text_link;?></label>
<input id="note-link" type="text" size="43" name="note_link" value="">
<div class="clearleft"></div>

<input class="colorname" type="hidden" name="color" value="<?php echo $defaultColor;?>" />
<input class="zindexvalue" type="hidden" name="zindex" value="" /><?php

require PATHBASE.'postit_attachments_create.php';?>

<br />
<?php 
 displayButton($button_submit,'','','task-submit tsc_awb_medium tsc_awb_green tsc_flat');	?>

</form>
 <?php
if ($currentProject->paramUseTags)
{?>
    <script>
        // update tags when there is a change in color = change posit type
        $('.color').live('click',function(){
          // get tag and group ids
          $.post('../xmlhttprequest/get_tags_for_color_project.php',{item_type :'TASK',color:($(this).attr('class').replace('color','')).trim()},function(msg){
	    if(msg!='')
	    {
              var arrayList = jQuery.parseJSON(msg);
              var selectList = '<select name="linkedTags[]" data-placeholder="<?php TextDisplay($text_choose_tag);?>" multiple class="chosen-select" tabindex="5" id="tag_for_us">';
              var optgroup=0;
              for (var x = 0; x < arrayList.length; x++) 
              {
                if (optgroup!=parseInt(arrayList[x]['tag_group_id_fk']))
                {
                  selectList += '<optgroup label="'+arrayList[x]['tag_group_name']+'">'; 
                  optgroup=parseInt(arrayList[x]['tag_group_id_fk']);                        
                }
                selectList += '<option groupid="'+arrayList[x]['tag_group_id_fk']+'" value="'+arrayList[x]['tag_id']+'">' + arrayList[x]['tag_label'] + '</option>';
              }
              selectList += "</select>";
              $('#selectDiv').html(selectList);         
              // create chosen select
              $(".chosen-select").chosen({width: "99%"}); 
              // set change actions on chosen select    
              $(".chosen-select").on('change', function (evt,params) 
              {
                if (params.selected) {
                  var group = $(this).find("option[value='" + params.selected + "']").attr("groupid");
                  if (group!=0)
                  {
                    $(this).find('option').each(function(k, i) { 
                      if ( $(i).val()!= params.selected && $(i).attr("groupid")==group)
                      {
                        $(i).prop('disabled', true);
                      }   
                    });
                  }
                }
                else if (params.deselected) 
                {
                  var group = $(this).find("option[value='" + params.deselected + "']").attr("groupid");
                  if (group!=0)
                  {
                    $(this).find('option').each(function(k, i) { 
                      if ( $(i).attr("groupid")==group)
                      {
                        $(i).prop('disabled', false);
                      }
                    });  
                  }
                }
                // update chosen select
                $('.chosen-select').trigger("chosen:updated");
              });                     
            }
          });
        });     
     
        // trigger for default color
        $( "#id_<?php echo $defaultColor;?>" ).trigger( "click" );
    </script><?php
    }?>    
    
</div><?php
}
else
{
  require_once $pathCommons.'functions.php';  ?>
  <script>
    window.location.replace('<?php echo getServerURL();?>/../index.php?warning_message=SESSION_END');
  </script>   <?php
}