<?php
/**
 * Main script to manage items in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */

// init table for adding table in postit request with left join
if (!isset($tableDataLeftJoin))
{
  $tableDataLeftJoin='';
}

// init array for users of th eproject
if (!isset($projectUsers))
{
  $projectUsers=array();  
}

// switch picture and tag for managing trash button on postit 
// go to trash or complete delete
if (!isset($deleteMode))
{
  $pictureTrash='app/trash.png';
  $deleteModeInt='trash';
}
else
{
  $pictureTrash='app/delete.png';  
  $deleteModeInt='del';
}

// init var
$displayNoUser = isset($displayNoUser) ? $displayNoUser : false;
?>

<div class="main" style="height:<?php echo $dashboardHeight;?>px;width:<?php echo $dashboardWidth;?>px;<?php if (isset($invisibleColumnsArray)) {echo 'margin-top:16px;';}?>"><?php
 $keys=array_keys($arrayStatusX);
 // display columns based on the specific array
 for ($i=0;$i<count($arrayStatus);$i++)
 {
   // open column  ?>     
   <span class="col2Do<?php echo ($i==0 ? 'First' :'');?>" style="width:<?php echo ($columnWidth-1);?>px;height:<?php echo $dashboardHeight;?>px"><?php  
   if ($displayDashBoardTitles)
   {?>
     <span class="colHeader" style="width:<?php echo ($columnWidth-1);?>px"><?php 
      if (isset($arrayStatus[$i]['link']))
	  {?>
	    <a href="<?php echo $arrayStatus[$i]['link'];?>"><?php echo $arrayStatus[$i]['colName'];?></a><?php
	  }
	  else
	  {
 	    echo $arrayStatus[$i]['colName'];
	  }	
	  if (isset($arrayStatus[$i]['colMeaning']))
	  {?>
	    <span class="colMeaning">
	      <img src="<?php echo $pathImages;?>app/infos.png" tooltip="<?php echo changeDoubleQuote($arrayStatus[$i]['colMeaning']);?>" />
		</span><?php
	  }?>
     </span>
   <span class="hidden-status"><?php echo $keys[$i].':'.$arrayStatusX[$keys[$i]];?></span> <?php
   }
   // if there is invisible columns, show a marker  
   if (isset($invisibleColumnsArray))
   {
     if($allowShowHideColumns)
     {
       // display   
       if ($i!=0)
       {?>
         <span class="hide-button"><a href="<?php echo $targetFile.$arrayStatus[$i]['link2hide'];?>"><img src="<?php echo $pathImages;?>hide.png" border="0"  /></a></span><?php
       }  
       if (in_array($i+1,array_column($invisibleColumnsArray,'column_position')))
       { 
         // reinit $keysToUse  
         if (isset($keysToUse)) {unset($keysToUse); }  
         // get keys
         $keysToUse=array_keys(array_column($invisibleColumnsArray,'column_position'),$i+1);  ?>
        <span class="hidden-column"><img src="<?php echo $pathImages;?>app/hidden.png" />
          <span class="column-list">
              <table><?php
               for($k=0;$k<count($keysToUse);$k++)
               {?>
                 <tr><td><a href="<?php echo $targetFile;?>&action=show_in_kanban&<?php echo $invisibleColumnsArray[$keysToUse[$k]]['column_type'];?>2show=<?php echo $invisibleColumnsArray[$keysToUse[$k]]['column_id'];?>" ><img src="<?php echo $pathImages;?>show.png" border="0" /></a></td><td><?php echo $invisibleColumnsArray[$keysToUse[$k]]['column_name'];?></td></tr><?php
               }?>
              </table>  
          </span>
        </span>    <?php
       }
     }
   }  ?>
   </span><?php
 }

if (!isset($specialClause))
{
  $specialClause='';
}

// request for getting postit for dashboard
$request=new sqlRequest("SELECT ".$fieldsList." 
                      FROM ".$tableData." ".$tableDataLeftJoin." 
                      WHERE active=1 ".$clauseWhereElementsGetAllStd.$specialClause." 
                      ORDER BY ".$zPosField." ASC",$cnx->num);
$resultArray=$request->getArrayFields();

// Build array with item ID
$itemIdsList=array_column($resultArray,$itemIdName);
array_unshift($itemIdsList,0);

$parentIdsList=array_column($resultArray,$parentRefId);
array_unshift($parentIdsList,0);
// Position de base pour la priorit en superposition
$posOver=2;
// Ajout de paramtre(s) pour le lien de mise  jour d'un postit
if (!isset($updateParameter))
{
  $updateParameter='';
}

// init user object
$userObject=new appUser($cnx->num,$_SESSION['login']);

/************************ TAGS ***************************************/
$projectTagsList=array();
if ($currentProject->paramUseTags)
{
  // get tags for the project
  $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
  $wkf->set_profile('framework_workflows_transitions_profiles','profile_id_fk',$_SESSION['user_profile']);

  $request->sqlGet("(SELECT tag_id,tag_label,tag_group_id_fk 
                    FROM kados_tags,kados_tags_projects 
		    WHERE tag_id_fk=tag_id 
		      AND project_id_fk=".$_SESSION['current_project_id']."
		      AND tag_type IN('USR_FREE','ALL_FREE') 
                      AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')." 
                      AND LOWER(tag_postit_type)='".$simpleItemType."')
		   UNION 
                   (SELECT tag_id,tag_label,tag_group_id_fk 
                    FROM kados_tags
		    WHERE tag_type='ALL_MAND' 
                      AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')." 
                      AND LOWER(tag_postit_type)='".$simpleItemType."')
		    ORDER BY tag_label");
  $projectTagsList=$request->getArrayFields();
  // get ID of tags
  $listTagsIds=array();
  for ($i=0;$i<count($projectTagsList);$i++)
  {
    $listTagsIds[$i]=$projectTagsList[$i]['tag_id'];
  }
  // compute which tag is allowed for which postit color
  $listAllowedTagsByPostit=array();
  // get matrix for tag and postit
  $request->sqlGet("SELECT tag_id_fk,group_concat(color separator ':') 
                    FROM kados_tags_allocations,kados_colors_uses,kados_tags  
                    WHERE use_color_id=color_use_id_fk 
                      AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')."
                      AND tag_id_fk=tag_id 
                    GROUP BY tag_id_fk ");  
  $listTagsWithAllocations=$request->getArrayFieldsOneField();
  
  // get allowed tags for each postit
  for ($i=0;$i<count($colorList);$i++)
  {
    $listAllowedTagsByPostit[$colorList[$i]['color_name']]=$listTagsIds;    
    // for each tag that has allocations, test if the color is in allocation or not
    // tags without allocations are available for sure.
    foreach($listTagsWithAllocations  as $tagId => $tagAllocations)
    {
      // find if color is not in the tag allocations => meaning the tag must be hidden for that color
      if(strpos('_'.$tagAllocations,$colorList[$i]['color_name'])===false)  
      {
        // find which key has the tag id
        $res=array_search($tagId,$listTagsIds);
        // if key exists
        if (!($res===false))
        {
          // remove it from  the list
          unset($listAllowedTagsByPostit[$colorList[$i]['color_name']][$res]);
        }  
      }
    }
    // reinit pointer on list
    reset($listTagsWithAllocations);
  }
  
  // get Tags for the postits
  $request->sqlGet("SELECT postit_id_fk,tag_id,tag_label,tag_color,tag_group_id_fk
                    FROM kados_tags,kados_tags_postit
                    WHERE tag_id_fk=tag_id AND postit_id_fk IN(".implode(',',$itemIdsList).")
	  	      AND postit_type='".strtoupper($simpleItemType)."'");  
  $postitTagsAllItemsList=$request->getArrayFieldsGroup('postit_id_fk');
  
}
/************************ END OF TAGS ****************************************/

/************************ WRANING and PARENTS ZONES **************************/
  // display link between issue and US if exists	
  if ($simpleItemType=='us')
  {
    if ($displayWarningZone)
    {
      // Warning zone may be activated if link with issues
      $request->sqlGet("SELECT issue_us_id_fk,issue_type,impact,issue_number,probability,text,issue_id,status 
                       FROM kados_issues 
		       WHERE active=1 AND issue_us_id_fk IN(".implode(',',$itemIdsList).")");
      $warningZoneDataAllItems=$request->getArrayFieldsGroup('issue_us_id_fk');
    }	
		  
    if ($displayParentZone)
    {
      // Parent zone may be activated if link with an US
      $request->sqlGet("SELECT us_id,feature_short_label,feature_description,feature_name 
                      FROM kados_features,kados_user_stories 
	              WHERE feature_id=us_feature_id_fk 
                        AND active=1 AND us_id IN(".implode(',',$itemIdsList).")");
      $parentZoneDataAllItems=$request->getArrayFieldsGroup('us_id');
    }	
  }
  else if ($simpleItemType=='issue')
  {
    if ($displayParentZone)
    {
      // Parent zone may be activated if link with an US
      $request->sqlGet("SELECT issue_id,us_number,us_id,kados_user_stories.status,
                               business_value,kados_user_stories.text,issue_type  
                       FROM kados_user_stories,kados_issues 
                       WHERE kados_user_stories.active=1 
                         AND kados_issues.active=1 
                         AND us_id=issue_us_id_fk 
                         AND issue_id IN(".implode(',',$itemIdsList).")");
      $parentZoneDataAllItems=$request->getArrayFieldsGroup('issue_id');
    }	
  }		
  else if ($simpleItemType=='task')
  {
    if ($displayParentZone)
    {
      // Parent zone may be activated if link with an US
      $request->sqlGet("SELECT us_number,us_id,status,business_value,text 
                       FROM kados_user_stories 
                       WHERE active=1 AND us_id IN(".implode(',',$parentIdsList).")");
      $parentZoneDataAllItems=$request->getArrayFieldsGroup('us_id');
    }	
  }
  
/************** END od WARNING and PARENTS ZONES *****************************/

/*************************** COMMENTS ZONE ***********************************/  
// count new comments  
      $request->sqlGet("SELECT COUNT(*) as nbItem,postit_comment_postit_id_fk
                        FROM kados_postit_comments
                        WHERE postit_comment_postit_id_fk IN(".implode(',',$itemIdsList).") 
                          AND postit_comment_postit_type='".strtoupper($simpleItemType)."' 
                          AND postit_comment_user_login_fk!='".$_SESSION['login']."' 
                          AND postit_comment_date>'".$userObject->getUserPreviousLoginDate()."'
                        GROUP BY postit_comment_postit_id_fk");
      $commentCountAllItems=$request->getArrayFieldsPivot('postit_comment_postit_id_fk'); 

      // get number of comment with a wave for the current user and more recent than the connection time
      $request->sqlGet("SELECT COUNT(*) as nbItem,postit_comment_postit_id_fk
                        FROM kados_postit_comments
                        WHERE LOCATE('@[".$_SESSION['login']."]',postit_comment_waved_users) 
                          AND postit_comment_postit_id_fk IN(".implode(',',$itemIdsList).") 
                          AND postit_comment_postit_type='".strtoupper($simpleItemType)."' 
                          AND postit_comment_user_login_fk!='".$_SESSION['login']."' 
                          AND postit_comment_date>'".$userObject->getUserPreviousLoginDate()."' 
                        GROUP BY postit_comment_postit_id_fk");     
      $commentWavedCountAllItems=$request->getArrayFieldsPivot('postit_comment_postit_id_fk'); 
      // get number of comments for each displayed postit
      $request->sqlGet("SELECT COUNT(*) as nbItem,postit_comment_postit_id_fk
                        FROM kados_postit_comments
                        WHERE postit_comment_postit_id_fk IN(".implode(',',$itemIdsList).") 
                          AND postit_comment_postit_type='".strtoupper($simpleItemType)."' 
                        GROUP BY postit_comment_postit_id_fk");
      $commentNumberAllItems=$request->getArrayFieldsPivot('postit_comment_postit_id_fk'); 
/*********************** END OF COMMENTS ZONE ********************************/    

/*************************** RELATIONSHIPS ZONE ******************************/  
      $request->sqlGet("SELECT COUNT(us_id) AS nbItem,us_id FROM (
                        SELECT first_us_id_fk AS us_id,second_us_id_fk 
                        FROM kados_user_stories_relationships
                        WHERE first_us_id_fk IN(".implode(',',$itemIdsList).")
                        UNION
                        SELECT second_us_id_fk AS us_id,first_us_id_fk 
                        FROM kados_user_stories_relationships
                        WHERE second_us_id_fk IN(".implode(',',$itemIdsList).")) AS tmptable 
                        GROUP BY us_id");      
      $relationshipCountAllItems=$request->getArrayFieldsPivot('us_id'); 
/*********************** END OF RELATIONSHIPS ZONE ***************************/      
  
// init a comment object
$commentObject=new comment($cnx->num);
// init a relationship object
$relationshipObject=new relationship($cnx->num);

/******************** MAIN BOUCLE TO DISPLAY POSTIT ON BOARD *****************/
// for each postit
for ($i=0;$i<count($resultArray);$i++)
{
  $addonUpdateUrl='';
  $activateParentZone=false;
  $activateWarningZone=false;
  if ($updateParameter!='')
  {
    $addonUpdateUrl='&'.$updateParameter.'='.$resultArray[$i][$updateParameter];
  }
  // Checked if there is a link
  $linkExists= isset($resultArray[$i]['link']) ? ($resultArray[$i]['link']!='' ? true : false ) : false;
  // Checked if there is a leader
  $leaderExists= isset($resultArray[$i]['item_leader']) ? ($resultArray[$i]['item_leader']!='' ? true : false ) : false;
			
  $postitInfos='';			
  if ($resultArray[$i]['creator']!='')
  {  
    $postitInfos=$text_created_on_m.format_date(dateFromDatetime($resultArray[$i]['creation_date'])).' ';
    $postitInfos.=$text_by.' '.getUserName($resultArray[$i]['creator']).'<br />';
    $postitInfos.=$text_last_updated_on_m.format_date(dateFromDatetime($resultArray[$i]['last_update'])).' ';  
    $postitInfos.=$text_by.' '.getUserName($resultArray[$i]['last_updater']).'<br />';
  }
  // get Tags for the postit
  $postitTagsList=isset($postitTagsAllItemsList[$resultArray[$i][$itemIdName]]) ? $postitTagsAllItemsList[$resultArray[$i][$itemIdName]] : array();
    
  
  // Warning and parent zones
  $parentZoneData=array();
  $warningZoneData=array();
  // display link between issue and US if exists	
  if ($simpleItemType=='us')
  {
    if ($displayWarningZone)
    {
      // Warning zone may be activated if link with issues
      $warningZoneData= isset($warningZoneDataAllItems[$resultArray[$i][$itemIdName]]) ? $warningZoneDataAllItems[$resultArray[$i][$itemIdName]] : array();
    }	
		  
    if ($displayParentZone)
    {
      // Parent zone may be activated if link with an US
      $parentZoneData= isset($parentZoneDataAllItems[$resultArray[$i][$itemIdName]]) ? $parentZoneDataAllItems[$resultArray[$i][$itemIdName]] : array();
    }	
  }
  else if ($simpleItemType=='issue')
  {
    if ($displayParentZone)
    {
      // Parent zone may be activated if link with an US
      $parentZoneData= isset($parentZoneDataAllItems[$resultArray[$i][$itemIdName]]) ? $parentZoneDataAllItems[$resultArray[$i][$itemIdName]] : array();
    }	
  }		
  else if ($simpleItemType=='task')
  {
    if ($displayParentZone)
    {
      // Parent zone may be activated if link with an US
      $parentZoneData= isset($parentZoneDataAllItems[$resultArray[$i][$parentRefId]]) ? $parentZoneDataAllItems[$resultArray[$i][$parentRefId]] : array();
    }	
  }
  // compute display for zones		
  if (count($parentZoneData)!=0)
  {
    if (file_exists(PATHBASE.'parent_zone_'.$simpleItemType.'.php'))
    {
      require PATHBASE.'parent_zone_'.$simpleItemType.'.php';
    }
  }  
  if (count($warningZoneData)!=0)
  {
    if (file_exists(PATHBASE.'warning_zone_'.$simpleItemType.'.php'))
    {
      require PATHBASE.'warning_zone_'.$simpleItemType.'.php';
    }
  }?>  

	<div class="<?php if ($allowMove) { echo 'note';} else { echo 'note_static'; }?> <?php echo $resultArray[$i]['color'];?> " id="note<?php echo $resultArray[$i][$itemIdName];?>" style="width:<?php echo $itemWidth;?>px;height:<?php echo $itemHeight;?>px;left:<?php echo ($arrayStatusX[$resultArray[$i][$managedField]]+$resultArray[$i][$xPosField]);?>px;top:<?php echo $resultArray[$i][$yPosField];?>px;z-index:<?php echo $resultArray[$i][$zPosField];?>">
	<div class="upper-header" style="width:<?php echo $itemWidth;?>px;">
		<!-- The PARENT ZONE --><?php
		if ($activateParentZone)
		{?>
		  <div class="parent_zone" ><?php echo $parentZoneDisplay;?></div><?php
		}?><!-- The WARNING ZONE --><?php
     	if ($activateWarningZone)
		{?>
		  <div class="warning_zone"><?php echo $warningZoneDisplay;?></div><?php		
		} ?> 
	</div><?php
		// Call special function to disable update function (useful for activities)
		$enableUpdateFunction=true;
		if (isset($functionForDisableUpdate))
		{
		  $enableUpdateFunction=call_user_func($functionForDisableUpdate,array($resultArray[$i][$itemIdName],$cnx->num)); 
		}
		// Call special function to disable update function (useful for activities)
		$enableDeleteFunction=true;
		
		if (isset($functionForDisableDelete))
		{
		  $enableDeleteFunction=call_user_func($functionForDisableDelete,array($resultArray[$i][$itemIdName],$cnx->num)); 
		}?>
	<div class="item-header">
		  <?php if ($allowDelete && $enableDeleteFunction) { ?><span class="<?php echo $deleteModeInt;?>span bloc-header"><form class="pure-form pure-form-aligned" action="<?php echo $targetFileAction;?>&action=del_item&item_id=<?php echo $resultArray[$i][$itemIdName];?>&object_id=<?php echo $parentId;?>#Block<?php echo $k;?>" method="post" name="form_del_item<?php echo $resultArray[$i][$itemIdName];?>"><img src="<?php echo $pathImages.$pictureTrash;?>" border="0" /></form></span><?php }?>			
		  <span class="editspan bloc-header"><?php if ($allowUpdate && $enableUpdateFunction) { ?><a href="<?php echo PATHBASE;?>boards_buttons/update_<?php echo $simpleItemType;?>.php?item_id=<?php echo $resultArray[$i][$itemIdName];?>&item_type=<?php echo $itemType;?><?php echo $addonUpdateUrl;?>&blockId=<?php echo $k;?>" class="ulbtn"><img src="<?php echo $pathImages;?>app/update.png" border="0" /></a><?php }?></span>	<?php
                  // if there is some postit infos
                  if ($postitInfos!='')
		  {
                    // if postit is US or task, display history dialog  
                    if ($simpleItemType=='task' || $simpleItemType=='us')
                    {?>
                      <span class="postit_details bloc-header historyButtton" ><img src="<?php echo $pathImages;?>app/history.png" border="0" /></span><?php
                    }
                    else
                    {?>
                      <span class="postit_details bloc-header"><img src="<?php echo $pathImages;?>app/history.png" border="0" tooltip="<?php echo changeDoubleQuote($postitInfos);?>" /></span>	<?php
                    }
                  }?>		  
		  <span class="postit_id"><?php echo $objectTag.$resultArray[$i][$itemNumberName];?></span>
		  <span class="postit_header-right"><?php 
		    if (isset($functionForHeaderStamp))
	            {
                      $argHeaderStamp= isset($resultArray[$i]['header_stamp_arg']) ? $resultArray[$i]['header_stamp_arg'] :'';
		      call_user_func($functionForHeaderStamp,array($resultArray[$i][$itemIdName],$resultArray[$i]['header_stamp'],$allowActionHeaderStamp,$argHeaderStamp)); 
		    }
                    else
                    {
                      echo htmlspecialchars($resultArray[$i]['header_stamp']);
                    }?>
		  </span>
		  <span class="hidden-parent_id"><?php echo $parentId;?></span>
		  <span class="hidden-title_displayed"><?php echo ($displayDashBoardTitles ? $displayTopLimit : 3);?></span>
		</div>
		<div class="postit_text" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"><?php echo make_clickable(nl2br(htmlspecialchars($resultArray[$i]['text'])));?></div>
                <div class="postit_text_over" style="color:#CECEF3;right:<?php echo $posOver;?>px;display:<?php echo $_SESSION['display_priority'];?>"><?php if (isset($resultArray[$i]['priority'])) { echo $resultArray[$i]['priority']; }?></div>				
	        <div class="postit_text_over" style="color:#6969F3;right:<?php echo $posOver+2;?>px;display:<?php echo $_SESSION['display_priority'];?>"><?php if (isset($resultArray[$i]['priority'])) { echo $resultArray[$i]['priority']; }?></div>				
	        <div class="postit_text_over" style="color:navy;right:<?php echo $posOver+4;?>px;display:<?php echo $_SESSION['display_priority'];?>"><?php if (isset($resultArray[$i]['priority'])) { echo $resultArray[$i]['priority']; }?></div>				
	        <div class="item-footer">
	      <span class="postit_footer-left"><?php 
                // If exists, display info for bottom left part of the postit
	  	if (isset($resultArray[$i]['infoBottomLeft']))
		{
                  // There may be a function to display the info  
	          if (isset($functionForBottomLeft)) 
		  { 
		    call_user_func($functionForBottomLeft,$resultArray[$i]['infoBottomLeft']);
		  }
		  else
		  {
                    // If no function, just display the info  
		    echo $resultArray[$i]['infoBottomLeft'];
		  }
		} ?>
	      </span>
	      <span class="postit_footer-center1" style="position:relative;left:<?php echo (round($itemWidth/2,0)-15);?>px;top:2px;"><?php
                // If a link exists, display a small icon to go to the link target
 	        if ($linkExists)
		{
                  $linkForPostIt=$resultArray[$i]['link'];  
                  // with a regex, check that link start with a protocol else add http://
                  if (!preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$resultArray[$i]['link']))
                  {  
                     $linkForPostIt="http://".$linkForPostIt;
                  }  ?>
		  <a href="<?php echo $linkForPostIt;?>" target="_ext"><img src="<?php echo $pathImages;?>app/link.png" title="<?php echo $resultArray[$i]['link'];?>" border="0" /></a><?php
                } 
                // If there is any files attached to the postit, display an icon to open the files list
                $filesDirectoryName=getParameter('FLPATH',$cnx->num).'/'.strtoupper($simpleItemType).'/'.strtoupper($simpleItemType).$resultArray[$i][$itemIdName];
                
                if (is_dir($filesDirectoryName))
                {
                  // scan directory to get files  
                  $attachmentFilesList=scandir($filesDirectoryName);
                  // check if there is more than 4 entries in the directory : ., .. , index.php and .htaccess at least
                  if (count($attachmentFilesList)>4)
                  {?>
                  <span class="attachments_icon attachementsButton"><img src="<?php echo $pathImages;?>app/attached.png" title="" border="0" /></span> <?php     
                  }
                }
                // RSS flow
                if ($simpleItemType=='us' && getParameter('RSSACT',$cnx->num))
                {?>  
                  <span style="padding-top:2px;"><a target="_ext_rss" href="rss.php?us_id=<?php echo $resultArray[$i][$itemIdName];?>&language=<?php echo $_SESSION['language'];?>&token=<?php echo $currentProject->rssKey;?>"><img src="<?php echo $pathImages;?>app/small_rss.png"/></a></span><?php
                }?>
              </span><?php
            
            if ($simpleItemType=='task')
            {
              // if the postit is a task, it ca be allocated
              $isUserStakeholder=false;
              if (isset($_SESSION['current_project_id']))
              {  
                $isUserStakeholder=$currentProject->isUserStakeholder($_SESSION['login'],$_SESSION['current_project_id'],(isset($_SESSION['current_release_id'])? $_SESSION['current_release_id'] : 0));
              }  
              // check if allocation is allowed for user
              $allowAllocate=in_array('ALLOC_TASK',$_SESSION['user_actions']) 
                          || in_array('ALLOC_TASK',$_SESSION['user_local_actions']); ?>
              <span class="postit_footer-center2" style="position:relative;left:<?php echo (round($itemWidth/2,0)+($linkExists?-11:+3));?>px"><?php
                // if task has a leader, display the allocated picture with the leader name
	        if ($leaderExists)
		{?>
		  <span class="user-head<?php if ($allowAllocate || $isUserStakeholder) {echo ' allocate_user';}?>" ><img src="<?php echo $pathImages;?>app/user.png" title="<?php echo $text_assigned_to_f.' '.getUserName($resultArray[$i]['item_leader']);?>" border="0" /></span><?php
		}
		else if ($displayNoUser)
                {
                  // else display the no user picture and if allowed, add allocation function for current user (through a small picklist)  
		  //if (in_array($_SESSION['login'],$stakeholdersProjects))?>
		  <span class="user-head<?php if ($allowAllocate || $isUserStakeholder) {echo ' allocate_user';}?>" ><img src="<?php echo $pathImages;?>app/no-user.png" border="0" tooltip="<?php echo changeDoubleQuote($text_assigned_to_nobody);?>" /></span><?php
		}
                // Build picklist/listbox for allocating tasks or actions
                if ($allowAllocate || $isUserStakeholder)
                {  ?>
                  <span class="user-list" id="user_list_<?php echo $resultArray[$i][$itemIdName];?>" style="left:12px;top:15px;display:none;position:absolute;" >
                      <table >
                      <tr><td>
                      <form  name="allocate_user_form_<?php echo $resultArray[$i][$itemIdName];?>" action="<?php echo $targetFileAction;?>#Block<?php echo $k;?>" method="POST">
                          <input type="hidden" name="action" value="assign" />
                          <input type="hidden" name="item_id" value="<?php echo $resultArray[$i][$itemIdName];?>" />
                          <select class="small_font username_select" name="username" onChange="javascript:document.allocate_user_form_<?php echo $resultArray[$i][$itemIdName];?>.submit()"> 
                              <option class="small_font"></option> <?php
                              // display a list of project users that could be the leader on postit
	            for ($nbUsers=0;$nbUsers<count($projectUsers);$nbUsers++)
	            { 
                      if (!$allowAllocate && $isUserStakeholder && $projectUsers[$nbUsers]['login']==$_SESSION['login'] || $allowAllocate)
                      {  ?>		  
	                <option class="small_font" value="<?php echo $projectUsers[$nbUsers]['login'];?>" <?php if ($resultArray[$i]['item_leader']==$projectUsers[$nbUsers]['login']) { echo 'selected="selected"';} ?>><?php echo $projectUsers[$nbUsers]['name'];?></option><?php
                      }
                    }?>	
                        </select>
                      </form>
                      </td>
                      <td><img src="<?php echo $pathImages;?>app/close.png" class="close_user_list" id="closeButton_<?php echo $resultArray[$i][$itemIdName];?>" /></td>
                          </tr></table>
                  </span><?php
                }?>  
		</span><?php
            }?>
		<span class="postit_footer-right"><?php 
                  // if the is an info for the bottom right of the postit
		  if (isset($resultArray[$i]['infoBottomRight']))
		  {
                    // it may use a function,  
		    if (isset($functionForBottomRight)) 
		    { 
                      // then call the function with the bottom right info as param  
		      call_user_func($functionForBottomRight,$resultArray[$i]['infoBottomRight']);
		    }
		    else
		    {
                      // or display the value directly  
		      echo $resultArray[$i]['infoBottomRight'];
		    }
                  } ?>		  
		</span>
	      </div>		
	      <span class="item-status"><?php echo $resultArray[$i][$managedField];?></span>
	      <span class="data"><?php echo $resultArray[$i][$itemIdName];?></span><?php
	  // display tags if postit are US or TASKS 
	  if (in_array($simpleItemType,array('us','task')) && $currentProject->paramUseTags)
	  {
            // reinit tags ID table  
	    unset($postitTagsListIds);
            // reinit list of groups used by the postit
            unset($postitTagsGroups);
            $postitTagsListIds=array();
            $postitTagsGroups=array();
	    // TAGS of the Postit, follow the list of tags
	    for ($nbtags=0;$nbtags<count($postitTagsList);$nbtags++)
            {
	      // add to local postit tags table
	      $postitTagsListIds[]=$postitTagsList[$nbtags]['tag_id'];
              // add group in the array, if it is not empty 
              if (intval($postitTagsList[$nbtags]['tag_group_id_fk'])!=0 && !in_array($postitTagsList[$nbtags]['tag_group_id_fk'],$postitTagsGroups))
              {
                $postitTagsGroups[]=$postitTagsList[$nbtags]['tag_group_id_fk'];
              }    
	      // display tag if it has just been created
              // default is none
	      $tagDisplay='display:none;';
              // if the script has receveid a value for "add tag"
	      if (isset($_REQUEST['tag2add_id'])) 
	      { 
                // if it this is the current tag and it is for the current postit
	        if ($_REQUEST['tag2add_id']==$postitTagsList[$nbtags]['tag_id'] && intval($_REQUEST['item_id'])==$resultArray[$i][$itemIdName]) 
		{ 
                  // show the tag completly
		  $tagDisplay='';
		}
	      }
              // display the tag on the postit?>
	      <div class="tag-zone-out <?php echo $postitTagsList[$nbtags]['tag_color'];?>" style="left:<?php echo $itemWidth;?>px;top:<?php echo 22+$nbtags*22;?>px;"></div>			
	      <div class="tag-zone <?php echo $postitTagsList[$nbtags]['tag_color'];?>" style="left:<?php echo $itemWidth;?>px;top:<?php echo 22+$nbtags*22;?>px;<?php echo $tagDisplay;?>">
                <?php echo $postitTagsList[$nbtags]['tag_label'];   if (in_array('MNG_TAGS',$_SESSION['user_actions']) || in_array('MNG_TAGS',$_SESSION['user_local_actions'])) {?> <a href="<?php echo $targetFileAction;?>&action=remove_tag&item_id=<?php echo $resultArray[$i][$itemIdName];?>&tag2remove_id=<?php echo $postitTagsList[$nbtags]['tag_id'];?>#Block<?php echo $k;?>" onclick="return confirm('<?php echo $msg_confirm_delete_object;?>');"><img src="<?php echo $pathImages;?>app/delete.png" border="0" /></a><?php }?>
	      </div><?php
            }
            // display small button to add tag on the postit, il allowed by profile
            if (in_array('MNG_TAGS',$_SESSION['user_actions']) || in_array('MNG_TAGS',$_SESSION['user_local_actions']))
            {?>
	    <!-- ADD tags -->
	    <div class="tag-zone-add" style="left:<?php echo $itemWidth+1;?>px;top:2px;">
	      <img src="<?php echo $pathImages;?>app/pin.png" />
	      <div class="tag-list" style="left:14px;top:0;display:none"><?php
              // allow to add all tags available in the project
	      for ($nbTagsTpl=0;$nbTagsTpl<count($projectTagsList);$nbTagsTpl++)
	      { 
                // except if they are already on the postit 
                // or there is one tag coming from the same group)
                // or tag is not allowed for this type of postit
	        if (!in_array($projectTagsList[$nbTagsTpl]['tag_id'],$postitTagsListIds) 
                    && !in_array($projectTagsList[$nbTagsTpl]['tag_group_id_fk'],$postitTagsGroups)
                    && in_array($projectTagsList[$nbTagsTpl]['tag_id'],$listAllowedTagsByPostit[$resultArray[$i]['color']]))
	        {?>		  
	          <a href="<?php echo $targetFileAction;?>&action=add_tag&item_id=<?php echo $resultArray[$i][$itemIdName];?>&tag2add_id=<?php echo $projectTagsList[$nbTagsTpl]['tag_id'];?>#Block<?php echo $k;?>" ><?php echo $projectTagsList[$nbTagsTpl]['tag_label'];?></a><br /><?php
	        }  
              }?>	
	      </div>
	    </div><?php
            }
	  }
          // if postit are US or Tasks, display comments
	  if (in_array($simpleItemType,array('us','task')))
	  {
            // display comments 
            // display comments if postit are US or TASKS                             ?>
	    <div class="comment-zone commentsButton" style="left:-16px;top:2px;">
	      <img src="<?php echo $pathImages;?>app/comment.png" />
                   <div class="new-comment-zone" style="left:-1px;top:-3px;"><?php
              // $newCommentForUser=$commentObject->getPostitHasNewComment($resultArray[$i][$itemIdName],$simpleItemType,$userObject->getUserPreviousLoginDate(),$_SESSION['login']);
              if (isset($commentWavedCountAllItems[$resultArray[$i][$itemIdName]]))     
              {    
                if ($commentWavedCountAllItems[$resultArray[$i][$itemIdName]]['nbItem']!=0)
                {?>
                  <img src="<?php echo $pathImages;?>app/newCommentUser.png" /><?php
                }
                else if (isset($commentCountAllItems[$resultArray[$i][$itemIdName]]))     
                {
                  if ($commentCountAllItems[$resultArray[$i][$itemIdName]]['nbItem']!=0)
                  {?>
                  <img src="<?php echo $pathImages;?>app/newComment.png" /><?php
                  }
                }
              }
              else if (isset($commentCountAllItems[$resultArray[$i][$itemIdName]]))     
              {
                if ($commentCountAllItems[$resultArray[$i][$itemIdName]]['nbItem']!=0)
                {?>
                  <img src="<?php echo $pathImages;?>app/newComment.png" /><?php
                }
              }?>  
            </div> <?php
            // Number of comments 
            $countComment= isset($commentNumberAllItems[$resultArray[$i][$itemIdName]]) ? $commentNumberAllItems[$resultArray[$i][$itemIdName]]['nbItem'] : 0 ;?>
            <div class="comment-counter-zone" id="comments_counter_<?php echo $resultArray[$i][$itemIdName];?>" style="left:<?php echo ($countComment>9 ? '0' : '4');?>px;top:16px;"><?php echo $countComment;?></div>
            </div> <?php
          }
          // if postit are US, display relationships to US
	  if ($simpleItemType=='us')
	  {
            // display relationships if postit are US                             ?>
	    <div class="relationship-zone relationshipsButton" style="left:-16px;top:42px;">
	      <img src="<?php echo $pathImages;?>app/related.png" />   <?php
            // Number of relationships 
            $countRel= isset($relationshipCountAllItems[$resultArray[$i][$itemIdName]]) ? $relationshipCountAllItems[$resultArray[$i][$itemIdName]]['nbItem'] : 0;?>
            <div class="relationship-counter-zone" id="relationships_counter_<?php echo $resultArray[$i][$itemIdName];?>" style="left:<?php echo ($countRel>9 ? '0' : '4');?>px;top:16px;"><?php echo $countRel;?></div>
            </div> <?php
          }?>          
            <div class="hidden-div postitSimpleType"><?php echo $simpleItemType;?></div>
	</div><?php
}?>	
</div>
<div class="clearleft"></div>
<div id="scroll"></div>
<script>
  /* if not in a multi matrix display, use floatable header for columns*/  
  if (!($('div').hasClass('main_matrix')))
  {
    // listen for scroll
    var positionElementInPage = $('.colHeader').offset().top-$('#menu').height()-10;
      $(window).scroll(
	function() {
		if ($(window).scrollTop() >= positionElementInPage) {
			// fixed
			$('.colHeader').addClass("floatable");
                        $('.colHeader').css("top",$(window).scrollTop()-92);
		} else {
			// relative
			$('.colHeader').removeClass("floatable");
                        $('.colHeader').css("top",'0');
                        
		}
	  }
        );
   }
</script>
