<?php
/**
 * Creates an excel file with  the result list of a search on an information
 * 
 * PHP version 5
 * 
 * @category Exports
 * @package  exportCsv
 * @author   Charles Santucci <charles.santucci@renault.com>
 * @license  GPL v3, MIT
*/

set_time_limit(600);
ini_set('memory_limit','64M');
define("PATHBASE",'../');
$pathLibraries=PATHBASE.'libraries/';
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';
$pathCommons=PATHBASE.'common_scripts/';
  
include PATHBASE.'conf/connect.conf';
require_once $pathLibraries.'classes/class_connexion_mysql.php';
require_once $pathCommons.'functions.php';
$cnx=new connexion_db();
require_once PATHBASE.'session_settings.php';

require_once $pathLibraries.'phpword/PHPWord.php';
require_once $pathCommons.'app_functions.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';
require_once $pathAppClasses.'project.php';


// get project data
$currentProject=new project($cnx->num,$_SESSION['current_project_id']);
$currentProject->getData();

// check if hierarchy must be used
$useHierarchy=true;

include 'export_get_data.php';

// BUILD FILE
$filename=$projectData->project_name.'-'.$projectData->release_name.'-'.$projectData->sprint_name.'-'.$_SESSION['login'];
$filename=stripSpaces(stripAccents(utf8_decode($filename))).'.csv';
$fname=PATHBASE.'tmp/'.$filename;
$fh = fopen($fname,'w');

fputcsv($fh,array_merge(array_fill(0,8,utf8_decode($text_US)),array_fill(0,7,utf8_decode($text_task))),';');
$header=$text_release.';'.$text_sprint.';'.$text_number.';'.$text_type.';'.$text_status.';'.$text_US.';'.$text_business_value.';'.$text_complexity.';'.$text_type.';'.$text_number.';'.$text_task.';'.$text_status.';'.$text_initial_load.';'.$text_load_spent.';'.$text_load2finish;
fwrite($fh,utf8_decode($header)."\n");
unset($header);

// lignes
// init
$releaseName='';  
$sprintName='';


  // If scope is project, display backlog
  if ($minimumScope=='project')  
  {
    // if backlog has US  
    if (isset($usTree[0]))  
    {    
      // display US in Product Backlog  
      if ($currentProject->level>1)  
      {
        // display name of Backlog if more than one level
        $releaseName='Product Backlog';  
        $sprintName='';
      }  
      for ($i=0;$i<count($usTree[0][0]);$i++)  
      {
        $currentUS=$listUs[$usTree[0][0][$i]];
        include 'export_csv_lines.php';
      }
    }  
  }
  for($i=0;$i<count($releases);$i++)  
  {
    $releaseName='Release '.$releases[$i]['release_name'];  
    $usInReleaseBySprint=$usTree[$releases[$i]['release_id']];
    // If scope is a release, display backlog for release
    if ($minimumScope=='release' || $minimumScope=='project' )  
    {
      // if there is some US in the backlog  
      if (isset($usInReleaseBySprint[0]))
      {
        // display US in Release Backlog  
        if ($currentProject->level>2)  
        {
          // display name of Backlog if more than one level
          $sprintName='Release Backlog';  
        }  
        for ($j=0;$j<count($usInReleaseBySprint[0]);$j++)  
        {
          $currentUS=$listUs[$usInReleaseBySprint[0][$j]];
          include 'export_csv_lines.php';
        }      
      }  
    }  
    // display US by sprint
    if (isset($sprints[$releases[$i]['release_id']]))
    {    
      $sprintsForTheRelease=$sprints[$releases[$i]['release_id']];
      for ($j=0;$j<count($sprintsForTheRelease);$j++)  
      {
        $sprintName=$sprintsForTheRelease[$j]['sprint_name'];     
        $sprintContent=$usInReleaseBySprint[$sprintsForTheRelease[$j]['sprint_id']];
        for($nbUs=0;$nbUs<count($sprintContent);$nbUs++)
        {
          $currentUS=$listUs[$sprintContent[$nbUs]];
          include 'export_csv_lines.php';
        }
      }    
    }
  }  

fclose($fh);

header("Content-Type: application/octet-stream");
header('Content-Disposition: inline; filename="'.$filename.'"');
readfile($fname); 
unlink($fname);