<?php
/**
 * Creates an odt file with filters
 * 
 * PHP version 5
 * 
 * @category Exports
 * @package  exportOdt
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
*/
define("PATHBASE",'../');
$pathLibraries=PATHBASE.'libraries/';
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';
$pathCommons=PATHBASE.'common_scripts/';

include PATHBASE.'conf/connect.conf';
require_once $pathLibraries.'classes/class_connexion_mysql.php';
require_once $pathCommons.'functions.php';
$cnx=new connexion_db();
require_once PATHBASE.'session_settings.php';

require_once $pathLibraries.'phpodt/phpodt.php';
require_once $pathCommons.'app_functions.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';
require_once $pathAppClasses.'project.php';

$cnx=new connexion_db();

// get project data
$currentProject=new project($cnx->num,$_SESSION['current_project_id']);
$currentProject->getData();

// check if hierarchy must be used
$useHierarchy= isset($_POST['use_hierarchy']) ? true : false;

// get Data
include 'export_get_data.php';

// CREATE DOC
// New ODT Document
$odt = ODT::getInstance();

$pageStyle = new PageStyle('myPageStyle');
//$pageStyle->setFooterContent(StyleConstants::PAGE_NUMBER);
/*
// New portrait section
$section = $PHPWord->createSection(array('borderColor'=>'E9E6DB', 'borderSize'=>4,'marginLeft'=>800, 'marginRight'=>800, 'marginTop'=>800, 'marginBottom'=>400));
// Define the paragraph style
$PHPWord->addParagraphStyle('pStyle', array('spaceAfter'=>10));
$PHPWord->addParagraphStyle('pStyleEnd', array('spaceAfter'=>30));

// Define font style
$PHPWord->addFontStyle('fStyle',array('size'=>12));
// Add title styles
$PHPWord->addTitleStyle(1, array('size'=>20, 'color'=>'black', 'bold'=>true),array('spaceAfter'=>60));
$PHPWord->addTitleStyle(2, array('size'=>16, 'color'=>'7A4E16', 'bold'=>true, 'italic'=>true),array('spaceAfter'=>60));
$PHPWord->addTitleStyle(3, array('size'=>12, 'color'=>'23107A'),array('spaceAfter'=>60));
// Add table style
$PHPWord->addTableStyle('UsTableStyle',array('borderColor'=>'A4A29A','cellMargin'=>50,'borderTopSize'=>2,'borderRightSize'=>2,'borderLeftSize'=>2));
$PHPWord->addTableStyle('UsContentTableStyle',array('borderColor'=>'A4A29A', 'cellMargin'=>50,'borderSize'=>2));
$PHPWord->addTableStyle('TasksTableStyle',array('borderSize'=>2, 'borderColor'=>'A4A29A', 'cellMargin'=>50));
*/
// add project name
$textStyle = new TextStyle('textstyle1');   //You can the name, but it's better to specify one
$textStyle->setColor('#000000');            //Change the color of the text to red. The color must be in hexa  notation
$textStyle->setBold();                      //Make the text bold
$textStyle->setFontSize(20);                //Change the font size

$textStyle2 = new TextStyle('textstyle2');   //You can the name, but it's better to specify one
$textStyle2->setColor('#7A4E16');            //Change the color of the text to red. The color must be in hexa  notation
$textStyle2->setFontSize(16);                //Change the font size

$pStyle = new ParagraphStyle('myPStyle');
$pStyle->setTopPadding('5cm');

$textStyle3 = new TextStyle('textstyle3');   //You can the name, but it's better to specify one
$textStyle3->setColor('#23107A');            //Change the color of the text to red. The color must be in hexa  notation
$textStyle3->setFontSize(12);                //Change the font size

$styledParagraph = new Paragraph();
$styledParagraph->addText($text_project.' '.utf8_decode($projectData->project_name), $textStyle);

$tableStyle = new TableStyle('USTableStyle');
//set the width of the table
$tableStyle->setWidth('17cm');
//set the alignment
//$tableStyle->setAlignment(StyleConstants::LEFT);

$countUS=0;
if ($useHierarchy)
{
  // If scope is project, display backlog
  if ($minimumScope=='project')  
  {
    // if backlog has US  
    if (isset($usTree[0]))  
    {    
      // display US in Product Backlog  
      if ($currentProject->level>1)  
      {
        // display name of Backlog if more than one level
        $styledParagraph = new Paragraph($pStyle);
        $styledParagraph->addText('Product Backlog', $textStyle2);  
      }  
      for ($nbUs=0;$nbUs<count($usTree[0][0]);$nbUs++)  
      {
        $currentUS=$listUs[$usTree[0][0][$nbUs]];
        include 'export_odt_table.php';
        $countUS++;
      }
    }  
  }
  for($i=0;$i<count($releases);$i++)  
  {
    $styledParagraph = new Paragraph($pStyle);  
    $styledParagraph->addText('Release '.$releases[$i]['release_name'], $textStyle2);    
    $usInReleaseBySprint=$usTree[$releases[$i]['release_id']];
    // If scope is a release, display backlog for release
    if ($minimumScope=='release' || $minimumScope=='project' )  
    {
      // if there is some US in the backlog  
      if (isset($usInReleaseBySprint[0]))
      {
        // display US in Release Backlog  
        if ($currentProject->level>2)  
        {
          // display name of Backlog if more than one level
          $styledParagraph = new Paragraph();
          $styledParagraph->addText('Release Backlog', $textStyle3);      
        }  
        for ($nbUs=0;$nbUs<count($usInReleaseBySprint[0]);$nbUs++)  
        {
          $currentUS=$listUs[$usInReleaseBySprint[0][$nbUs]];
          include 'export_odt_table.php';
          $countUS++;
        }      
      }  
    }  
    // display US by sprint
    if (isset($sprints[$releases[$i]['release_id']]))
    {    
      $sprintsForTheRelease=$sprints[$releases[$i]['release_id']];
      for ($j=0;$j<count($sprintsForTheRelease);$j++)  
      {
        $styledParagraph = new Paragraph();  
        $styledParagraph->addText('Sprint '.$sprintsForTheRelease[$j]['sprint_name'], $textStyle3);       
        $sprintContent=$usInReleaseBySprint[$sprintsForTheRelease[$j]['sprint_id']];
        for($nbUs=0;$nbUs<count($sprintContent);$nbUs++)
        {
          $currentUS=$listUs[$sprintContent[$nbUs]];
          include 'export_odt_table.php';
          $countUS++;
        }
      }    
    }
  }  
}
else
{
  // for each release, display name
  if ($projectData->release_name!='')
  {    
    $styledParagraph = new Paragraph();
    $styledParagraph->addText('Release '.utf8_decode($projectData->release_name),$textStyle2);       
  }  
  // for each sprint, display name
  if ($projectData->sprint_name!='')
  {
    $styledParagraph = new Paragraph();  
    $styledParagraph->addText('Sprint '.utf8_decode($projectData->sprint_name),$textStyle2);         
  }  

  while($usData=each($listUs))
  {
    $currentUS=$usData[1];  
    include 'export_odt_table.php';
    $countUS++;
    break;
  }
}

// set filename
$filename=$projectData->project_name.'-'.$projectData->release_name.'-'.$projectData->sprint_name.'-'.$_SESSION['login'];
$filename=stripSpaces(stripAccents(utf8_decode($filename))).'.odt';
$fname=PATHBASE.'tmp/'.$filename;

// output file
$odt->output($fname);

header("Content-Type: application/octet-stream");
header('Content-Disposition: inline; filename="'.$filename.'"');
readfile($fname); 
unlink($fname);
?>