<?php
/**
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:index
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
define("PATHBASE",'./');
require_once PATHBASE.'constants.php';
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';

include PATHBASE.'conf/connect.conf';
require_once $pathClasses.'class_connexion_mysql.php';
require_once $pathCommons.'functions.php';
$cnx=new connexion_db();
require_once PATHBASE.'session_settings.php';
require_once $pathCommons.'getDefaultLanguage.php';

$_SESSION['charset']=$cnx->charset;
$delayMsg=2000;

// if language is not set 
if (!isset($_SESSION['language']))
{
  // Set default language using the browser language 
  $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages  ",$cnx->num);
  $availableLanguages=$request->getArrayFirstFieldOnly();
  // if URL gives a language use it
  if (isset($_GET['lg']))
  {
    $browserLanguage=$_GET['lg'];
  }   
  else
  {    
    // else use the default language for app  
    $browserDefaultLanguage=strtolower(getDefaultLanguage());
  }
  // set language in session var
  $_SESSION['language']= in_array($browserLanguage,$availableLanguages) ? $browserLanguage : getParameter('DFLANG',$cnx->num) ;
}
// if change language request received
if (isset($_GET['change_language']))
{    
  $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages  ",$cnx->num);
  $availableLanguages=$request->getArrayFirstFieldOnly();
  $changeLanguage=strtolower(substr($_GET['change_language'],0,2));
  $_SESSION['language']=in_array($changeLanguage,$availableLanguages) ? $changeLanguage : getParameter('DFLANG',$cnx->num) ;
} 

require_once $pathClasses.'class_ldap.php';
require_once $pathCommons.'date_hour.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_js_messages.php';

require_once $pathCommons.'functions.php';
require_once $pathCommons.'app_functions.php';
require_once $pathAppClasses.'appUser.php';

// Include PHP mailer lib
require_once PATHBASE.'libraries/PHPMailer/PHPMailerAutoload.php';

$targetFile='forgotten.php?';

if (!isset($_REQUEST['connexion']))
{
  $_REQUEST['connexion']='';
}  
      
switch($_REQUEST['connexion'])
{
  case 'on':
    // protect against false form  
    if (!getParameter('USACT', $cnx->num))
    {
      break;  
    }  
  
    // get user
    $formLogin=substr($_POST['Flogin_forgotpass'],0,LG_MAX_LOGIN);       
    $userToCheck=new appUser($cnx->num,$formLogin);  
    
    // If user is authenticated, let's go to the welcome page
    if ($userToCheck->login!='')
    {	
      // if user is not an LDAP user 
      if ($userToCheck->mode=='LOCAL')
      {    
        // check if email is the same
        if ($userToCheck->email==$_POST['form_item_email_forgotpass']) 
        {
          // reinit user  
          // reset key  
          $userConfirmationKey=md5('key'.$userToCheck->login.time());
          // update user confirmation requested date 
          $request=new sqlRequest("UPDATE ".PARAM_DB_PREFIX."framework_users 
                                   SET user_confirmed=0,
                                       user_confirmation_key_stamp='".date('Y-m-d H:i:s')."',
                                       user_confirmation_key='".$userConfirmationKey."' 
                                   WHERE user_login='".$userToCheck->login."'",$cnx->num);
          // send email
          //Create a new PHPMailer instance
          $mail = new PHPMailer;
          //Set who the message is to be sent from
          $mail->setFrom(getParameter('FROMML',$cnx->num),getParameter('FROMNM',$cnx->num));
          //Set who the message is to be sent to
          $mail->addAddress($userToCheck->email, $userToCheck->firstname.' '.$userToCheck->lastname);
          //Set the subject line
          $mail->Subject =  str_replace('__APP__',$appName,file_get_contents(PATHBASE.'/mails/'.$userToCheck->language.'_subject_reset_password.txt'));
          //Read an HTML message body from an external file, convert referenced images to embedded,
          // build URL
          $urlToValidate=getServerROOT().getParameter('APDIR',$cnx->num).'validate.php?k='.$userConfirmationKey.'&lg='.$userToCheck->language;
          //convert HTML into a basic plain-text alternative body
          $messageBody=file_get_contents(PATHBASE.'/mails/'.$userToCheck->language.'_contents_reset_password.html');
          // set name in mail
          $messageBody=str_replace('__NAME__',$userToCheck->firstname.' '.$userToCheck->lastname,$messageBody);
          // set link in mail
          $messageBody=str_replace('__LINK__',$urlToValidate,$messageBody);
          // set app in mail
          $messageBody=str_replace('__APP__',$appName,$messageBody);
          
          $mail->msgHTML($messageBody, dirname(__FILE__));
     
          //send the message, check for errors
          if (!$mail->send()) 
          {
            $msg_warning="Mailer Error: " . $mail->ErrorInfo;
          } 
          else 
          {
            $msg_ok=$msg_reset_email_sent;
          }      
        }
        else
        {
          // email is ko  
          $msg_warning=$msg_unknown_email;  
        }    
      }
      else
      {
        // user is an LDAP user  
        $msg_error=$msg_password_not_locally_managed;    
      }
    }
    else
    {
      // user is unknown  
      $msg_warning=$msg_unknown_user;  
    }
  break;  
}

// if user is not managed by email, the page must not allow to reset a password
if (!getParameter('USACT', $cnx->num))
{
  $msg_error=$msg_feature_not_available;  
}?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title><?php TextDisplay($appName);?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="icon" type="image/png" href="<?php echo $pathImages;?>app/favicon.png" />

<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/global.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/bulle.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/form.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/sweetalert/sweet-alert.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/app.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/buttons.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/forms.css" />

<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>themes/<?php echo getParameter('THEME',$cnx->num);?>/theme.css" />

<?php require_once PATHBASE."js/messages.js.php"; ?>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/global.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/app.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery-ui.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/sweet-alert.min.js"></script>
</head>

<body>

<div class="global">

<!-- START HEADER!-->
<div class="display_header">
  <div class="logo"><img src="<?php echo PATHBASE;?>themes/<?php echo getParameter('THEME',$cnx->num);?>/images/logo.png" border="0" /></div>
  <div class="title"><?php TextDisplay($appName);?></div>  
  <div class="subtitle"><?php if (isset($appSubTitle)) { TextDisplay($appSubTitle);}?></div>
  <div class="languages"><?php
   $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages  ORDER BY language_tag",$cnx->num); 
   $resultsArray=$request->getArrayFields();
   // list languages with link to switch language
   for ($i=0;$i<count($resultsArray);$i++)
   {?>
     <a href="<?php echo setUrlForParam($_SERVER['REQUEST_URI']);?>change_language=<?php echo $resultsArray[$i]['language_tag'];?>" class="std_link link_flag"><img src="<?php echo $pathImages;?>flags/<?php echo $resultsArray[$i]['language_tag'];?>-small.png" border="0"/></a> <?php
   }?>	 
  </div>    
</div>
<div class="sol"></div>
<div class="clearleft"></div>
<!-- END HEADER!-->


<div class="display_body"><?php
    if (isset($msg_ok))
    {?>
      <div class="MessageBox ConfirmationMessageBox"><?php TextDisplay($msg_ok);?></div>   <?php     
    }
    else
    {
      if (isset($msg_error))
      {?>
        <div class="MessageBox ErrorMessageBox"><?php TextDisplay($msg_error);?></div>    <?php
      }
      else
      {
        if (isset($msg_warning))
        {?>
          <div class="MessageBox WarningMessageBox"><?php TextDisplay($msg_warning);?></div><?php
        }?>
          <form  class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>"  method="POST" name="form_user_forgotpass" onkeypress="javascript:if(event.keyCode == 13){CheckFormPassword();}">
	    <fieldset class="fieldset">
	    <input type="hidden" name="connexion" value="on" />
             <legend class="legend"><?php TextDisplay($legend_reset_password);?></legend>
	     <label class="label required_field100" for="Flogin_forgotpass"><?php TextDisplay($text_login);?></label>
             <input class="std_form_field" type="text" name="Flogin_forgotpass" size="18" value=""/><div class="clearleft"></div>
             <label class="label required_field100" ><?php TextDisplay($text_email);?></label>
             <input class="std_form_field" name="form_item_email_forgotpass" type="text" size="50"  value="" /><div class="clearleft"></div>
              
            <div class="clearleft"></div>

	    <div style="margin-top:15px"><?php
              displayButton($button_submit,'','javascript:CheckFormForgottenPassword()','tsc_awb_medium tsc_awb_green tsc_flat');	?>
            </div>  		   
		   
		  </fieldset> 
          </form>
          <script type="text/javascript">document.form_user_forgotpass.Flogin_forgotpass.focus();</script>   <?php 
      }
    }?>
<br />
<div class="back_home std_link"><a href="index.php"><?php TextDisplay($text_back_home);?></a></div> <?php         
    
require_once PATHBASE.'footer.php';?>

