<?php
/**
 * Build an image for burnup chart for complexity
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
define("PATHBASE",'../');
$pathLibraries=PATHBASE.'libraries/';
$pathClasses=PATHBASE.'libraries/classes/';

require_once PATHBASE.'popin_includes_presession.php'; 

require_once $pathLibraries.'jpgraph402/jpgraph.php';
require_once $pathLibraries.'jpgraph402/jpgraph_bar.php';

// Get data of the sprint
require_once PATHBASE.'popin_includes.php';

$request=new sqlRequest('SELECT * FROM kados_releases WHERE release_id='.$_SESSION['current_release_id'],$cnx->num);
$releaseData=$request->getObject();
$request->sqlGet("SELECT sprint_id,sprint_name FROM kados_sprints WHERE sprint_release_id_fk=".$_SESSION['current_release_id']." ORDER BY sprint_start_date");
$sprintsList=$request->getArrayFields();

if (count($sprintsList)!=0)
{

require $pathCommons.'compute_release_data_by_sprint.php';

// set arrays for graphs

$complexityLine=array();
$realCpLine=array();
$sprints=array();

for ($i=0;$i<count($sprintsList);$i++)
{
  $complexityLine[$i]=0; 
  if (isset($complexityBySprint[$sprintsList[$i]['sprint_id']]))
  {
    $complexityLine[$i]=$complexityBySprint[$sprintsList[$i]['sprint_id']];
  }
  $realCpLine[$i]=0; 
  if (isset($complexityDeliveredbySprint[$sprintsList[$i]['sprint_id']]))
  {
    $realCpLine[$i]=$complexityDeliveredbySprint[$sprintsList[$i]['sprint_id']];
  }  
  $sprints[$i]=$sprintsList[$i]['sprint_name'];
}

// Setup the graph
$graph = new Graph(800,480);
$graph->SetScale("textint");

$theme_class=new SoftyTheme;

$graph->SetTheme($theme_class);
$graph->img->SetAntiAliasing();

$graph->SetMargin(50,30,30,00);
$graph->yaxis->HideZeroLabel();
$graph->yaxis->HideLine(false);
$graph->yaxis->HideTicks(false,false);
$graph->xaxis->SetTickLabels($sprints);

$graph->xgrid->Show();
$graph->xgrid->SetLineStyle("solid");
$graph->xgrid->SetColor('#E3E3E3');

$b1plot = new BarPlot($complexityLine);
$b1plot->SetLegend($text_cp_planned_delivery);  
$b2plot = new BarPlot($realCpLine);
$b2plot->SetLegend($text_cp_delivered);

$gbplot = new GroupBarPlot(array($b1plot,$b2plot));
$graph->Add($gbplot);
$b1plot->SetWidth(50);
$b1plot->SetFillColor('#6495ED');
$b1plot->SetColor('#6495ED');
$b1plot->value->Show();
$b1plot->value->SetColor('black');
$b1plot->value->SetFont(FF_FONT1,FS_BOLD);    
$b1plot->value->SetFormat('%d');

$b2plot->SetWidth(50);
$b2plot->SetFillColor('#46BB28');
$b2plot->SetColor('#46BB28');
$b2plot->value->Show();
$b2plot->value->SetColor('black');
$b2plot->value->SetFont(FF_FONT1,FS_BOLD);    
$b2plot->value->SetFormat('%d');

$graph->legend->SetFrameWeight(1);

// Output line
$graph->Stroke();
}
