<?php
/**
 * header.php
 * Standard page header  
 *
 * PHP versions 4 and 5
 *
 * @category Script
 * @package  Project_Mngt:global
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * @link     http://marmotech.free.fr/gestion_chantier 
 * */

require_once PATHBASE.'constants.php';

$pathLibraries=PATHBASE.'libraries/';
$pathClasses=PATHBASE.'libraries/classes/';
$pathAppClasses=PATHBASE.'classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathImages=PATHBASE.'images/';
$pathImagesGeneration=PATHBASE.'generated_images/';

include PATHBASE.'conf/connect.conf';
require_once $pathClasses.'class_connexion_mysql.php';
require_once $pathCommons.'functions.php';
require_once $pathCommons.'getDefaultLanguage.php';

// create a database connexion
$cnx=new connexion_db();    

require_once PATHBASE.'session_settings.php';

if (!isset($_SESSION['menu_lev1'])) {
    $_SESSION['menu_lev1']='none';
}

if (isset($_REQUEST['menu_lev1'])) {
    $_SESSION['menu_lev1']=$_REQUEST['menu_lev1'];
    $_SESSION['menu_lev2']=-1;
}

if (!isset($_SESSION['menu_lev2'])) {
    $_SESSION['menu_lev2']=-1;
}

if (isset($_REQUEST['menu_lev2'])) {
    $_SESSION['menu_lev2']=$_REQUEST['menu_lev2'];
}

if (isset($_POST['form_item_theme']))
{
  $_SESSION['user_theme']=$_POST['form_item_theme'];
}

$flagCheckCurrentProject = isset($flagCheckCurrentProject) ? $flagCheckCurrentProject : false;

// If language is not defined, get the default language from browser and if not defined, French is the default language
if (!isset($_SESSION['language']))
{
  // Set default language using the browser language 
  $request=new sqlRequest("SELECT language_tag FROM framework_languages WHERE language_status=1 ",$cnx->num);
  $availableLanguages=$request->getArrayFirstFieldOnly();
  $browserDefaultLanguage=strtolower(getDefaultLanguage());
  $browserLanguage= ($browserDefaultLanguage=='pt-br') ? 'br' : substr($browserDefaultLanguage,0,2);  
  $_SESSION['language']= in_array($browserLanguage,$availableLanguages) ? $browserLanguage : 'en' ;
}  

// get language change done through the flags
if (isset($_GET['change_language']))
{  
  $request=new sqlRequest("SELECT language_tag FROM framework_languages WHERE language_status=1 ",$cnx->num);
  $availableLanguages=$request->getArrayFirstFieldOnly();
  $changeLanguage=strtolower(substr($_GET['change_language'],0,2));
  $_SESSION['language']=in_array($changeLanguage,$availableLanguages) ? $changeLanguage : 'en' ;
  //update user language in profile
  $request->sqlGet("UPDATE framework_users SET user_language='".$_SESSION['language']."' WHERE user_login='".$_SESSION['login']."'");
}  

// build an array of language tags for date picker
$languageTag=array('fr'=>'fr','de'=>'de','br'=>'pt-BR','es'=>'es','en'=>'en-GB');

// Add libraries and functions
require_once $pathClasses.'class_connexion_mysql_ext.php';
require_once $pathClasses.'class_filters.php';
require_once $pathClasses.'class_workflow.php';
require_once $pathClasses.'class_railway.php';
require_once $pathClasses.'class_ldap.php';
require_once $pathCommons.'date_hour.php';
require_once $pathClasses.'class_sortColumn.php';
require_once $pathClasses.'class_changePage.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_js_messages.php';

require_once $pathCommons.'app_functions.php';
require_once $pathAppClasses.'appUser.php';
require_once $pathAppClasses.'project.php';
require_once $pathAppClasses.'history.php';
require_once $pathAppClasses.'comment.php';
require_once $pathAppClasses.'relationship.php';
require_once $pathAppClasses.'appUtils.php';
require_once $pathAppClasses.'tag.php';
// Include PHP mailer lib
require_once PATHBASE.'libraries/PHPMailer/PHPMailerAutoload.php';

// name of teh current script
$pos=strrpos($_SERVER['PHP_SELF'], '/');
$pos2=strrpos($_SERVER['PHP_SELF'], '?');
if ($pos2) 
{
  $script=substr($_SERVER['PHP_SELF'], $pos+1, $pos2-$pos+1);
} 
else 
{
  $script=substr($_SERVER['PHP_SELF'], $pos+1);
}      

// if project is a one level project, redirect to the Kanban
if (isset($_REQUEST['project_id']))
{
  // get data from project  
  $currentProject=new project($cnx->num,intval($_REQUEST['project_id']));
  $currentProject->getData();
  
  // check user is allowed for the project
  // => project is public or (project is private and user is in the team)
  if (!($currentProject->paramVisibility=='PUB' || ($currentProject->paramVisibility=='PRI' && ($currentProject->isUserStakeholder($_SESSION['login']) || $currentProject->adminLogin==$_SESSION['login'] || $_SESSION['user_profile_tag']=='ADM'))))
  {
    // go back to home  
    header('location:'.getServerURL().'/projects.php');    
  }    
  unset($currentProject);
    
  // check if project id is not null and request is coming from the projects list
  if (intval($_REQUEST['project_id'])!=0 && isset($_REQUEST['fromProjectList']))
  {
    $_SESSION['current_project_id']=intval($_REQUEST['project_id']);
    // reset some session vars
    // tags
    unset($_SESSION['tag_filter_plus_us']);
    unset($_SESSION['tag_filter_minus_us']);        
    unset($_SESSION['tag_filter_plus_task']);
    unset($_SESSION['tag_filter_minus_task']);
    // features
    unset($_SESSION['feature_filter']);
    // stakeholders
    unset($_SESSION['stakeholder_filter']);
    // US color
    unset($_SESSION['filter_us']);
    // Task color
    unset($_SESSION['filter_task']);
    // order
    unset($_SESSION['display_priority']);
    // load user rights
    include_once PATHBASE.'project_get_user_rights.php';
    // set session vars
    // put zero as first value, then search on the array on non-zero value (id) will never send 0 as a result  
    $_SESSION['tag_filter_plus_us']=array(0=>0); 
    $_SESSION['tag_filter_minus_us']=array(0=>0); 
    $_SESSION['tag_filter_plus_task']=array(0=>0); 
    $_SESSION['tag_filter_minus_task']=array(0=>0); 
    // unset session values for scatter plot
    unset($_SESSION['cpl_min']);
    unset($_SESSION['bv_min']);
    unset($_SESSION['cpl_max']);
    unset($_SESSION['bv_max']);
    unset($_SESSION['idZone']);
  }	
}

// set default value for action
if (!isset($_REQUEST['action'])) {
    $_REQUEST['action']='';
}  

/************* REDIRECT *******************************/
// Check is session is correct and someone is logged
if (!isset($_SESSION['login'])) {
    header('location: '.getServerURL().'/index.php');    	
}

// if script needs a check on current project
if ($flagCheckCurrentProject && $_REQUEST['action']!='submit_new_project')
{
  // check session var  
  if (!isset($_SESSION['current_project_id']))
  {
    // go back to projects with a warning message   
    header('location:projects.php?&menu_lev1=projects&msg=no_project_selected');   
  }
}
/************* END REDIRECT *******************************/

// get months names
$_SESSION['annee']=$list_months;
// set delay for hidding messages
$delayMsg=2000;

// Get menu level 1 from database	
$menus_lev1=array();
$menus_lev2=array();
$sqlMenus="SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
           FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
           WHERE menu_father='' AND menu_translation_language='".$_SESSION['language']."' 
             AND menu_tag=framework_menus_translations.menu_tag_fk AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
             AND profile_id_fk=".$_SESSION['user_profile']." 
             AND (menu_category='PROJECT' OR  menu_category='HOME'  )
           ORDER BY menu_order";
$request=new sqlRequest($sqlMenus,$cnx->num);
$menus_lev1=$request->getArrayFields();

if ($_SESSION['menu_lev1']!='none')
{
  // Get menu level 2 from database
  $request->sqlGet("SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                    FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
                    WHERE menu_father='".$_SESSION['menu_lev1']."' 
                      AND menu_translation_language='".$_SESSION['language']."' 
                      AND menu_tag=framework_menus_translations.menu_tag_fk 
                      AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
                      AND profile_id_fk=".$_SESSION['user_profile']." 
                    ORDER BY menu_order");  
  $menus_lev2=$request->getArrayFields();

  if ($_SESSION['menu_lev2']==-1)
  {
    // Get a the default menu (if exists) for the level2
    $request->sqlGet("SELECT menu_tag FROM framework_menus,framework_profiles_constitution_menus WHERE menu_father='".$_SESSION['menu_lev1']."' AND menu_tag=menu_tag_fk AND profile_id_fk=".$_SESSION['user_profile']."  AND menu_default=1 ORDER BY menu_order");
    $request->countRows();
    if ($request->rowCount!=0)
    {
      $request->getObject();
	  $_SESSION['menu_lev2']=$request->objet->menu_tag;
    }
  }
} 

$imgRailway='railway.png';
$allowedScripts=array();
// Check if the user can access the page
$request->sqlGet("SELECT menu_item 
                  FROM ( SELECT SUBSTRING(TRIM(TRAILING '?' FROM menu_file),LENGTH(menu_file)-LOCATE('/',REVERSE(menu_file))+2) AS menu_item
                         FROM framework_menus,framework_profiles_constitution_menus 
                         WHERE menu_tag_fk=menu_tag AND profile_id_fk=".$_SESSION['user_profile']."
                         UNION 
                         SELECT SUBSTRING(TRIM(TRAILING '?' FROM menu_file),LOCATE('/',menu_file)+1)  AS menu_item
                         FROM framework_menus,framework_profiles_constitution_menus 
                         WHERE menu_tag_fk=menu_tag AND profile_id_fk=".$_SESSION['user_profile'].") AS list_menus 
                  WHERE menu_item!=''");
$allowedScripts=$request->getArrayFirstFieldOnly();

// check if page allowed by profile
if (!in_array($script,$allowedScripts)) 
{
  $menu_lev1=array();
  // if there is an user profile
  if (isset($_SESSION['user_profile']))
  {    
    // build menus   
    $sqlMenus="SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
              FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
              WHERE menu_father='' AND menu_translation_language='".$_SESSION['language']."' 
                AND menu_tag=framework_menus_translations.menu_tag_fk 
                AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
                AND profile_id_fk=".$_SESSION['user_profile']." ORDER BY menu_order";
    $request=new sqlRequest($sqlMenus,$cnx->num);
    $menu_lev1=$request->getArrayFields();		
    $_SESSION['menu_lev1']=$menu_lev1[0]['tag'];	
    // go to home page
    header('location:'.getServerURL().'/'.$menu_lev1[0]['file']);
  }
  else
  {
    // else, go back to index  
    header('location:'.getServerURL().'/index.php');  
  } 
}

include_once PATHBASE.'project_switch_cases_adding.php';

// if a project is selected
if (isset($_SESSION['current_project_id']))
{
  // get data from project  
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
  $currentProject->getData();
    
  /*if ($currentProject->level==1 && $script=='project_cockpit.php')
  {
    header('location: ./manage_kanban.php?&menu_lev2=prj_kanban');	  
  }*/	
} 

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title><?php TextDisplay($appName);?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="icon" type="image/png" href="<?php echo $pathImages;?>app/favicon.png" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/global.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/form.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/filters.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/app.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/switch.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/buttons.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/forms.css" />

<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>themes/<?php echo $_SESSION['user_theme'];?>/theme.css" />

<link rel="stylesheet" type="text/css" href="<?php echo $pathLibraries;?>fancybox/jquery.fancybox-1.3.4.css" media="screen" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/colorpicker.css" type="text/css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/peppergrinder/jquery-ui.min.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/peppergrinder/jquery-ui.theme.min.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/jquery.qtip.min.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/customInput.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/xbreadcrumbs.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/sweetalert/sweet-alert.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/chosen.min.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/menu.css" />

<?php require_once PATHBASE."js/messages.js.php"; ?>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/global.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/app.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery-ui.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery.qtip.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery.ui.touch-punch.min.js"></script>
<script type="text/javascript" src="<?php echo $pathLibraries;?>fancybox/jquery.fancybox-1.3.4.pack.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/colorpicker.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/customInput.jquery.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/xbreadcrumbs.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/sweet-alert.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/chosen.jquery.min.js"></script>

<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/i18n/datepicker-fr.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/i18n/datepicker-es.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/i18n/datepicker-de.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/i18n/datepicker-pt-BR.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/i18n/datepicker-en-GB.js"></script>

<script type="text/javascript" src="<?php echo PATHBASE;?>js/script.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/validate.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/poof.js"></script>

<style type="text/css"><?php
  $colorListText='';
  $request->sqlGet('SELECT * FROM kados_colors');
  $colorList=$request->getArrayFields();
  for ($i=0;$i<count($colorList);$i++)
  {?>
  .<?php echo $colorList[$i]['color_name'];?>{
    background-color:#<?php echo $colorList[$i]['color_value'];?>;
    border-top:solid #<?php echo $colorList[$i]['color_border_value'];?> 4px;	
    background: -webkit-linear-gradient(top, #<?php echo $colorList[$i]['color_value'];?> 30%,#FFFFFF 100%); /* Chrome10+,Safari5.1+ */
    background: linear-gradient(#<?php echo $colorList[$i]['color_value'];?> 30%,#FFFFFF 100%); /* W3C; A catch-all for everything else */         
  }   <?php
  $colorListText.=$colorList[$i]['color_name'].' ';  
  }
  for ($i=0;$i<count($colorList);$i++)
  {?>
  .<?php echo $colorList[$i]['color_name'];?>_bg{
    background-color:#<?php echo $colorList[$i]['color_value'];?>;
   background: -webkit-linear-gradient(top, #<?php echo $colorList[$i]['color_value'];?> 30%,#FFFFFF 100%); /* Chrome10+,Safari5.1+ */
    background: linear-gradient(#<?php echo $colorList[$i]['color_value'];?> 30%,#FFFFFF 100%); /* W3C; A catch-all for everything else */      
    }   <?php
  }  
  ?>
</style>

</head>

<body>
<script>
 $.datepicker.setDefaults( $.datepicker.regional["<?php echo $languageTag[$_SESSION['language']];?>"] );  
 </script>
<div class="global">
<div class="colorList"><?php echo $colorListText;?></div>

<span class="hidden-pathBase"><?php echo PATHBASE;?></span>
<div id="menu">
<!-- START HEADER!-->
<div class="display_header">
  <div class="logo_title">
    <div class="logo"><img src="<?php echo PATHBASE;?>themes/<?php echo $_SESSION['user_theme'];?>/images/logo.png" border="0" /></div>  
    <div class="title"><?php TextDisplay($appName);?></div>
  </div>    
  <div class="menu_lev1">
  <div <?php 
  // display home with a small house (first e,ntry of the menu)
   if ($menus_lev1[0]['tag']==$_SESSION['menu_lev1'])  {
     echo 'class="elt_menu_img_select"';  } 
   else  { echo 'class="elt_menu_img"'; } ?>><a href="<?php echo PATHBASE.$menus_lev1[0]['file'];?>&menu_lev1=<?php echo $menus_lev1[0]['tag']; ?>" ><img src="<?php echo $pathImages;?>app/home.png" border="0" title="<?php echo $menus_lev1[0]['titre']?>" /></a>
  </div><?php

if (isset($_SESSION['current_project_id']))
{
  // display menu for level 1
  for ($i=1;$i<count($menus_lev1);$i++) {?>
    <div class="dropdown floating_left">  
    <div <?php 
    if ($menus_lev1[$i]['tag']==$_SESSION['menu_lev1']) {
        echo 'class="elt_menu_select"'; 
    } else {
        echo 'class="elt_menu"';
    } ?>><a href="<?php echo PATHBASE.$menus_lev1[$i]['file'];?>&menu_lev1=<?php echo $menus_lev1[$i]['tag']; ?>" ><?php echo $menus_lev1[$i]['titre']?></a></div><?php
          // Get menu level 2 from database
          $request->sqlGet("SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                            FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
                            WHERE menu_father='".$menus_lev1[$i]['tag']."' 
                              AND menu_translation_language='".$_SESSION['language']."' 
                              AND menu_tag=framework_menus_translations.menu_tag_fk 
                              AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
                              AND profile_id_fk=".$_SESSION['user_profile']." 
                            ORDER BY menu_order");  
          $menus_lev2=$request->getArrayFields();         
          // set menu if any level 2 menus
          if (count($menus_lev2)!=0)
          {?>
            <div class="dropdown-content menu_level2 less_padding"><?php 
            for ($j=0;$j<count($menus_lev2);$j++) 
            {?>
              <a href="<?php echo PATHBASE.$menus_lev2[$j]['file'];?>&menu_lev1=<?php echo $menus_lev1[$i]['tag']; ?>&menu_lev2=<?php echo $menus_lev2[$j]['tag']; ?>" class="menu_link_level2"><?php echo $menus_lev2[$j]['titre'];?></a><br /><?php
            }?>
            </div><?php
          }?>        
    </div><?php
  }
}?>
  </div><!-- FIN du menu niveau1!-->
    <?php
        // get admin and global config menu
        $request->sqlGet("SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                          FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
                          WHERE menu_translation_language='".$_SESSION['language']."' 
                            AND menu_tag=framework_menus_translations.menu_tag_fk AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
                            AND profile_id_fk=".$_SESSION['user_profile']." 
                            AND (menu_category='ADMIN' OR menu_father='admin'    )
                          ORDER BY menu_father,menu_order");
        $menuAdmin=$request->getArrayFields();    
        // get user menu
        $request->sqlGet("SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                          FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
                          WHERE menu_translation_language='".$_SESSION['language']."' 
                            AND menu_tag=framework_menus_translations.menu_tag_fk AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
                            AND profile_id_fk=".$_SESSION['user_profile']." 
                            AND (menu_category='CONFIG' OR menu_father='app_admin')
                          ORDER BY menu_father,menu_order");
        $menuConfig=$request->getArrayFields();      
        
// if no admin menu, do not display the menu img
if ((count($menuAdmin)+count($menuConfig))!=0)
{?>  
  <div class="dropdown floating_right">
     <div id="link_admin" class="dropbtn"><img src="<?php echo PATHBASE;?>images/settings.png" />
        <div id="menu_admin" class="dropdown-content"> <?php
           if (count($menuAdmin)!=0)  
           {
             echo '<div class="menu_category">'.$menuAdmin[0]['titre'].'</div>';
             for($i=1;$i<count($menuAdmin);$i++)
             {?>
               <a href="<?php echo PATHBASE.$menuAdmin[$i]['file'];?>&menu_lev1=<?php echo $menuAdmin[$i]['tag']; ?>" class="menu_link_level2"><?php echo $menuAdmin[$i]['titre']?></a><br /><?php
             }
           }
           if (count($menuConfig)!=0)  
           {           
             echo '<div class="menu_category">'.$menuConfig[0]['titre'].'</div>';
             for($i=1;$i<count($menuConfig);$i++)
             {?>
               <a href="<?php echo PATHBASE.$menuConfig[$i]['file'];?>&menu_lev1=<?php echo $menuConfig[$i]['tag']; ?>" class="menu_link_level2"><?php echo $menuConfig[$i]['titre']?></a><br /><?php
             }             
           } ?>
        </div>
     </div> 
  </div><?php
  }?>
  
  <div class="dropdown floating_right">
      <div id="link_user"><img src="<?php echo PATHBASE;?>themes/<?php echo $_SESSION['user_theme'];?>/images/bonhomme.png" /><?php
      
        $request->sqlGet("SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                          FROM framework_menus,framework_menus_translations,framework_profiles_constitution_menus 
                          WHERE menu_translation_language='".$_SESSION['language']."' 
                            AND menu_tag=framework_menus_translations.menu_tag_fk AND menu_tag=framework_profiles_constitution_menus.menu_tag_fk 
                            AND profile_id_fk=".$_SESSION['user_profile']." 
                            AND (menu_category='USER ' OR menu_father='my_profile')    
                          ORDER BY menu_father,menu_order");
        $menuUser=$request->getArrayFields();      ?>
       <div id="menu_user" class="dropdown-content" <?php if ((count($menuAdmin)+count($menuConfig))==0) { echo 'style="right:0px;"';}?>><?php
             for($i=0;$i<count($menuUser);$i++)
             {?>
               <a href="<?php echo PATHBASE.$menuUser[$i]['file'];?>&menu_lev1=<?php echo $menuUser[$i]['tag']; ?>"  class="menu_link"><?php echo $menuUser[$i]['titre']?></a><br /><?php
             }
        // languages     
        // get available languages
   $request=new sqlRequest("SELECT language_tag FROM framework_languages WHERE language_status=1 ORDER BY language_tag",$cnx->num); 
   $resultsArray=$request->getArrayFirstFieldOnly();
   // check if there is a language status change done by admin
   if (isset($_GET['language_tag']) && isset($_GET['situation']))
   {
     // if language is added to the availability list  
     if ($_GET['situation']==1)  
     {
       // current list must be updated  
       $resultsArray[]=$_GET['language_tag'];
     }
     else
     {
       // else language is removed of the list 
       $pos=array_search($_GET['language_tag'],$resultsArray);  
       // and current list must be uodated
       unset($resultsArray[$pos]);
     }
   }    
   // sort list in order to always have the same order even after some changes
   sort($resultsArray);
   // list languages with link to switch language
   for ($i=0;$i<count($resultsArray);$i++)
   {?>
     <a href="<?php echo setUrlForParam($_SERVER['PHP_SELF']);?>change_language=<?php echo $resultsArray[$i];?>" class="std_link link_flag"><img src="<?php echo $pathImages;?>flags/<?php echo $resultsArray[$i];?>-small.png" border="0"/></a> <?php
   }?>	    <br />           
             <a href="<?php echo PATHBASE;?>index.php?connexion=off" class="menu_link"><?php echo $text_logout;?></a>  
         </div>
      </div>
  </div>   
  <div class="username"><?php echo $_SESSION['user_fullname'];?></div>
</div>
<div class="sol"></div>
<div class="clearleft"></div>
<!-- END HEADER!-->

</div>

<div class="display_body"><?php

// Set for the app
require_once PATHBASE.'railway_set_level.php';
$businessValueDefault='0';
// change product backlog view
if (isset($_REQUEST['mode_pbl']))
{
  $_SESSION['mode_pbl']=$_REQUEST['mode_pbl'];
}
// start product backlog mode if not exist
if (!isset($_SESSION['mode_pbl']))
{
  $_SESSION['mode_pbl']='std';
}
// start deck if not exist
if (!isset($_SESSION['us_deck_content']))
{
  $_SESSION['us_deck_content'][0]=0;
  // Get the deck storage of the user
  $request->sqlGet("SELECT item_id_fk FROM kados_users_decks WHERE user_login_fk='".$_SESSION['login']."' AND item_type='us'");
  $_SESSION['us_deck_content']=array_merge($_SESSION['us_deck_content'],$request->getArrayFirstFieldOnly());
}

// show or hide release or sprint in kanban
// and features in their kanban
switch ($_REQUEST['action'])
{
	case 'show_in_kanban':
          // Show Release for everybody
	  if (isset($_REQUEST['release2show']))
	  {
            // update visibility to true in releases table for the release
	    $request=new sqlRequest("UPDATE kados_releases SET visibility=1 WHERE release_id=".$_REQUEST['release2show'],$cnx->num);
	  }	
          // Show Sprint for everybody
	  if (isset($_REQUEST['sprint2show']))
	  {
            // update visibility to true in sprints table for the sprint
	    $request=new sqlRequest("UPDATE kados_sprints SET visibility=1 WHERE sprint_id=".$_REQUEST['sprint2show'],$cnx->num);
	  }	
          // Show Feature for user
	  if (isset($_REQUEST['feature2show']))
	  {
            // delete line for user in hidden features table  
	    $request=new sqlRequest("DELETE 
                                     FROM kados_users_hidden_features 
                                     WHERE user_login_fk='".$_SESSION['login']."'
                                       AND feature_id_fk=".$_REQUEST['feature2show'],$cnx->num);
	  }          
	break;
	
	case 'hide_in_kanban';
          // hide Release for everybody
	  if (isset($_REQUEST['release2hide']))
	  {	
            // update visibility to false in release table for the release
	    $request=new sqlRequest("UPDATE kados_releases SET visibility=0 WHERE release_id=".$_REQUEST['release2hide'],$cnx->num);	
	  }	
          // hide sprint for everybody
	  if (isset($_REQUEST['sprint2hide']))
	  {	
            // update visibility to false in sprints table for the sprint  
	    $request=new sqlRequest("UPDATE kados_sprints SET visibility=0 WHERE sprint_id=".$_REQUEST['sprint2hide'],$cnx->num);	
	  }		
          // Hide feature for user
	  if (isset($_REQUEST['feature2hide']))
	  {
            // add line for user in hidden features table    
	    $request=new sqlRequest("INSERT INTO kados_users_hidden_features 
                                       (user_login_fk,feature_id_fk)
                                     VALUES('".$_SESSION['login']."',".$_REQUEST['feature2hide'].")",$cnx->num);
	  }           
	break;    
}