<?php
  class mtLdap
  {
    var $ldap_cnx;
    var $base_dn=LDAP_BASE_DN;
    var $justthese;
    var $all_infos;
    var $uid_field=LDAP_UID_FIELD;
    var $name_field=LDAP_NAME_FIELDS_NAME;
    var $firstname_field=LDAP_NAME_FIELDS_FIRSTNAME;
    var $fullname_field=LDAP_NAME_FIELDS_FULLNAME;
    var $entry;
    var $bind_dn=LDAP_BIND_DN;
    var $bind_pass=LDAP_BIND_PASS;
    var $userObjectClass=LDAP_USER_OBJECTCLASS;
    
    function mtLdap()
    {
      $this->ldap_cnx=ldap_connect(LDAP_SERVER,LDAP_PORT);
      ldap_set_option($this->ldap_cnx, LDAP_OPT_PROTOCOL_VERSION, 3);
      ldap_set_option($this->ldap_cnx, LDAP_OPT_REFERRALS, 0);	      
      if ($this->bind_dn!='')
      {    
        $ldapbind = ldap_bind($this->ldap_cnx, $this->bind_dn, $this->bind_pass);
      }
      else
      {
        $ldapbind = ldap_bind($this->ldap_cnx);              
      }
      $this->cache=array();
      $this->justthese=explode(",",LDAP_ATTRIBUTES);
      $this->all_infos=explode(",",LDAP_ALL_ATTRIBUTES);
      array_push($this->justthese,$this->uid_field);
      array_push($this->all_infos,$this->uid_field);
    }

    function name($userId)
    {
      $userIdTmp=strtolower($userId);
      if (!in_array($userIdTmp,$this->cache))
      {		
        $filter="(|(".$this->uid_field."=".$userIdTmp."))";
        $results=ldap_search($this->ldap_cnx,$this->base_dn,$filter,$this->justthese);	
        $infos=ldap_get_entries($this->ldap_cnx, $results);
	if ($infos['count'])
        {
	  $this->cache[$userIdTmp]=$infos[0][$this->name_field][0];	
        }
	else
        {
	  $this->cache[$userIdTmp]="User unknown";  
        }
      }	
      return $this->cache[$userIdTmp];
    }

    function uidValid($userId)
    {
      $filter="(|(".$this->uid_field."=".strtolower($userId)."))";
      $results=ldap_search($this->ldap_cnx,$this->base_dn,$filter,$this->justthese);	
      $infos=ldap_get_entries($this->ldap_cnx, $results);
      return $infos['count'];
    }

    function getData($userId)
    {
      $filter="(&(objectclass=".$this->userObjectClass.")(".$this->uid_field."=".strtolower($userId)."))";
      $results=ldap_search($this->ldap_cnx,$this->base_dn,$filter,$this->justthese);	
      $infos=ldap_get_entries($this->ldap_cnx, $results);
      $user=new stdClass();
      $user->firstname=isset($infos[0][$this->firstname_field]) ? $infos[0][$this->firstname_field][0] : '';
      $user->lastname=isset($infos[0][$this->name_field]) ? $infos[0][$this->name_field][0] :'';	  
      $user->name=$user->firstname.' '.$user->lastname;
      if (isset($infos[0]['mail'][0]))
      {  $user->mail=$infos[0]['mail'][0]; }
      else
      {  $user->mail="no_mail"; }
      return $user;
    }	

    function searchNameCountHits($searched_name,$searched_firstname)
    {
      // if firstname is used, filter has to be adapted
      if ($searched_firstname!="" && $this->firstname_field!='')
      {
        $filter="(&(".$this->name_field."=*".$searched_name."*)(".$this->firstname_field."=*".$searched_firstname."*))";
      }	
      else
      {
        $filter="(|(".$this->name_field."=*".$searched_name."*))";	  
      }
      $results=ldap_search($this->ldap_cnx,$this->base_dn,$filter,$this->justthese);	
      return ldap_count_entries($this->ldap_cnx, $results);
    }	  
	
    function searchName($searched_name,$searched_firstname,&$nb_total,$depart=0,$nb=10)
    {
      // if firstname is used, filter has to be adapted
      if ($searched_firstname!="" && $this->firstname_field!='')
      {
        $filter="(&(".$this->name_field."=*".$searched_name."*)(".$this->firstname_field."=*".$searched_firstname."*))";
      }	
      else
      {
        $filter="(|(".$this->name_field."=*".$searched_name."*))";	  
      }
      $results=ldap_search($this->ldap_cnx,$this->base_dn,$filter,$this->justthese);	
      $nb_total=ldap_count_entries($this->ldap_cnx, $results);
      $infos=ldap_get_entries($this->ldap_cnx, $results);
      $nb_resultats=min($depart+$nb,$infos['count']);
      $cpt=0;
      $tablo=array();
      for ($i=$depart;$i<$nb_resultats;$i++)
      {
        $tablo[$cpt][$this->uid_field]=$infos[$i][$this->uid_field][0];
	$user=$this->getData($tablo[$cpt][$this->uid_field]);
        $tablo[$cpt]['name']=$user->firstname." ".$user->lastname;	
 	$tablo[$cpt++]['mail']=$user->mail;
      }
      return $tablo;
    }	
	
    function authenticate($userId,$pass)
    {
      $userIdTmp=strtolower($userId);
      if ($userIdTmp!="" && $pass!="")
      {
        $filter="(|(".$this->uid_field."=".$userIdTmp."))";
        $results=ldap_search($this->ldap_cnx,$this->base_dn,$filter,$this->justthese);	
        $infos=ldap_get_entries($this->ldap_cnx, $results);
        if ($infos['count']!=0)
	{
          return @ldap_bind($this->ldap_cnx, $infos[0]['dn'], $pass); 
        }
	else
	  return false;
      }
      else
        return false;
    }
	
    function mtLdapClose()
    {
      ldap_close($this->ldap_cnx);	
    }
  }?>