<?php
/**
 * Main page to manage tasks in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

if (!isset($_REQUEST['object_id']))
{
  $_REQUEST['object_id']=0;
}

$itemType='pbl_tasks';
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);

/* Dashboard settings */
include PATHBASE.'dashboard_settings.php';

// Select list of columns					 
$request->sqlGet("SELECT column_tag,column_name,column_usage,column_meaning 
	          FROM kados_template_columns,kados_projects_columns
		  WHERE column_tag=column_tag_fk 
                    AND project_id_fk=".$_SESSION['current_project_id']."
		  ORDER BY column_order");				   
$request->getArrayFields();

$colsMaxNumber=1;
if ($currentProject->level==1)
{
  $colsMaxNumber=$request->rowCount;
}	

$arrayStatus=array();
$arrayStatusX=array();

// Allocate columns
for ($i=0;$i<$colsMaxNumber;$i++)
{
  // Column width, except if visibility is 0
  $arrayStatusX[$request->array[$i]['column_tag']]=$columnWidth*$i;
  // column name
  $arrayStatus[$i]['colName']=$request->array[$i]['column_name'];  
  // column tip
  $arrayStatus[$i]['colMeaning']=$request->array[$i]['column_usage'];  
  // if column meaning is not the default one, but a project custom, change for the custom
  if ($request->array[$i]['column_meaning']!='')
  {
    $arrayStatus[$i]['colMeaning']=$request->array[$i]['column_meaning'];  
  }	
  
}
/* Buttons settings */
$allowAddInFirstColumn=in_array('ADDTASK',$_SESSION['user_actions']) || in_array('ADDTASK',$_SESSION['user_local_actions']);
// if no column, tasks can not be created, disable task creation
if ($colsMaxNumber==0)
{
  $allowAdd=false;
}
$buttonAdd=$button_add_task;
$buttonAddImage='app/add_task.png';
$targetAdd='';

$allowDelete=in_array('DELTASK',$_SESSION['user_actions']) || in_array('DELTASK',$_SESSION['user_local_actions']);
$allowOrder=in_array('ORDTASK',$_SESSION['user_actions']) || in_array('ORDTASK',$_SESSION['user_local_actions']);
$allowUpdate=in_array('UPDTASK',$_SESSION['user_actions']) || in_array('UPDTASK',$_SESSION['user_local_actions']);
$allowMove=in_array('MOVE_TASK',$_SESSION['user_actions']) || in_array('MOVE_TASK',$_SESSION['user_local_actions']);

$allowActionHeaderStamp=true;

$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;

$otherFieldsInsert=',us_id_fk';
$otherFieldsInsertValues=','.$_REQUEST['object_id'];

$otherFieldsInsertUS=',us_project_id_fk';
$otherFieldsInsertValuesUS=','.$_SESSION['current_project_id'];

$firstColumnStatic=true;
$firstColumnDisplayParentZone=true;
$firstColumnDisplayWarningZone=true;
$firstColumnTitle='Product Backlog';
$firstColumnObjectTag='US';
$firstColumnFunctionForHeaderStamp='displayStatusImageButton';
$functionForHeaderStamp='displayTaskInitLoad';
$initialValue=getInitialStatus($_SESSION['current_project_id']);
$finalStatus=getFinalStatus($_SESSION['current_project_id']);

include PATHBASE.'boards_settings/settings_'.$itemType.'.php';

// generic actions for postit
include PATHBASE.'boards_actions/actions_items.php';
// specific actions for tasks
include PATHBASE.'boards_actions/actions_tasks.php';
// specific actions for us, since they can be updated directly on the board
include PATHBASE.'boards_actions/actions_us.php';
// display railway (here to compte US count after US creation)
include PATHBASE.'railway_display.php';

// if no column, tasks can not be created, display a message
if ($colsMaxNumber==0)
{ 
  if (in_array('ADDTASK',$_SESSION['user_actions']) || in_array('ADDTASK',$_SESSION['user_local_actions']))
  {?>
    <div class="MessageBox WarningMessageBox"><?php echo $msg_steps_to_add_tasks_design_columns_and_settings_access;?> <a href="project_columns.php?menu_lev1=settings&menu_lev2=prj_columns" ><?php echo $text_click_here;?></a></div><?php
  }
  else
  {?>
    <div class="MessageBox WarningMessageBox"><?php echo $msg_steps_to_add_tasks_design_columns_and_settings_no_access;?></div><?php		  
  }		  
}

$deckIsAvailable=false;
if ($currentProject->level==1)
{
  $firstColumnEnableUpdateFunction=true;
  $simpleItemParentType='us';
  // Get Deck actions
  $deckIsAvailable=true;
  $displayMyTasks=true;  
  $usFieldForOrderMatrix='kados_user_stories.ypos';  
  require_once PATHBASE.'deck_management.php';
  // if user is allowed to add US, display button
  if (in_array('ADD_US',$_SESSION['user_actions']) || in_array('ADD_US',$_SESSION['user_local_actions']))
  {
    $allowAdd=true;
    $buttonAdd=$button_add_user_story;
    $targetAdd=PATHBASE.'boards_buttons/add_us.php?item_type=us_project&us_from='.($itemType=='us_release' ? 'release' : '');
  } 
}  
else
{
  // get filter computation for US
  include_once $pathCommons.'filter_us_compute.php';

  // Get US of the sprint
  if ($flagJoinTasks)
  {
    $request=new sqlRequest("SELECT us_id AS parent_id,us_number AS display_number,
                                    kados_user_stories.text,
                                    kados_user_stories.status AS header_stamp,
                                    kados_user_stories.color,
                                    business_value AS infoBottomLeft,complexity AS infoBottomRight,
                                    us_link AS link,
                                    us_creator AS creator,
                                    us_creation_date AS creation_date,
                                    us_last_update_date AS last_update,
                                    us_last_updater AS last_updater  
                             FROM kados_user_stories,kados_tasks  
                             WHERE kados_user_stories.active=1 
                               AND kados_tasks.active=1     
                               AND us_id_fk=us_id  
 		               AND us_project_id_fk=".$_SESSION['current_project_id']." 
			       AND us_release_id_fk=0 
			       ".$clauseWhereUsFilter." 
			     ORDER BY zpos_r ASC",$cnx->num);      
  }
  else
  {
    $request=new sqlRequest("SELECT us_id AS parent_id,us_number AS display_number,text,
                                    status AS header_stamp,color,
                                    business_value AS infoBottomLeft,complexity AS infoBottomRight,
                                    us_link AS link,
                                    us_creator AS creator,
                                    us_creation_date AS creation_date,
                                    us_last_update_date AS last_update,
                                    us_last_updater AS last_updater  
                             FROM kados_user_stories 
		             WHERE active=1 AND us_project_id_fk=".$_SESSION['current_project_id']." 
			       AND us_release_id_fk=0 
			       ".$clauseWhereUsFilter." 
			     ORDER BY zpos_r ASC",$cnx->num);
  }
  $MultipleItemsArray=$request->getArrayFields();

}

// get project stakeholders
$stakeholdersProjects=$currentProject->getStakeholdersAllowedToMoveTasksUsernames();
$projectUsers=$currentProject->getStakeholders();

// If there are at least one user story
//if ($currentProject->level==1)
$displayParentZone=false;
$showFilterUs=true;
$showFilterTask=true;
$displayNoUser=true;  
$forceDisplayDashBoardTitles=true;  

$displayTopButtons=true;
$displaySortByNumberButton=false;  

if ($currentProject->level==2)
{?>
  <div class="MessageBox InformationMessageBox"><?php echo $msg_early_dashboard_level2;?></div><?php  
}
else if ($currentProject->level==3)
{?>
  <div class="MessageBox InformationMessageBox"><?php echo $msg_early_dashboard_level3;?></div><?php  
}    
// Display order buttons => order all tasks for all US
$targetButtonOrder=$targetFileAction.'&action=order_all_tasks_compact&tasks2order='.implode('_',array_column($MultipleItemsArray,'parent_id'));
$targetButtonOrderExtended=$targetFileAction.'&action=order_all_tasks_extended&tasks2order='.implode('_',array_column($MultipleItemsArray,'parent_id'));
// if project with 2 or 3 levels, it is an early dashboard, then add a back button
if ($currentProject->level>=2)
{
  $allowAdd=false;
  $displayBackToRoadmapButton=true;
} 
include PATHBASE.'matrix_display.php';?>