<?php
/**
 * Main page to manage tasks in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

if (!isset($_REQUEST['object_id']))
{
  $_REQUEST['object_id']=0;
}

$itemType='rbl_tasks';
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);

/* Dashboard settings */
include PATHBASE.'dashboard_settings.php';

// Select list of columns					 
$request->sqlGet("SELECT column_tag,column_name,column_usage,column_meaning 
	          FROM kados_template_columns,kados_projects_columns
		  WHERE column_tag=column_tag_fk AND project_id_fk=".$_SESSION['current_project_id']."
		  ORDER BY column_order");				   
$request->getArrayFields();	

// set column to one, assuming we are in an early dashboard for release
$colsMaxNumber=1;
// If project is a 2-levels projects, then we are not in early dashboard but the tasks dashboard
if ($currentProject->level==2)
{
  $colsMaxNumber=$request->rowCount;
}
// Init dashboard columns
$arrayStatus=array();
$arrayStatusX=array();

// Allocate columns
for ($i=0;$i<$colsMaxNumber;$i++)
{	 
  // X position of the column (since postit have only the x-position in a column, not an absolute position  
  $arrayStatusX[$request->array[$i]['column_tag']]=$columnWidth*$i;
  // store column name
  $arrayStatus[$i]['colName']=$request->array[$i]['column_name'];  
  // store column usage, that is to say the local meaning for the current project 
  $arrayStatus[$i]['colMeaning']=$request->array[$i]['column_usage'];
  // If there is no usage, use the global meaning for column
  if ($request->array[$i]['column_meaning']!='')
  {
    $arrayStatus[$i]['colMeaning']=$request->array[$i]['column_meaning'];  
  }	
  
}
/* Buttons settings */
$displayTopButtons=false;
$allowAddInFirstColumn=in_array('ADDTASK',$_SESSION['user_actions']) || in_array('ADDTASK',$_SESSION['user_local_actions']);
// if no column, tasks can not be created, disable task creation
if ($colsMaxNumber==0)
{
  $allowAdd=false;
}
// set label and image for button
$buttonAdd=$button_add_task;
$buttonAddImage='app/add_task.png';

// get actions rights for current user based on actions available in global profile and local profile
// delete postits
$allowDelete=in_array('DELTASK',$_SESSION['user_actions']) || in_array('DELTASK',$_SESSION['user_local_actions']);
// get order postit right
$allowOrder=in_array('ORDTASK',$_SESSION['user_actions']) || in_array('ORDTASK',$_SESSION['user_local_actions']);
// get update postit right
$allowUpdate=in_array('UPDTASK',$_SESSION['user_actions']) || in_array('UPDTASK',$_SESSION['user_local_actions']);
// get move postit right
$allowMove=in_array('MOVE_TASK',$_SESSION['user_actions']) || in_array('MOVE_TASK',$_SESSION['user_local_actions']);

// allow action on the top right of a postit
$allowActionHeaderStamp=true;

// get order buttons labels
$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;

// set param for SQL insertion. Since inserted object are tasks, they must be linked to an US
$otherFieldsInsert=',us_id_fk';
$otherFieldsInsertValues=','.$_REQUEST['object_id'];

// If US are inserted, set SQL fields
$otherFieldsInsertUS=',us_release_id_fk,us_project_id_fk';
$otherFieldsInsertValuesUS=','.$_SESSION['current_release_id'].','.$_SESSION['current_project_id'];

// set param for dashboard
// set first column with static postits
$firstColumnStatic=true;
// set display of parent zone at the top left above a postit in the static column
$firstColumnDisplayParentZone=true;
// set display of warning zone at the top right above a postit in the static column
$firstColumnDisplayWarningZone=true;
// Set Title for first column
$firstColumnTitle='Release Backlog';
$firstColumnObjectTag='US';
$firstColumnFunctionForHeaderStamp='displayStatusImageButton';
$functionForHeaderStamp='displayTaskInitLoad';

// Get initial and final status for tasks, based on project config
$initialValue=getInitialStatus($_SESSION['current_project_id']);
$finalStatus=getFinalStatus($_SESSION['current_project_id']);

// get settings for the type of postit
include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
include PATHBASE.'boards_actions/actions_items.php';

// generic actions for postit
include PATHBASE.'boards_actions/actions_items.php';
// specific actions for tasks
include PATHBASE.'boards_actions/actions_tasks.php';
// display railway (here to compte US count after US creation)
include PATHBASE.'railway_display.php';

// if no column, tasks can not be created, display a message
if ($colsMaxNumber==0)
{ 
  if (in_array('ADDTASK',$_SESSION['user_actions']) || in_array('ADDTASK',$_SESSION['user_local_actions']))
  {?>
    <div class="MessageBox WarningMessageBox"><?php echo $msg_steps_to_add_tasks_design_columns_and_settings_access;?> <a href="project_columns.php?menu_lev1=settings&menu_lev2=prj_columns" ><?php echo $text_click_here;?></a></div><?php
  }
  else
  {?>
    <div class="MessageBox WarningMessageBox"><?php echo $msg_steps_to_add_tasks_design_columns_and_settings_no_access;?></div><?php		  
  }		  
}

$deckIsAvailable=false;
if ($currentProject->level==2)
{
  // Get Deck actions
  $deckIsAvailable=true;
  $displayMyTasks=true;  
  $usFieldForOrderMatrix='kados_user_stories.ypos_r';  
  require_once PATHBASE.'deck_management.php';
}  
else
{
  // get filter computation for US
  include_once $pathCommons.'filter_us_compute.php';

  // Get US of the sprint
  if ($flagJoinTasks)
  {   
    $request=new sqlRequest("SELECT us_id AS parent_id,
                                    us_number AS display_number,
                                    kados_user_stories.text,
                                    kados_user_stories.status AS header_stamp,
                                    kados_user_stories.color,
                                    business_value AS infoBottomLeft,
                                    complexity AS infoBottomRight,
                                    us_link AS link,  
                                    us_creator AS creator,
                                    us_creation_date AS creation_date,
                                    us_last_update_date AS last_update,
                                    us_last_updater AS last_updater                                 
                             FROM kados_user_stories,kados_tasks  
                             WHERE kados_user_stories.active=1 
                               AND kados_tasks.active=1     
                               AND us_id_fk=us_id  
			       AND us_release_id_fk=".$_SESSION['current_release_id']." 
	  	               AND us_sprint_id_fk=0 
			       ".$clauseWhereUsFilter." 
			     ORDER BY ypos_s ASC",$cnx->num);
  }
  else
  {
    $request=new sqlRequest("SELECT us_id AS parent_id,us_number AS display_number,
                                    text,status AS header_stamp,color,
                                    business_value AS infoBottomLeft,complexity AS infoBottomRight,
                                    us_link AS link,  
                                    us_creator AS creator,
                                    us_creation_date AS creation_date,
                                    us_last_update_date AS last_update,
                                    us_last_updater AS last_updater                                 
                             FROM kados_user_stories 
			     WHERE active=1 AND us_release_id_fk=".$_SESSION['current_release_id']." 
			       AND us_sprint_id_fk=0 
			       ".$clauseWhereUsFilter." 
			     ORDER BY ypos_s ASC",$cnx->num);
  }
  $MultipleItemsArray=$request->getArrayFields();
}

// get project stakeholders
$stakeholdersProjects=$currentProject->getStakeholdersAllowedToMoveTasksUsernames();
$projectUsers=$currentProject->getStakeholders();

// set config for using board
$displayParentZone=false;    
$showFilterUs=true;
$showFilterTask=true;
$displayNoUser=true;
$forceDisplayDashBoardTitles=true;  

$displayTopButtons=true;
$allowAdd=false;
$displaySortByNumberButton=false;

if ($currentProject->level==3)
{?>
  <div class="MessageBox InformationMessageBox"><?php echo $msg_early_dashboard_level3;?></div><?php  
}
// Display order buttons => order all tasks for all US
$targetButtonOrder=$targetFileAction.'&action=order_all_tasks_compact&tasks2order='.implode('_',array_column($MultipleItemsArray,'parent_id'));
$targetButtonOrderExtended=$targetFileAction.'&action=order_all_tasks_extended&tasks2order='.implode('_',array_column($MultipleItemsArray,'parent_id'));
if ($currentProject->level==3)
{
  $displayBackToRoadmapButton=true;
} 

include PATHBASE.'matrix_display.php';?>