<?php
/**
 * Main page to manage user stories of a project
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

// Get mode
if ($_SESSION['mode_pbl']=='std')
{ 
  $itemType='us_release';
}
else
{ 
  $itemType='us_release_workshop';
}

$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);
/* set dashboard settings */
include PATHBASE.'dashboard_settings.php';

$arrayStatusX[0]=$columnWidth*0;
$arrayStatus[0]['colName']='Release BackLog';
// Check is at least one column for tasks exists
$request->sqlGet("SELECT column_tag_fk FROM kados_projects_columns WHERE project_id_fk=".$_SESSION['current_project_id']);
$request->countRows();
if ($request->rowCount!=0)
{
  $arrayStatus[0]['link']='manage_kanban.php?menu_lev2=prj_kanban&release_id='.$_SESSION['current_release_id'].'&board=tasks';
}  

$visibleSprintsArray[0]=0;
$invisibleColumnsArray=array();

if ($_SESSION['mode_pbl']=='std')
{
  // Get releases to display columns of the dashboard
  $request=new sqlRequest("SELECT * FROM kados_sprints WHERE sprint_release_id_fk=".$_SESSION['current_release_id']." ORDER BY sprint_start_date",$cnx->num);
  $resultArray=$request->getArrayFields();
  // array for getting the visible sprints id 
  $cpt=1;
  for ($i=0;$i<count($resultArray);$i++)
  {
    // Column width, except if visibility is 0
    if ($resultArray[$i]['visibility'])
    {
      $arrayStatusX[$resultArray[$i]['sprint_id']]=$columnWidth*($cpt);
      //  Sprints ID array
      $visibleSprintsArray[$cpt]=$resultArray[$i]['sprint_id'];
      //  Column name
      $arrayStatus[$cpt]['colName']=$resultArray[$i]['sprint_name'];
      // Column meaning popup
      $arrayStatus[$cpt]['colMeaning']=format_date_slash($resultArray[$i]['sprint_start_date']).' -> '.format_date_slash($resultArray[$i]['sprint_end_date']);
      // set link to hide column
      $arrayStatus[$cpt]['link2hide']='&action=hide_in_kanban&sprint2hide='.$resultArray[$i]['sprint_id'];
      // Column link
      $arrayStatus[$cpt++]['link']='manage_kanban.php?menu_lev2=prj_kanban&sprint_id='.$resultArray[$i]['sprint_id'];
    }
    else
    {
      // store column invisibility
      $invisibleColumnsArray[]=array('column_id' => $resultArray[$i]['sprint_id'],'column_position' =>$cpt,'column_type' => 'sprint','column_name' =>$resultArray[$i]['sprint_name']);  
    }
  }
  // Prepare a filter for getting only the US of the visible sprints
}
else
{
  $columnWidth=getParameter('WSSIZE',$cnx->num);
}
$visibleSprints=implode(',',$visibleSprintsArray);

// allow or not to display buttons for hide or show columns based on  UPD_SPRINT right in profile
$allowShowHideColumns=in_array('UPD_SPRINT',$_SESSION['user_actions']) || in_array('UPD_SPRINT',$_SESSION['user_local_actions']);

// set flag for displaying buttons  
$displayTopButtons=true;

// set parameters of dashboard
$allowAdd=in_array('ADD_US_REL',$_SESSION['user_actions']) || in_array('ADD_US_REL',$_SESSION['user_local_actions']);
$targetAdd=PATHBASE.'boards_buttons/add_us.php?item_type='.$itemType.'&us_from='.($itemType=='us_release' ? 'release' : '');
// set Add button parameters
$buttonAdd=$button_add_user_story;
$buttonAddImage='app/new_user_story.png';

// set others buttons
$allowDelete=in_array('DEL_US',$_SESSION['user_actions']) || in_array('DEL_US',$_SESSION['user_local_actions']);
$allowOrder=in_array('ORD_US',$_SESSION['user_actions']) || in_array('ORD_US',$_SESSION['user_local_actions']);
$allowUpdate=in_array('UPD_US',$_SESSION['user_actions']) || in_array('UPD_US',$_SESSION['user_local_actions']);
$allowMove=in_array('MOVE_US',$_SESSION['user_actions']) || in_array('MOVE_US',$_SESSION['user_local_actions']);
//
$allowActionHeaderStamp=$allowUpdate;

// set display of priority sorting button
$displayPriorityButton=true;
// get from global config if workshop button must be displayed
$displayWorkshopSwitch=getParameter('USEWS',$cnx->num);
// set texts for ordering buttons
$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;
$buttonSortByPriority=$button_reorder_priority;

// set link to project for postit created on that board
$otherFieldsInsertUS=',us_release_id_fk,us_project_id_fk';
$otherFieldsInsertValuesUS=','.$_SESSION['current_release_id'].','.$_SESSION['current_project_id'];

// init static column parameters => for no display
$MultipleItemsArray[0]=array('parent_id'=>0,'name'=>'','header_stamp'=>'','text'=>'','color'=>'');
$firstColumnStatic=false;
// set function used for top right-hand part of the postit => use image for postit status
$functionForHeaderStamp='displayStatusImageButton';
	
include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
// generic actions on postit
include PATHBASE.'boards_actions/actions_items.php';
// specific actions on US
include PATHBASE.'boards_actions/actions_us.php';
// display railway (here to compte US count after US creation)
include PATHBASE.'railway_display.php';

$showFilterUs=true;
// display board
include PATHBASE.'matrix_display.php';?>