<?php
/**
 * Main page to manage user stories of a project
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'./');
$targetFile='manage_release_checklist.php?menu_lev2=checklist';
$displayTable=true;
	  
$flagCheckCurrentProject=true;
include PATHBASE.'header.php';

  // check if this is a project with releases  
  if ($currentProject->level>1)
  {
    // check if any release is selected
    if (isset($_SESSION['current_release_id']))
    {    
      // do not show sprints in railway  
      $activateOnlyReleaseLevel=true;  
      include 'railway_display.php';
  
      // Get mode
      $itemType='activities';
  
      // Compute main item used in the board
      $masterItemType=getMasterItemType($itemType);
      $simpleItemType=getSimpleItemType($itemType);
      /* set dashboard settings */
      include PATHBASE.'dashboard_settings.php';
      $columnWidth=360;
  
      // set columns tags 
      $arrayStatusX['TODO']=$columnWidth*0;
      $arrayStatusX['PROG']=$columnWidth*1;
      $arrayStatusX['DONE']=$columnWidth*2;
      // set columns names
      $arrayStatus[]['colName']=$text_activity_status_todo;
      $arrayStatus[]['colName']=$text_activity_status_inprogress;
      $arrayStatus[]['colName']=$text_activity_status_done;  
  
      // set initial and final status
      $initialValue='TODO';
      $actionFinalStatusTag='DONE';  
  
      // set buttons
      $displayTopButtons=true;
      $allowAdd=in_array('ADD_ACTIVITY',$_SESSION['user_actions']) || in_array('ADD_ACTIVITY',$_SESSION['user_local_actions']);
      $targetAdd=PATHBASE.'boards_buttons/add_activity.php?item_type='.$itemType;
      $buttonAdd=$button_add_activity;
      $buttonAddImage='app/new_activity.png';	
  	
      // compute access rights for user
      $allowDelete=in_array('DEL_ACTIVITIES',$_SESSION['user_actions']) || in_array('DEL_ACTIVITIES',$_SESSION['user_local_actions']);
      $allowOrder=in_array('ORD_ACTIVITIES',$_SESSION['user_actions']) || in_array('ORD_ACTIVITIES',$_SESSION['user_local_actions']);
      $allowUpdate=in_array('UPD_ACTIVITIES',$_SESSION['user_actions']) || in_array('UPD_ACTIVITIES',$_SESSION['user_local_actions']);
      $allowMove=in_array('MOV_ACTIVITIES',$_SESSION['user_actions']) || in_array('MOV_ACTIVITIES',$_SESSION['user_local_actions']);
      // set functions for displaying parts of the postit
      $allowActionHeaderStamp=false;
      $functionForHeaderStamp='displayActivitySourceImage';
      $functionForDisableUpdate='isTemplateActivity';
      $functionForDisableDelete='isTemplateActivity';
  
      // $buttonAdd=$button_add_issues;
      $buttonOrder=$button_reorder;
      $buttonOrderExtended=$button_reorder_flat;
      
      $MultipleItemsArray[0]=array('parent_id'=>0,'name'=>'','header_stamp'=>'','text'=>'','color'=>'');
      $firstColumnStatic=false;
  	
      include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
      include PATHBASE.'boards_actions/actions_items.php';
      include PATHBASE.'boards_actions/actions_activities.php';
      // change delete picture (direct delete, no trash system)
      $deleteMode='del';
      $showFilterSearch['us']=false;
      include PATHBASE.'matrix_display.php';
    }
    else
    {?>
      <div class="MessageBox WarningMessageBox"><?php echo $msg_no_release_selected;?></div><?php
    }  
  }
  else
  {?>
    <div class="MessageBox WarningMessageBox"><?php echo $msg_no_release_selected;?></div><?php
  }      

include PATHBASE.'footer.php';?>