<?php
/**
 * Main page to manage tasks in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

if (!isset($_REQUEST['object_id']))
{
  $_REQUEST['object_id']=0;
}

$itemType='tasks_sprint';
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);

/* Dashboard settings */
include PATHBASE.'dashboard_settings.php';

// Select list of columns					 
$request->sqlGet("SELECT column_tag,column_name,column_usage,column_meaning   
	          FROM kados_template_columns,kados_projects_columns
		  WHERE column_tag=column_tag_fk 
                    AND project_id_fk=".$_SESSION['current_project_id']."
		  ORDER BY column_order");				   
$request->getArrayFields();	
// Allocate columns
for ($i=0;$i<$request->rowCount;$i++)
{	 
  // Column width, except if visibility is 0
  $arrayStatusX[$request->array[$i]['column_tag']]=$columnWidth*$i;
  // column name
  $arrayStatus[$i]['colName']=$request->array[$i]['column_name'];  
  // set column tip
  $arrayStatus[$i]['colMeaning']=$request->array[$i]['column_usage'];  
  // if column meaning is not the default one, but a project custom, change for the custom
  if ($request->array[$i]['column_meaning']!='')
  {
    $arrayStatus[$i]['colMeaning']=$request->array[$i]['column_meaning'];  
  }	
  
}
/* Buttons settings */
$allowAddInFirstColumn=in_array('ADDTASK',$_SESSION['user_actions']) || in_array('ADDTASK',$_SESSION['user_local_actions']);
$buttonAdd=$button_add_task;
$buttonAddImage='app/add_task.png';

$allowDelete=in_array('DELTASK',$_SESSION['user_actions']) || in_array('DELTASK',$_SESSION['user_local_actions']);
$allowOrder=in_array('ORDTASK',$_SESSION['user_actions']) || in_array('ORDTASK',$_SESSION['user_local_actions']);
$allowUpdate=in_array('UPDTASK',$_SESSION['user_actions']) || in_array('UPDTASK',$_SESSION['user_local_actions']);
$allowMove=in_array('MOVE_TASK',$_SESSION['user_actions']) || in_array('MOVE_TASK',$_SESSION['user_local_actions']);

$allowActionHeaderStamp=true;

$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;

$otherFieldsInsert=',us_id_fk';
$otherFieldsInsertValues=','.$_REQUEST['object_id'];

$firstColumnStatic=true;
$firstColumnDisplayParentZone=true;
$firstColumnDisplayWarningZone=true;
$firstColumnTitle=$text_sprint_backlog;
$firstColumnObjectTag='US';
$firstColumnFunctionForHeaderStamp='displayStatusImageButton';
$functionForHeaderStamp='displayTaskInitLoad';

$initialValue=getInitialStatus($_SESSION['current_project_id']);
$finalStatus=getFinalStatus($_SESSION['current_project_id']);
include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
// set railway befire actions tasks because of the message comin from deleting an attachment
include PATHBASE.'railway_display.php';
// generic actions for postit
include PATHBASE.'boards_actions/actions_items.php';
// specific actions for tasks
include PATHBASE.'boards_actions/actions_tasks.php';

// // Display the deck
$usFieldForOrderMatrix='kados_user_stories.ypos_s';  
require_once PATHBASE.'deck_management.php';

// get project stakeholders
$stakeholdersProjects=$currentProject->getStakeholdersAllowedToMoveTasksUsernames();
$projectUsers=$currentProject->getStakeholders();

// If there are at least one user story
$displayParentZone=false;
$showFilterUs=true;
$showFilterTask=true;
$displayNoUser=true;
$displayMyTasks=true;
$forceDisplayDashBoardTitles=true;
// Display order buttons => order all tasks for all US
$displayTopButtons=true;
$allowAdd=false;
$displaySortByNumberButton=false;
$targetButtonOrder=$targetFileAction.'&action=order_all_tasks_compact&tasks2order='.implode('_',array_column($MultipleItemsArray,'parent_id'));
$targetButtonOrderExtended=$targetFileAction.'&action=order_all_tasks_extended&tasks2order='.implode('_',array_column($MultipleItemsArray,'parent_id'));

include PATHBASE.'matrix_display.php';
?>