<?php
/**
 * messages and texts used by all scripts in English
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:labels
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */        
 
// Global Messages   
$msg_confirm_delete_object=utf8_encode('Do you really want to delete this item?');
$msg_object_deleted=utf8_encode("The item has been deleted");
$msg_object_detached=utf8_encode("The item has been detached");
$msg_object_created=utf8_encode("The item has been created");
$msg_all_objects_created=utf8_encode('All items have been created');
$msg_object_updated=utf8_encode("The item has been updated");
$msg_select_profile=utf8_encode('Select a profile to access management functions.');
$msg_unknown_user=utf8_encode('Unknown user');
$msg_wrong_password=utf8_encode('Wrong password');
$msg_object_exists=utf8_encode('This item already exists!');
$msg_status_changed=utf8_encode('The status has been updated');
$msg_object_added=utf8_encode("The item has been added");
$msg_confirm_detach_object=utf8_encode('Do you reaaly want to detach this item?');
$msg_managing_profile=utf8_encode('You are updating the profile features');
$msg_choose_value=utf8_encode('Choose a value');
$msg_file_missing=utf8_encode("The file is not on the server anymore");
$msg_file_too_big=utf8_encode('The file is too big');
$msg_credentials_ko=utf8_encode('Wrong login or password');
$msg_language_available=utf8_encode('Available language');
$msg_language_data_missing=utf8_encode('Some language data are missing');
$msg_no_result=utf8_encode('No result found');
$msg_too_much_results=utf8_encode('Too much results. Please refine your search');
$msg_not_enough_char=utf8_encode('Not enough char (at least 3)');
$msg_user_already_exists=utf8_encode('This user already exists');
$msg_managing_parameters_switch=utf8_encode('Change on/off parameters by clicking on the switching arrow of the parameter box.');
$msg_managing_parameters=utf8_encode('Set parameters in the list below by clicking on the update icon at the end of the line.');
$msg_user_format_ko=utf8_encode('User format is not correct (lowercase alphanumeric and _ chars only)');
$msg_session_ended=utf8_encode('Session has expired. Please reconnect.');
$msg_wrong_current_password=utf8_encode("Current password is not correct, please retry.");        
$msg_user_not_confirmed=utf8_encode("This user is not confirmed. Confirm it form the mail you've received or ask your administrator");
$msg_user_inactive=utf8_encode("This user is inactive. Contact your administrator");
$msg_confirm_reset_pass=utf8_encode("Do you really want to reinit this password?");                
$msg_password_updated=utf8_encode("Password has been updated");
$msg_password_not_locally_managed=utf8_encode("Password is managed by an external system.");      
$msg_password_reset=utf8_encode("Password has been reset.");
$msg_user_updated=utf8_encode("The user has been updated.");  
$msg_mail_validation_sent=utf8_encode("Validation email for the new email address has been sent.");      
$msg_reset_email_sent=utf8_encode("Reset password email has been sent.");                
$msg_unknown_email=utf8_encode("Incorrect email address. Please try again or contact your administrator.");        
$msg_user_already_confirmed=utf8_encode("The user is already confirmed.");                
$msg_no_email_to_confirm=utf8_encode("No email address to confirm.");                
$msg_feature_not_available=utf8_encode("This feature is not available.");                
$msg_unknown_request=utf8_encode("Unknown request.");                
$msg_password_incorrect=utf8_encode("Password is not correct. Please retry");
$msg_mail_sent=utf8_encode("Mail sent");                
$msg_user_not_registred=utf8_encode("LDAP user not in local database. Please contact your administrator");                
$msg_ldap_on_but_not_available=utf8_encode("LDAP connection is on, but the LDAP module is not available on your web server. Contact your administrator.");                
$msg_user_ldap_without_ldap=utf8_encode("You are a LDAP user, but the LDAP configuration is off. Contact your administrator.");                         
$msg_password_rules=utf8_encode('Password must be compliant with theses rules : <br />-At least one lower case char<br />-At least one upper case char<br />-At least one digit<br />-Beetwen 8 and 20 characters<br />-At least one special char among these !?*$+_@%# ');

// Global Texts
$text_profile=utf8_encode('Profile');
$text_duration=utf8_encode('Duration (months)');
$text_template_status=utf8_encode('Template status');
$text_year=utf8_encode('year');
$text_month=utf8_encode('month');
$text_number=utf8_encode('#');
$text_login=utf8_encode('Login');
$text_password=utf8_encode('Password');
$text_user=utf8_encode('User');
$text_logout=utf8_encode('Logout');
$text_firstname=utf8_encode('First name');
$text_name=utf8_encode('Name');
$text_email=utf8_encode('Email');
$text_status=utf8_encode('Status');
$text_short_name=utf8_encode('Short name');
$text_address=utf8_encode('Address');
$text_address_comment=utf8_encode("Address comments");
$text_address_city=utf8_encode('City');
$text_address_country=utf8_encode('Country');
$text_address_zip_code=utf8_encode('Postal code');
$text_address_state=utf8_encode('State');
$text_filter_inactive=utf8_encode('Inactive');
$text_description=utf8_encode('Description');
$text_amount=utf8_encode('Amount');
$text_reference=utf8_encode('Reference');
$text_resource=utf8_encode('Resource');
$text_of=utf8_encode('of');
$text_of_the=utf8_encode('of');
$text_date_from=utf8_encode('from');
$text_date_to=utf8_encode('to');
$text_none=utf8_encode('None');
$text_total=utf8_encode('Total');
$text_no_data=utf8_encode('No data');
$text_total_cost=utf8_encode('Total cost');
$text_hours=utf8_encode('Hours');
$text_creator=utf8_encode('Creator');
$text_creation_date=utf8_encode('Creation date');
$text_parameter=utf8_encode('Parameter');
$text_tag=utf8_encode('Tag');
$text_value=utf8_encode('Value');
$text_max_value=utf8_encode('Max value');
$text_informations=utf8_encode('General informations');
$text_misc=utf8_encode('Misc.');
$text_comments=utf8_encode('Comments');
$text_comment=utf8_encode('Comment');
$text_object_id=utf8_encode('#');
$text_actions=utf8_encode('Actions');
$text_start_date=utf8_encode('Starting date');
$text_days=utf8_encode('days');
$text_features=utf8_encode('Features');
$text_created_by=utf8_encode('Created by');
$text_no_item=utf8_encode('No item');
$text_for=utf8_encode('for');
$text_the_m=utf8_encode('the');
$text_the_f=utf8_encode('the');
$text_one_m=utf8_encode('a');
$text_one_f=utf8_encode('a');
$text_change_status=utf8_encode('Change status');
$text_workflow=utf8_encode('Workflow');
$text_management=utf8_encode('Management');
$text_group=utf8_encode('Group');
$text_ratio=utf8_encode('Ratio');
$text_std_profile=utf8_encode('Standard profile');
$text_value_is_too_high_for=utf8_encode('The value is too high to');
$text_limit_is=utf8_encode('The limit is');
$text_yes=utf8_encode('Yes');
$text_no=utf8_encode('No');
$text_to=utf8_encode('to');
$text_cost=utf8_encode('Cost');
$text_week=utf8_encode('week');
$text_tip=utf8_encode('Tip');
$text_alert_if_zero=utf8_encode('Alert if null value');
$text_date=utf8_encode('Date');
$text_menu=utf8_encode('Menu items');
$text_transitions=utf8_encode('Transitions');
$text_and=utf8_encode('and');
$text_todo2finish=utf8_encode('To do to finish');
$text_order=utf8_encode('Order');
$text_owner=utf8_encode('Owner');
$text_role=utf8_encode('Role');
$text_stakeholder=utf8_encode('Contributor');
$text_global=utf8_encode('Global');
$text_local=utf8_encode('Local');
$text_type=utf8_encode('Type');
$text_progress=utf8_encode('Progress');
$text_on=utf8_encode('on');
$text_update_date=utf8_encode('Updated on');
$text_file=utf8_encode('File');
$text_document=utf8_encode('Document');
$text_maxsize=utf8_encode('Max size');
$text_objects_using_this_profile=utf8_encode('Items using this profile');
$text_connection_mode=utf8_encode('Source');
$text_language=utf8_encode('Language');
$text_situation=utf8_encode('Situation');
$text_not_enough_char=utf8_encode('Not enough char (at least 3)');
$text_ldap_search=utf8_encode('LDAP search');
$text_search_by_name=utf8_encode('By name');
$text_search_by_username=utf8_encode('By login');
$text_readonly_role=utf8_encode('Read Only');
$text_nobody=utf8_encode('Nobody');
$text_theme=utf8_encode('Theme');
$text_project_block_raf=utf8_encode('Forbid to fill remaining time in the tasks of the last column');
$text_tag_used=utf8_encode('Tag available for the project');
$text_tag_not_used=utf8_encode('Tag unavailable for the project');
$text_password_check=utf8_encode('New password check');
$text_change_password=utf8_encode('To change password, fill in the form. Password is limited to 20 characters.');
$text_current_password=utf8_encode('Current password');
$text_new_password=utf8_encode('New password');
$text_user_confirmed=utf8_encode('User confirmed');
$text_key_not_valid=utf8_encode("Key is not valid");
$text_key_no_more_valid=utf8_encode("Key is not valid anymore");
$text_forgotten_password=utf8_encode("Forgotten password?");
$text_back_home=utf8_encode("Back to welcome page");
$text_relationships=utf8_encode("US relationships");
$text_news=utf8_encode('News');
$text_link=utf8_encode('Link');

// Global Buttons
$button_cancel=utf8_encode('Cancel');
$button_submit=utf8_encode('Submit');
$button_search=utf8_encode('Search');
$button_new_profile=utf8_encode('Create a profile');
$button_update_values=utf8_encode('Update values');
$button_new_user=utf8_encode('Create an user');
$button_filter=utf8_encode('Filter');
$button_back_to_list=utf8_encode('Back to list');
$button_lock=utf8_encode('Lock');
$button_save=utf8_encode('Save');
$button_unlock=utf8_encode('Unlock');
$button_update_value=utf8_encode('Save value');
$button_new_user_ldap=utf8_encode("Add an user from the LDAP directory");
$button_new_news=utf8_encode('Add a piece of news');

// Global Actions
$action_modify=utf8_encode('Modify');
$action_delete=utf8_encode('Delete');
$action_manage=utf8_encode('Manage');
$action_fill_in=utf8_encode('Fill in');
$action_start=utf8_encode('Start');
$action_view=utf8_encode('View');
$action_view_progress=utf8_encode("View progress");
$action_change_status=utf8_encode('Change status');
$action_detach=utf8_encode('Detach');
$action_fill=utf8_encode('Fill');
$action_set_as_default=utf8_encode('Set as default value');
$action_view_dashboard=utf8_encode('View dashboard');
$action_disable=utf8_encode('Disable');
$action_activate=utf8_encode('Activate');
$action_move_up=utf8_encode('Move up');
$action_move_down=utf8_encode('Move down');

// Legends
$legend_logon=utf8_encode('Connection');
$legend_changing_f=utf8_encode("Changing a");
$legend_creation_f=utf8_encode("Creation of a");
$legend_display_f=utf8_encode("Display a");
$legend_adding_f=utf8_encode("Adding a");
$legend_changing_m=utf8_encode("Changing a");
$legend_creation_m=utf8_encode("Creation of a");
$legend_display_m=utf8_encode("Display a");
$legend_adding_m=utf8_encode("Adding a");
$legend_change_password=utf8_encode('To change password fill in the two inputs. Password is limited to 20 characters.');
$legend_update_email=utf8_encode("To confirm the new email address, please fill in your password.");
$legend_reset_password=utf8_encode("To reset your password, please fill in your login and email address.");        

// Days
$list_days_week[]=utf8_encode('Monday');
$list_days_week[]=utf8_encode('Tuesday');
$list_days_week[]=utf8_encode('Wenesday');
$list_days_week[]=utf8_encode('Thursday');
$list_days_week[]=utf8_encode('Friday');
$list_days_week[]=utf8_encode('Saturday');
$list_days_week[]=utf8_encode('Sunday');

// Months
$list_months[]=utf8_encode('January');
$list_months[]=utf8_encode('February');
$list_months[]=utf8_encode('March');
$list_months[]=utf8_encode('April');
$list_months[]=utf8_encode('May');
$list_months[]=utf8_encode('June');
$list_months[]=utf8_encode('July');
$list_months[]=utf8_encode('August');
$list_months[]=utf8_encode('September');
$list_months[]=utf8_encode('October');
$list_months[]=utf8_encode('November');
$list_months[]=utf8_encode('December');

// Arrays
$array_yes_no[1]=$text_yes;
$array_yes_no[0]=$text_no;
?>