<?php
/**
 * Popup to display comments
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */    
define("PATHBASE",'./');
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathAppClasses=PATHBASE.'classes/';
$pathImages=PATHBASE.'images/';

$targetFile='';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{
  require_once PATHBASE.'popin_includes.php';
  require_once $pathClasses.'class_sortColumn.php';
  require_once $pathCommons.'date_hour.php';
  require_once $pathAppClasses.'project.php';
  require_once $pathAppClasses.'appUser.php';
  require_once $pathAppClasses.'comment.php';
  // create comment object
  $postitComments=new comment($cnx->num);
  // get mode var
  $mode = isset($_GET['mode']) ? $_GET['mode'] : 'w';   ?>

<html>
    <head>
     <script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery-ui.triggeredAutocomplete.js"></script>
     <script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery.highlighttext.js"></script>
    </head>
    <body>
        
    <div class="MessageBox WarningMessageBox hidden-div" id="MsgWarning"><?php echo $msg_fill_in_a_comment;?></div>    <?php        
    // if write mode, display form
    if ($mode=='w')
    {?>
    <div class="align_center">
      <form class="pure-form pure-form-aligned" style="margin-bottom:10px;" method="post">
        <input type="hidden" id="item_id" value="<?php echo $_GET['i'];?>" />
        <input type="hidden" id="item_type" value="<?php echo $_GET['t'];?>" />
        <textarea id="form_item_comment" class="std_form_field" rows="4" cols="70"></textarea> 
        <input type="hidden" id="waved_users" value="">
        
    </form>
    <div id="addComment" class="tsc_awb_medium tsc_awb_green tsc_flat"><?php echo $button_submit;?></div>
     
    </div><?php
    }?>
    <div style="border-top:solid 1px grey;margin-top:15px;"> <?php


  // see if master
  $masterObject = isset($_GET['l']) ? 'master_' : '';  
  
  // init user object
  $user=new appUser($cnx->num);   
  // get comments
  $commentsList=$postitComments->getPostitComments(intval($_GET['i']),strtoupper($_GET['t']));       
  // get current user
  $user->appUser($cnx->num,$_SESSION['login']);    
  $dateRefPrevious=$user->getUserPreviousLoginDate();
  for ($i=0;$i<count($commentsList);$i++)
  {
    //check if comment is new
    $commentDate=new DateTime($commentsList[$i]['postit_comment_date']);
    $previousLogin=new DateTime($dateRefPrevious);
    $new=($commentDate>$previousLogin && $commentsList[$i]['postit_comment_user_login_fk']!=$_SESSION['login']);
    // if new, find if the current user is concerned
    $newWithUser=false;
    if ($new)
    {
      $newWithUser=(strpos('-'.$commentsList[$i]['postit_comment_waved_users'],'@['.$_SESSION['login'].']'));
    }
    // get user names to be highlighted
    preg_match_all("/@\[([a-zA-Z0-9_]*)\]/",$commentsList[$i]['postit_comment_waved_users'],$wavedUsers);
    // get user/author from the comment
    $user->appUser($cnx->num,$commentsList[$i]['postit_comment_user_login_fk']);   ?>
        <div class="commentLine <?php if ($newWithUser) {echo 'newCommentUser';} else if($new) { echo 'newComment';}?>">
           <div class="commentAuthorBox"><span class="commentAuthor"><?php echo $user->getFullName().' '.$text_said.' :';?></span></div>    
           <div class="commentText"><?php echo nl2br($commentsList[$i]['postit_comment_text']);?></div> 
           <div class="commentDate "><?php echo $commentDate->format('d F Y H:i:s');?></div>
           <div class="clearright"></div>
         </div>
        <script><?php
           for ($j=0;$j<count($wavedUsers[1]);$j++)
           {
             $user->appUser($cnx->num,$wavedUsers[1][$j]);?>
             $('.commentText').highlightText('@<?php echo $user->getFullName();?>','hightlightUserName');<?php
           }?>  
        </script><?php
  }?>
     </div>  <?php

}?>
    <div class="hidden-div" id="reloadDialog" onclick="$(this).parent().load('postit_comments.php?i=<?php echo $_GET['i'];?>&t=<?php echo $_GET['t'];?>');"></div>
    <script>
    $('#addComment').click(function(){
        
      if ($('#form_item_comment').val()!='')
      {
        $.post('<?php echo PATHBASE;?>xmlhttprequest/add_comment.php',{item_id:<?php echo $_GET['i'];?>,item_type:'<?php echo $_GET['t'];?>',comment:$('#form_item_comment').val(),waved_users:$('#waved_users').val()},function(msg){
          if(msg=='OK')
          {
            var count=parseInt($('#comments_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').html());
            count++;
            $('#comments_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').html(count);
            if (count==10)
            {
              $('#comments_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').css('left','0');
            }
            $('#reloadDialog').click();
          }  
	});
      }
      else
      {
         $('#MsgWarning').show();
      }      
    });

    $('#form_item_comment').triggeredAutocomplete({
      hidden: '#waved_users',
      source: "xmlhttprequest/search_user_to_wave.php",
      trigger: "@",
    });
    </script>
    </body>   
</html>