<?php
/**
 * popup to display a project card
 *
 * PHP version 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */    
define("PATHBASE",'./');
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathAppClasses=PATHBASE.'classes/';
$pathImages=PATHBASE.'images/';

$targetFile='';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{
  require_once PATHBASE.'popin_includes.php';
  require_once $pathClasses.'class_sortColumn.php';
  require_once $pathClasses.'class_workflow.php';    
  require_once $pathCommons.'date_hour.php';
  require_once $pathAppClasses.'project.php';
  require_once PATHBASE.'templates_projects_list.php'; 
  
  // create project object
  $projectData=new project($cnx->num,intval($_GET['i']));
  $projectData->getData();
  // compute project shortcuts
  if ($projectData->externalProjectId!=0)
  {
    $paramShortcut='shortcut=project_ext&shortcut_id='.$projectData->externalProjectId;
  }
  else
  {
    $paramShortcut='shortcut=project&shortcut_id='.$projectData->projectId;
  }
  
  // init action param
  $action='';
  // check parameters
  if (isset($_GET['a']))
  {
    $action=$_GET['a'];  
  }
  ?>

<html>
    <header>
        <link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/card.css" />
    </header>
    <div class="MessageBox WarningMessageBox hidden-div" id="MsgWarningAdmin"><?php echo $msg_fill_in_an_user;?></div>   
    <div class="MessageBox WarningMessageBox hidden-div" id="MsgWarningName"><?php echo $msg_fill_in_a_name;?></div>   
    <div style="width:680px;float:left;">
        <div class="info_card"><div class="header_card" ><?php echo $text_name;?></div><div class="value_card"><?php  
        
             if (in_array('MNGPARAMPRJ',$_SESSION['user_actions']) 
                 || isActionAllowedOnProjectForUser($_SESSION['login'],'MNGPARAMPRJ',$projectData->projectId)
                 || $projectData->adminLogin==$_SESSION['login'])
             {
	        // If project is from an external source, add a button to update data
	        if ($projectData->externalProjectId!=0)
                {
		  $projectFindId=$projectData->externalProjectId;
		  $project_external_project_connection_id=$projectData->externalProjectConnexId;
		  include 'external_connection_get_projects.php';
		  // si changement de nom ou de date, proposer la mise  jour
		  if ($projectData->name!=$projectsList[0]['project_field_name'])
		  {?>
                    <a href="javascript:document.form_update_project_data_<?php echo $projectData->projectId;?>.submit()" tooltip="<?php TextDisplay($action_refresh_release);?>"><img src="<?php echo $pathImages;?>refresh.png" border="0"  /></a>				 
		    <form name="form_update_project_data_<?php echo $projectData->projectId;?>" method="post" action="<?php echo $targetFile;?>" enctype="multipart/form-data">
		      <input type="hidden" name="action" value="update_ext_project" />
		      <input type="hidden" name="project2update" value="<?php echo $projectData->projectId;?>" />
		      <input type="hidden" name="new_name" value="<?php echo $projectsList[0]['project_field_name'];?>" />
		    </form><?php
		  }
	        }
                // if the user wants to change project name
                if ($action=='name')
                {
                  // change name form        ?>
                  <form class="pure-form pure-form-aligned" method="post" enctype="multipart/form-data" name="form_change_name">
                    <div style="float:left;">    
            	      <input id="projectName" class="std_form_field" type="text" size="35" value="<?php echo $projectData->name;?>"/>
                    </div>
                    <div style="float:left;margin-top:4px;margin-left:10px;">
                      <a  id="submitNameButton" class="tsc_awb_small tsc_awb_green tsc_flat _link"><?php echo $button_submit;?></a>
                      <a  id="cancelButton" class="tsc_awb_small tsc_awb_orange tsc_flat _link"><?php echo $button_cancel;?></a> 
                    </div>   
                    <div class="clearleft"></div>
                  </form><?php              
                }
                else
                {       
                  echo $projectData->name;   
                  // allow change of project name?>
                 <img id="changeName" src="<?php echo $pathImages;?>edit.png" border="0"  /><?php                  
	        }
             }
             else
             {
               echo $projectData->name;   
             }?> </div> 
        </div>
        <div class="info_card"><div class="header_card" ><?php echo $text_status;?></div><div class="value_card"><?php 
            $wkf=new workflow('PRJ','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language']);  
            // reset some arrays
            unset($statusListProfile);
	    unset($statusListLocalProfil);
	    unset($statusList);
            // reinit arrays
            $statusListProfile=array();
	    $statusListLocalProfil=array();
            $statusList=array();
	    // Status list with global profile
            $wkf->set_profile('framework_workflows_transitions_profiles','profile_id_fk',$_SESSION['user_profile']);
	    $statusListProfile=$wkf->etats_suivants_tablo($projectData->projectId);
	    // Get status to merge with local profile
	    for ($k=0;$k<count($statusListProfile);$k++)
	    {
	      $statusList[$k]=$statusListProfile[$k]['status_id'];
	    }
            // Set local profile if exists
	    $localProfile=getLocalProfileOnProjectForUser($_SESSION['login'],$projectData->projectId);
            $wkf->set_profile('framework_workflows_transitions_profiles','profile_id_fk',$localProfile);
            // Get status list for the local profile
	    $statusListLocalProfil=$wkf->etats_suivants_tablo($projectData->projectId);
            // merge the two status lists
	    for ($k=0;$k<count($statusListLocalProfil);$k++)
	    {
	      if (!in_array($statusListLocalProfil[$k]['status_id'],$statusList))
	      {
		array_push($statusListProfile,$statusListLocalProfil[$k]);
	      }
	    }
            if ($action=='status')
            {?>        
                <form class="pure-form pure-form-aligned" method="post" enctype="multipart/form-data" name="form_change_name">
                  <div style="float:left;">   
                    <select id="projectStatus" class="std_form_field" > <?php
                      // display available status
                      for ($k=0;$k<count($statusListProfile);$k++)
	              {?>
                        <option value="<?php echo $statusListProfile[$k]['status_id']; ?>"><?php echo $statusListProfile[$k]['status_value'];?></option><?php
	              }?>                      
            	    </select>
                  </div>
                  <div style="float:left;margin-top:4px;margin-left:10px;">
                    <a  id="submitStatusButton" class="tsc_awb_small tsc_awb_green tsc_flat _link"><?php echo $button_submit;?></a>
                    <a  id="cancelButton" class="tsc_awb_small tsc_awb_orange tsc_flat _link"><?php echo $button_cancel;?></a> 
                  </div>   
                  <div class="clearleft"></div>
                </form><?php
            }
            else
            {
              echo $projectData->status;
              if (count($statusListProfile)!=0)
              {?>        
                <img id="changeStatus" src="<?php echo $pathImages;?>edit.png" border="0"  /><?php
              }
            }?>
        </div> </div>
        <div class="info_card"><div class="header_card" ><?php echo $text_type;?></div><div class="value_card"><?php echo $textProjectTemplates[$projectData->level];?></div> </div>
        <div class="info_card"><div class="header_card" ><?php echo $text_project_admin;?></div><div class="value_card"><?php 
          if ($action=='admin')
          {
            // change admin form   ?>
            <form class="pure-form pure-form-aligned" method="post" enctype="multipart/form-data" name="form_change_admin">
              <div style="float:left;">   
    	        <input name="form_item_project_admin" id="searchAnyUser" class="std_form_field" type="text" size="35"/>
	        <input name="form_item_project_admin_search" id="searchAnyUserId" type="hidden"/>
              </div>
              <div style="float:left;margin-top:4px;margin-left:10px;">
                <a  id="submitAdminButton" class="tsc_awb_small tsc_awb_green tsc_flat _link"><?php echo $button_submit;?></a>
                <a  id="cancelButton" class="tsc_awb_small tsc_awb_orange tsc_flat _link"><?php echo $button_cancel;?></a> 
              </div>   
              <div class="clearleft"></div>
            </form><?php              
          }
          else
          {
             echo $projectData->adminName;
             if (in_array('MNGPARAMPRJ',$_SESSION['user_actions']) 
                 || isActionAllowedOnProjectForUser($_SESSION['login'],'MNGPARAMPRJ',$projectData->projectId)
                 || $projectData->adminLogin==$_SESSION['login'])
             {             	  
               // allow change of project admin?>
               <img id="changeAdmin" src="<?php echo $pathImages;?>edit.png" border="0"  /><?php
             }
          }  
        ?></div> </div>
        <div class="info_card"><div class="header_card" ><?php echo $msg_use_this_url_as_shortcut_for_project;?></div><div class="value_card"><?php echo getServerURL();?>/index.php?<?php echo $paramShortcut;?></div> </div>
        <div class="info_card"><div class="header_card" ><?php echo $msg_use_this_url_as_shortcut_for_cockpit;?></div><div class="value_card"><?php echo getServerURL();?>/index.php?<?php echo $paramShortcut;?>&shortcut_target=cockpit</div> </div>
    </div>
    <div style="margin-left:25px;width:60px;float:left;margin-top:20px;"><a href="<?php echo PATHBASE;?>rss.php?project_id=<?php echo $projectData->projectId;?>&language=<?php echo $_SESSION['language'];?>&token=<?php echo $projectData->rssKey;?>" target="rss_ext"><img src="<?php echo $pathImages;?>app/rss48.png" border="0" /></a></div> <?php
}
?>
    <div class="hidden-div" id="openChangeAdmin" onclick="$(this).parent().load('project_card.php?i=<?php echo $projectData->projectId;?>&a=admin');"></div> 
    <div class="hidden-div" id="openChangeName" onclick="$(this).parent().load('project_card.php?i=<?php echo $projectData->projectId;?>&a=name');"></div> 
    <div class="hidden-div" id="openChangeStatus" onclick="$(this).parent().load('project_card.php?i=<?php echo $projectData->projectId;?>&a=status');"></div> 
    <div class="hidden-div" id="reloadPopup" onclick="$(this).parent().load('project_card.php?i=<?php echo $projectData->projectId;?>');"></div> 
    <div class="hidden-div" id="submitUpdate" onclick="$(this).parent().load('project_card.php?i=<?php echo $projectData->projectId;?>');"></div> 
    <script>
    $('#changeAdmin').click(function(){
        
      $('#openChangeAdmin').click();
    });  

    $('#changeName').click(function(){
        
      $('#openChangeName').click();
    });  
    
    $('#changeStatus').click(function(){
        
      $('#openChangeStatus').click();
    });  
    

    $('#cancelButton').click(function(){
        
      $('#reloadPopup').click();
    });  

    $('#submitAdminButton').click(function(){
      if ($('#searchAnyUserId').val()!='')
      {
        $.post('<?php echo PATHBASE;?>xmlhttprequest/update_admin.php',{project_id:<?php echo $_GET['i'];?>,new_admin:$('#searchAnyUserId').val()},function(msg){
          if(msg=='OK')
          {
            $('#reloadPopup').click();    
          }  
	});
      }
      else
      {
         $('#MsgWarningAdmin').show();
      } 
    });  

    $('#submitNameButton').click(function(){
      if ($('#projectName').val()!='')
      {
        $.post('<?php echo PATHBASE;?>xmlhttprequest/update_project_name.php',{project_id:<?php echo $_GET['i'];?>,new_project_name:$('#projectName').val()},function(msg){
          if(msg=='OK')
          {
            $('.list_project_name_'+<?php echo $_GET['i'];?>).html($('#projectName').val());
            $('#reloadPopup').click();    
          }  
	});
      }
      else
      {
         $('#MsgWarningName').show();
      } 
    });  

    $('#submitStatusButton').click(function(){
        $.post('<?php echo PATHBASE;?>xmlhttprequest/update_project_status.php',{project_id:<?php echo $_GET['i'];?>,new_project_status:$('#projectStatus').val()},function(msg){
          if(msg=='OK')
          {
            $('#reloadPopup').click();    
          }  
	});
    });  

    $('#searchAnyUser').autocomplete({
       source: "xmlhttprequest/search_any_user.php",
       minLength: 2,
       select: function( event, ui ) {
            $('#searchAnyUserId').attr('value',ui.item['id']);
       }
    });
    </script>    
</html>