<?php
/**
 * Import US in a project
 *
 * PHP version 5
 *
 * @category Scripts
 * @package  ProjectManagement:ImportUS
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'./');
$targetFile='project_import.php?';
$displayTable=true;
	  
$flagCheckCurrentProject=true;
include PATHBASE.'header.php';
$uploadOk=false;
if (isset($_SESSION['current_project_id']))
{
  // check token  
  if (appUtils::checkToken())
  {       
    /* actions for the page */
    switch ($_REQUEST['action'])
    {
      case 'submit_file':
        // get file
        if ($_FILES['file_csv']['error']==UPLOAD_ERR_OK)
        {
          // open file
          $fileCSV=fopen($_FILES['file_csv']['tmp_name'],"r");
          $simpleItemType='us';  
          /* set dashboard settings */
          include PATHBASE.'dashboard_settings.php';   
          // get specific settings for that board
          include PATHBASE.'boards_settings/settings_us_project.php';      
          // read file
          while($line=fgetcsv($fileCSV))
          {
            // insert US  

            // preparing the input data:
            $business_value = intval($line[1]);
            $body = formatStringForDB($line[0]);
            $zindex = (int)10;
            $complexity = intval($line[2]);
            
            // compute default color
            $request=new sqlRequest("(SELECT color AS color_name,use_color_default  AS color_default
                                      FROM kados_colors_uses
			              WHERE use_color_postit_type='".strtoupper($simpleItemType)."' 
                                        AND use_color_lock=1)
			             UNION
			             (SELECT color_name,object_color_default AS color_default 
			              FROM kados_projects_colors,kados_colors 
			              WHERE project_id_fk=".$_SESSION['current_project_id']."
		 	                AND color_id_fk=color_id 
                            	        AND object_type='".strtoupper($simpleItemType)."')",$cnx->num);	  	     
            $colorList=$request->getArrayFields();   
            // set default color
            $color='';
            for ($i=0;$i<count($colorList);$i++)
            {
              $color= $colorList[$i]['color_default'] ? $colorList[$i]['color_name'] : $color; 
            }
            // If default color is not set, set the first color as default color 
            if ($color=='')
            {
              if (isset($colorList[0]['color_name']))
	      {
	        $color=$colorList[0]['color_name'];
	      }
            }
            
            // Get max us_number for the project
            $request= new sqlRequest("SELECT MAX(us_number) AS max FROM kados_user_stories WHERE us_project_id_fk=".$_SESSION['current_project_id'],$cnx->num);
            $request->getObject();
            $usNumber=(int)$request->objet->max+1;

            /* Compute position for US */
            // set local init positions
            $xLocalInitDefaultPosition=$xInitDefaultPosition;
            $yLocalInitDefaultPosition=$yInitDefaultPosition;      
            // get US of the scope : product backlog or release backlog or feature backlog
            $clauseScope= ' AND us_sprint_id_fk=0  AND us_release_id_fk=0';
            // get US y max and y min and number of US in the backlog
            $request->sqlGet("SELECT MIN(".$yPosField.") AS ymin,MAX(".$yPosField.") AS ymax,COUNT(".$yPosField.") AS nb_items 
                              FROM kados_user_stories 
                              WHERE active=1 
                               AND us_project_id_fk=".$_SESSION['current_project_id'].$clauseScope);
            $infosItemsInScope=$request->getObject();  
            if ($infosItemsInScope->nb_items!=0)
            {
              // compute y position for the new US
              $score=floor(($infosItemsInScope->ymax+$itemHeight-$infosItemsInScope->ymin+25*$infosItemsInScope->nb_items)/$infosItemsInScope->nb_items);  
              // the objective is to know if postit are more in an extended or a compact display 
              if ($score>=$itemHeight)
              {
                // if it is an extended    
                // new postit y-position is set under the last postit
                $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemHeight+25;  
                // x position is the init x position
              }    
              else
              {
                //  if it is a more compact display
                $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemYShift;  
                // then x-position should be a small shift
                // Check before that the postit will not "bite" on the next column
                if ((7*($infosItemsInScope->nb_items+1)+$itemWidth)<$columnWidth)
                {
                  $xLocalInitDefaultPosition=7*($infosItemsInScope->nb_items+1);
                }
              }                
            }  
            // if link is not empty
            if ($line[3]!='')
            {    
              // Check if link has an allowed protocol
              if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$line[3]))
              {
                // then set var for the SQL request  
                $recordFieldLink=',us_link';
                $recordFieldLinkValue=",'".$line[3]."'";
              }
              else 
              {
                // display warning message 
                $displayProtocolWarningMsg=true; 
                // empty var
                $recordFieldLink='';
                $recordFieldLinkValue='';
              }      
            }
            else
            {
              // no link to record   
              $recordFieldLink='';
              $recordFieldLinkValue='';
            }
            
            // set link to project for postit created on that board
            $otherFieldsInsertUS=',us_project_id_fk';
            $otherFieldsInsertValuesUS=','.$_SESSION['current_project_id'];
    
            /* Inserting a new record in the $tableData DB: */
            $request->sqlGet("INSERT INTO kados_user_stories (us_number,text,business_value,color,".$xPosField.",".$yPosField.",".$zPosField.",status".$otherFieldsInsertUS.",
      	                         complexity,us_creation_date,us_creator,us_last_update_date,us_last_updater".$recordFieldLink.")
				   VALUES (".$usNumber.",'".$body."','".$business_value."','".$color."',".$xLocalInitDefaultPosition.",".$yLocalInitDefaultPosition.",".$zindex.",'TODO'".$otherFieldsInsertValuesUS.",
				           ".$complexity.",'".date('Y-m-d H:i:s')."','".$_SESSION['login']."','".date('Y-m-d H:i:s')."','".$_SESSION['login']."'".$recordFieldLinkValue.")");	
            // get new ID
            $idNewUS=$request->getLastId();
            // add history items
            $history=new history($cnx->num);
            // status
            $history->addPostitHistory('US',$idNewUS,'status','', 'TODO', $_SESSION['login']);
            // text
            $history->addPostitHistory('US',$idNewUS,'text','', $body, $_SESSION['login']);
            // type of US
            $history->addPostitHistory('US',$idNewUS,'type','', $color, $_SESSION['login']);
            // link
            if ($recordFieldLinkValue!='' && $line[3]!='')
            {
              $history->addPostitHistory('US',$idNewUS,'link','', $line[3], $_SESSION['login']);
            }           
          }      
          $uploadOk=true;
        }
      break;
    }
  }
  
  if ($displayTable)
  {
    $showOnlyProjectLevel=true;
    include PATHBASE.'railway_display.php';	
    // set token  
    appUtils::initToken(); 
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());    
    // get right of user to add US
    $allowImport=in_array('ADD_US',$_SESSION['user_actions']) || in_array('ADD_US',$_SESSION['user_local_actions']);
    // if adding US is allowed, import is allowed
    if ($allowImport)
    {
      // if upload done, display message  
      if ($uploadOk)
      {?>
         <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_upload_csv_done;?></div><?php
      }?>
      <div class="MessageBox InformationMessageBox"><?php echo $msg_upload_csv;?></div><?php
    
      // get form to import csv file
      require_once PATHBASE.'forms/form_import_csv.php';
    }
    else
    {?>
      <div class="MessageBox WarningMessageBox"><?php echo $msg_import_us_not_allowed;?></div><?php  
    }
  }
}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}

include PATHBASE.'footer.php';?>