<?php
/**
  * Project Parameters management
 *
 * PHP versions 4 and 5
 *
 * @framework_ Scripts
 * @package  ProjectMngt
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     
define("PATHBASE",'./');
require_once PATHBASE.'header.php';
$targetFile='project_parameters.php?';
$cnx=new connexion_db();

if (isset($_SESSION['current_project_id']))
{
  // check token  
  if (appUtils::checkToken())
  {        
  // action allowed      
  switch ($_REQUEST['action'])
  {
    case 'change_overlapping':
        // switch between use or no use 
        $request=new sqlRequest("UPDATE kados_projects SET project_sprint_overlapping=NOT(project_sprint_overlapping) WHERE project_id=".$_SESSION['current_project_id'],$cnx->num);
        $currentProject->paramSprintOver=!$currentProject->paramSprintOver;  
    break;		 
	
    case 'change_visibility':
        // switch between use or no use 
        $request=new sqlRequest("UPDATE kados_projects SET project_visibility=IF(project_visibility='PRI','PUB','PRI') WHERE project_id=".$_SESSION['current_project_id'],$cnx->num);
        $currentProject->paramVisibility=$currentProject->paramVisibility=='PRI' ? 'PUB': 'PRI';  
    break;		 	

    case 'change_tags_use':
        // switch between use or no use 
        $request=new sqlRequest("UPDATE kados_projects SET project_use_tags=NOT(project_use_tags) WHERE project_id=".$_SESSION['current_project_id'],$cnx->num);
        $currentProject->paramUseTags=!$currentProject->paramUseTags;
    break;	

    case 'change_block_raf':
        // switch between use or no use 
        $request=new sqlRequest("UPDATE kados_projects SET project_block_raf=NOT(project_block_raf) WHERE project_id=".$_SESSION['current_project_id'],$cnx->num);
        $currentProject->paramBlockRaf=!$currentProject->paramBlockRaf;  
    break;	

    case 'change_attachment':
        // switch between use or no use 
        $request=new sqlRequest("UPDATE kados_projects SET project_allow_attachments=NOT(project_allow_attachments) WHERE project_id=".$_SESSION['current_project_id'],$cnx->num);
        $currentProject->paramAttachment=!$currentProject->paramAttachment;  
    break;

    case 'switch_profile':
        if ($_GET['situation']==1)  
        {
          $request=new sqlRequest("DELETE FROM kados_projects_profiles WHERE profile_id_fk=".$_GET['profile_id']." AND project_id_fk=".$_SESSION['current_project_id'],$cnx->num);
        }
        else
        {
          $request=new sqlRequest("INSERT INTO kados_projects_profiles (profile_id_fk,project_id_fk) VALUES (".$_GET['profile_id'].",".$_SESSION['current_project_id'].")",$cnx->num); 
        }
    break;
  }  	 
  }
 
  $showOnlyProjectLevel=true;  
  include PATHBASE.'railway_display.php';
  require $pathCommons.'project_data.php';

  // set token  
  appUtils::initToken(); 
  // add token to target file
  $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());
  // display parameters with switch?>
  <div class="block1"><?php	
  if (in_array('MNGPARAMPRJ',$_SESSION['user_actions']) 
      || isActionAllowedOnProjectForUser($_SESSION['login'],'MNGPARAMPRJ',$_SESSION['current_project_id'])
      || $currentProject->adminLogin==$_SESSION['login'])      
  {	?>

    <div class="MessageBox TitleBox"><?php echo $msg_managing_parameters_switch;?></div><?php
    if (getParameter('SPOVL',$cnx->num)==1)	
    {
      $buttonText=$text_allow_sprint_overlapping;
      $urlButtonOnOff=$targetFile.'&action=change_overlapping';
      $boolOnOff=$currentProject->paramSprintOver;
      include $pathCommons.'on_off_button.php';	
    }
  
    $buttonText=$text_project_is_private;
    $urlButtonOnOff=$targetFile.'&action=change_visibility';
    $boolOnOff=$currentProject->paramVisibility=='PRI';
    include $pathCommons.'on_off_button.php';	
    
    $buttonText=$text_project_use_tags;
    $urlButtonOnOff=$targetFile.'&action=change_tags_use';
    $boolOnOff=$currentProject->paramUseTags;
    include $pathCommons.'on_off_button.php';	   
    
    $buttonText=$text_project_block_raf;
    $urlButtonOnOff=$targetFile.'&action=change_block_raf';
    $boolOnOff=$currentProject->paramBlockRaf;
    include $pathCommons.'on_off_button.php';

    $buttonText=$text_allow_attachements;
    $urlButtonOnOff=$targetFile.'&action=change_attachment';
    $boolOnOff=$currentProject->paramAttachment;
    include $pathCommons.'on_off_button.php'; ?>
    <div class="clearleft"></div><br /><?php
  }	
  else
  {?>
    <table class="zebraTable" cellpadding="0" cellspacing="0"><?php
    if (getParameter('SPOVL',$cnx->num)==1)	
    {?>
	  <tr class="alt">
	     <td style="text-align:left;"> <?php 
		   echo $text_allow_sprint_overlapping;?>
		</td>
	    <td style="text-align:left;"><?php
	      echo ($currentProject->paramSprintOver==1 ? $text_yes : $text_no); ?>
	    </td>
	  </tr><?php
    }?>
    <tr>
      <td style="text-align:left;"> <?php 
	   if ($currentProject->paramVisibility=='PRI')
	   {
	     echo $text_this_project_is_private;
	   }
	   else
	   {
	     echo $text_this_project_is_public;
	   }?>
      </td>
	  <td style="text-align:left;"> </td>
    </tr>
    <tr class="alt">
	     <td style="text-align:left;"> <?php 
		   echo $text_project_use_tags;?>
		</td>
	    <td style="text-align:left;"><?php
	      echo $currentProject->paramUseTags==1 ? $text_yes : $text_no; ?>
	    </td>
	  </tr>
  <tr>
	    <td style="text-align:left;"> <?php 
		   echo $text_project_block_raf;?>
		</td>
	    <td style="text-align:left;"><?php
	      echo $currentProject->paramBlockRaf==1 ? $text_yes : $text_no; ?>
	    </td>
	  </tr>          
  </table><?php
  }?>
  </div>
  <div class="block2"> <?php
      $request->sqlGet("SELECT profile_id,profile_name 
                       FROM framework_profiles 
                       WHERE profile_type='LOCAL'");
      $listProfiles=$request->getArrayFields();
      
      $request->sqlGet("SELECT profile_id_fk 
                       FROM kados_projects_profiles 
                       WHERE project_id_fk=".$_SESSION['current_project_id']);
      $availableProfiles=$request->getArrayFirstFieldOnly();
      
      // if user is allowed to change config, display buttons
      if (in_array('MNGPARAMPRJ',$_SESSION['user_actions']) 
          || isActionAllowedOnProjectForUser($_SESSION['login'],'MNGPARAMPRJ',$_SESSION['current_project_id'])
          || $currentProject->adminLogin==$_SESSION['login'])      
      {      ?>
        <div class="MessageBox TitleBox"><?php echo $msg_profiles_switch;?></div>  <?php
        for ($i=0;$i<count($listProfiles);$i++)
        {
          $buttonText=$listProfiles[$i]['profile_name'];
          $urlButtonOnOff=$targetFile.'&action=switch_profile&profile_id='.$listProfiles[$i]['profile_id'].'&situation='.in_array($listProfiles[$i]['profile_id'],$availableProfiles);
          $boolOnOff=in_array($listProfiles[$i]['profile_id'],$availableProfiles);
          if (count($availableProfiles)==1)
          {
            $buttonDisabled=$boolOnOff;
          }    
          include $pathCommons.'on_off_button.php'; ?>
          <div class="clearleft"></div> <?php
        }
      }
      else
      {?>
        <div class="MessageBox TitleBox"><?php echo $msg_profiles_displayed;?></div>  
        <table class="zebraTable" cellpadding="0" cellspacing="0"><?php  
        for ($i=0;$i<count($listProfiles);$i++)
        {?>
          <tr><td><?php echo $listProfiles[$i]['profile_name'];?></td><td><?php if (in_array($listProfiles[$i]['profile_id'],$availableProfiles)) { echo $text_yes;} else { echo $text_no;}?></td></tr>  <?php
        }?>
        </table><?php
      } ?>
  </div><?php
}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}

$cnx->close();  
require_once PATHBASE.'footer.php';?>