<?php
/**
 * Tags template management
 *
 * PHP versions 4 and 5
 *
 * @framework_ Scripts
 * @package  ProjectMngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     
define("PATHBASE",'./');
require_once PATHBASE.'header.php';
$targetFile='project_tags.php?';
$cnx=new connexion_db();

$displayTable=true;

// init an array for names of postit
$postitTypeTable['US']=$text_US;
$postitTypeTable['TASK']=$text_task;	

if (isset($_SESSION['current_project_id']))
{ 
  // display railway with project name
  $showOnlyProjectLevel=true;  
  include PATHBASE.'railway_display.php';  

  // check token  
  if (appUtils::checkToken())
  {        
  // action allowed    
  // action choice switch
  switch ($_REQUEST['action'])
  {
    case 'delete':
      // delete tag  
      $request=new sqlRequest("DELETE FROM kados_tags WHERE tag_id=".intval($_REQUEST['id_to_delete'])." AND tag_type='USR_FREE'",$cnx->num);
      $request->sqlGet("DELETE FROM kados_tags_projects 
                        WHERE project_id_fk=".$_SESSION['current_project_id']." AND tag_id_fk=".intval($_REQUEST['id_to_delete']));
      // display confirmation message
      $msgDisplay=$msg_object_deleted;
    break;
	
    case 'new_tag':
      $colors=array();
      $request->sqlGet("SELECT color_name FROM kados_colors");
      $colors=$request->getArrayFirstFieldOnly();
      $legendLabel=$legend_creation_m.' '.lcfirst($text_tag);
      $tagData=new stdClass();
      $tagData->tag_label='';
      $tagData->tag_color=$colors[0];
      $tagData->tag_postit_type='US';
      $tagId=-1;
      // get postit color types
      $request->sqlGet("SELECT use_color_id AS use_color_id_fk,tag_id_fk,
	                       CONCAT(use_color_meaning,' (',color,')') AS postit_meaning 
                        FROM kados_colors_uses 
                        LEFT JOIN kados_tags_allocations ON color_use_id_fk=use_color_id 
                                                        AND tag_id_fk=".$tagId."
			WHERE use_color_postit_type='".$tagData->tag_postit_type."'");
      $postItColorsList=$request->getArrayFields();      
      // init vars
      $showType=false;
      $TagPostitScope='ALL';
      include PATHBASE.'forms/form_tag.php';
      $displayTable=false;
    break;
  
    case 'submit_new_tag':
      // get workflow object  
      $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
      // record new tag  
      $request=new sqlRequest("INSERT INTO kados_tags (tag_label,tag_owner,tag_color,tag_type,tag_postit_type,tag_status_id_fk) 
	                        VALUES ('".$_POST['form_item_tag']."',
				        '".$_SESSION['login']."',
			         	'".$_POST['form_item_color']."',
				        'USR_FREE',
                                        '".$_POST['form_item_postit_type']."',
					".$wkf->init_statut().")",$cnx->num);
      // add tag for the current project
      $idNew=$request->getLastId();									
      $request->sqlGet("INSERT INTO kados_tags_projects (tag_id_fk,project_id_fk)
	                       VALUES (".$idNew.",".$_SESSION['current_project_id'].")");
      // then link tag to specific postit (or none)
      if (isset($_POST['linkedPostits']))
      {
        // create new links
        for ($i=0;$i<count($_POST['linkedPostits']);$i++)
        {
          $request->sqlGet("INSERT INTO kados_tags_allocations 
                            (color_use_id_fk,tag_id_fk)
                            VALUES (".$_POST['linkedPostits'][$i].",".$idNew.")");
        }
      }            
      // display confirmation message
      $msgDisplay=$msg_object_created;	
    break;
  
    case 'modify_tag':
      $tagId=intval($_REQUEST['id_to_modify']);
      // get tag data
      $request=new sqlRequest("SELECT * 
	                    FROM kados_tags 
	                    WHERE tag_id=".$tagId,$cnx->num);
      $tagData=$request->getObject();
      // get postit color types
      $request->sqlGet("SELECT use_color_id AS use_color_id_fk,tag_id_fk,
	                       CONCAT(use_color_meaning,' (',color,')') AS postit_meaning 
                        FROM kados_colors_uses 
                        LEFT JOIN kados_tags_allocations ON color_use_id_fk=use_color_id 
                                                        AND tag_id_fk=".$tagId." 
			WHERE use_color_postit_type='".$tagData->tag_postit_type."'");
      $postItColorsList=$request->getArrayFields();      
      // get colors for displaying color choice for tag
      $colors=array();
      $request->sqlGet("SELECT color_name FROM kados_colors");
      $colors=$request->getArrayFirstFieldOnly();
      $legendLabel=$legend_changing_m.' '.lcfirst($text_tag);
      // init vars
      $showType=false;
      $TagPostitScope='ALL';
      include PATHBASE.'forms/form_tag.php';
      $displayTable=false;  	
    break;	
     
    case 'submit_modify_tag':
      // update tag data  
      $request=new sqlRequest("UPDATE kados_tags 
	                    SET tag_label='".$_POST['form_item_tag']."',
	                        tag_color='".$_POST['form_item_color']."'
	                    WHERE tag_id='".$_REQUEST['tag_id']."'
                              AND tag_type='USR_FREE'",$cnx->num);
      // delete existing links
      $request->sqlGet("DELETE FROM kados_tags_allocations WHERE tag_id_fk=".$_REQUEST['tag_id']);          
      // then link tag to specific postit (or none)
      if (isset($_POST['linkedPostits']))
      {
        // create new links
        for ($i=0;$i<count($_POST['linkedPostits']);$i++)
        {
          $request->sqlGet("INSERT INTO kados_tags_allocations 
                            (color_use_id_fk,tag_id_fk)
                            VALUES (".$_POST['linkedPostits'][$i].",".$_REQUEST['tag_id'].")");
        }
      }        
      //display message  
      $msgDisplay=$msg_object_updated;
    break;  
     
    case 'change_status':
      // update tag status   
      $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
      $wkf->change_object_status($_REQUEST['tag_id'],$_REQUEST['new_status_id']);
      // display confirmation message
      $msgDisplay=$msg_status_changed;
    break;			 
	
    case 'change_button':
      if ($_REQUEST['situation'])
      {
        $request->sqlGet("DELETE FROM kados_tags_projects 
	                 WHERE tag_id_fk=".$_REQUEST['tag2change_id']." AND project_id_fk=".$_SESSION['current_project_id']);		  
      }
      else
      {
        $request->sqlGet("INSERT INTO kados_tags_projects (tag_id_fk,project_id_fk)
	                       VALUES (".$_REQUEST['tag2change_id'].",".$_SESSION['current_project_id'].")");	
      }	  
    break;
  }  	 
  }
  
  if ($displayTable)
  {
    // set token  
    appUtils::initToken(); 
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());      
      
    // display message if any
    if (isset($msgDisplay))
    {?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msgDisplay;?></div>
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    }
    $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);

    // display button to add tag id user allowed
    $readOnly=true;
    if (in_array('MNGPARAMPRJ',$_SESSION['user_actions']) 
        || isActionAllowedOnProjectForUser($_SESSION['login'],'MNGPARAMPRJ',$_SESSION['current_project_id'])
        || $currentProject->adminLogin==$_SESSION['login'])    
    {     
      displayButton($button_new_tag,'',$targetFile.'&action=new_tag','tsc_awb_small tsc_awb_blue tsc_flat');	
      $readOnly=false;
    }?>
    <div class="clearleft"></div><?php
    
    // create filters
    $filtres=new filters(PATHBASE,$pathImages);
    // filter for tag name
    $filtres->add_field('filter_tag_name',$text_tag,'string','tag_label');     	
    // filter for tag group
    $filtres->add_field('filter_group',$text_tag_group,'requete','tag_group_id_fk');
    $filtres->define_field_request('filter_group',"tag_group_name",'kados_tags_groups','tag_group_id',"");
	
    // add filter for tag type
    $filtres->add_field('filter_tag_type',$text_type,'liste','tag_type');
    $filtres->define_field_list('filter_tag_type','ALL_MAND:'.$tagTypeDisplay['ALL_MAND'].',ALL_FREE:'.$tagTypeDisplay['ALL_FREE'].',USR_FREE:'.$tagTypeDisplay['USR_FREE']);
    
    // add filter for tag postit type
    $filtres->add_field('filter_tag_postit_type',$text_postit_type,'liste','tag_postit_type');
    $filtres->define_field_list('filter_tag_postit_type','US:'.$postitTypeTable['US'].',TASK:'.$postitTypeTable['TASK']);

    // show filters
    $filtres->display($targetFile,$button_filter,$text_filter_inactive);
     
    $sqlTags="(SELECT tag_id,tag_color,tag_label,tag_type,tag_owner,tag_status_id_fk,tag_postit_type,tag_group_name   
               FROM kados_tags LEFT JOIN kados_tags_groups ON tag_group_id_fk=tag_group_id 
               WHERE tag_type IN ('ALL_FREE','ALL_MAND') 
                 AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT').$filtres->return_sql_filter().")
               UNION
              (SELECT tag_id,tag_color,tag_label,tag_type,tag_owner,tag_status_id_fk,tag_postit_type,tag_group_name  
               FROM kados_tags_projects,kados_tags LEFT JOIN kados_tags_groups ON tag_group_id_fk=tag_group_id 
               WHERE tag_type='USR_FREE' 
                 AND tag_id=tag_id_fk 
                 AND project_id_fk=".$_SESSION['current_project_id'].$filtres->return_sql_filter().")"; 
    $request=new sqlRequest($sqlTags,$cnx->num); 	  	     
    $request->countRows();
    // mange the table
    $pageNumbering=new changePage('page_tags',$request->rowCount,$targetFile,$pathImages,getParameter('PGNUBR',$cnx->num));
    $sortColumn=new sortColumn('tags_sort',$targetFile,$pathImages);

    // get tags active on the project : specific tags for project and global optional tags activated on project
    $request->sqlGet("SELECT tag_id_fk FROM kados_tags_projects WHERE project_id_fk=".$_SESSION['current_project_id']);
    $freeTagsActivatedOnProject=$request->getArrayFirstFieldOnly();
	 
    $pageNumbering->displayNavigator($text_no_item);?>
     <table class="zebraTable">
       <tr>
         <th><?php echo $text_tag; $sortColumn->displaySortButtons('tag_label');?></th>
         <th><?php echo $text_color; ?></th>          
         <th><?php echo $text_tag_group; $sortColumn->displaySortButtons('tag_group_name');?></th>   
         <th><?php echo $text_linked_postit;?></th>	         
         <th><?php echo $text_type; $sortColumn->displaySortButtons('tag_type');?></th>
         <th><?php echo $text_postit_type; $sortColumn->displaySortButtons('tag_postit_type');?></th>		 
         <th><?php echo $text_creator;?></th>
	 <th><?php echo $text_use_for_project;?></th>
	 <th><?php echo $text_status;?></th><?php
         if (!$readOnly)
         {?>
  	   <th><center><a href="#" tooltip="<?php TextDisplay($text_workflow);?>"><img src="<?php echo $pathImages;?>workflow.gif" border="0"  /></a></center></th>		 
           <th><center><a href="#" tooltip="<?php echo $text_management;?>"><img src="<?php echo $pathImages;?>tools.png" border="0" /></a></center></th>       <?php
         }?>    
       </tr><?php
       $request=new sqlRequest($sqlTags.$sortColumn->returnSqlOrderBy().$pageNumbering->returnSqlLimit(),$cnx->num);
       $resultsArray=$request->getArrayFields();
              
       for ($i=0;$i<count($resultsArray);$i++)
       {
         // get linked postits if any
         $request->sqlGet("SELECT color,use_color_meaning 
                           FROM kados_colors_uses,kados_tags_allocations 
                           WHERE use_color_id=color_use_id_fk 
                             AND tag_id_fk=".$resultsArray[$i]['tag_id']);
         $linkedPostits=$request->getArrayFields();  ?>
         <tr>
           <td><?php echo $resultsArray[$i]['tag_label'];?></td>
           <td><div class="colorDisplay <?php echo $resultsArray[$i]['tag_color'];?>"></div></td>   
           <td><?php echo $resultsArray[$i]['tag_group_name'];?></td>           
           <td><?php
             for ($k=0;$k<count($linkedPostits);$k++)
             {?>
               <div class="<?php echo $linkedPostits[$k]['color'];?>" style="width:auto;height:18px;float:left;margin-left:5px;padding-left:5px;padding-right:5px"><?php echo $linkedPostits[$k]['use_color_meaning'];?></div><?php  
             }?>
           </td>           
	   <td><?php echo $tagTypeDisplay[$resultsArray[$i]['tag_type']];?></td>
           <td><?php echo $postitTypeTable[$resultsArray[$i]['tag_postit_type']];?></td>
           <td><?php echo $resultsArray[$i]['tag_owner'];?></td>
	   <td><center><?php
	     if ($resultsArray[$i]['tag_type']=='ALL_FREE')
	     {
               $boolOnOff=in_array($resultsArray[$i]['tag_id'],$freeTagsActivatedOnProject) ? 1 : 0;
               if (!$readOnly)
               {                 
                 $urlButtonOnOff=$targetFile.'&action=change_button&tag2change_id='.$resultsArray[$i]['tag_id'].'&situation='.$boolOnOff;
                 include $pathCommons.'on_off_button_small.php';		   
               }  
               else
               {
                 echo ($boolOnOff ? $text_tag_used : $text_tag_not_used);
               }
	     } ?> </center>
	   </td>
	   <td><?php if ($resultsArray[$i]['tag_type']=='USR_FREE') echo $wkf->valeur_etat($resultsArray[$i]['tag_status_id_fk']); ?></td><?php
           if (!$readOnly)
           {?>           
           <td class="nowrap"><center><?php
             if ($resultsArray[$i]['tag_type']=='USR_FREE')
	     {
	       $status_list=$wkf->etats_suivants_tablo($resultsArray[$i]['tag_id']);
	       for ($k=0;$k<count($status_list);$k++)
	       {?>
		  <a href="<?php echo $targetFile;?>&action=change_status&new_status_id=<?php echo $status_list[$k]['status_id']; ?>&tag_id=<?php echo $resultsArray[$i]['tag_id'];?>" tooltip="<?php TextDisplay($action_change_status.' : '.$status_list[$k]['status_value']);?>"><img src="<?php echo $pathImages.$status_list[$k]['status_icon'];?>" border="0"  /></a><?php
	       }
	     }?></center>
	   </td> 	
           <td class="nowrap">
	     <center><?php
	     if ($resultsArray[$i]['tag_type']=='USR_FREE')
	     {?>
	       <a href="<?php echo $targetFile;?>&action=modify_tag&id_to_modify=<?php echo $resultsArray[$i]['tag_id'];?>" tooltip="<?php TextDisplay($action_delete);?>"><img src="<?php echo $pathImages;?>edit.png" border=0 /></a><?php
	       $request->sqlGet("SELECT COUNT(tag_id_fk) AS nbTags 
		                FROM kados_tags_postit 
		                WHERE tag_id_fk='".$resultsArray[$i]['tag_id']."'");
	       $request->getObject();
	       if ($request->objet->nbTags==0)
               {?>
                 <a href="<?php echo $targetFile;?>&action=delete&id_to_delete=<?php echo $resultsArray[$i]['tag_id'];?>" tooltip="<?php TextDisplay($action_delete);?>" onclick="return confirm('<?php echo $msg_confirm_delete_object;?>');"><img src="<?php echo $pathImages;?>delete.png" border=0 /></a><?php
               }
	     } ?>
	     </center>
	   </td><?php
           }?>
         </tr><?php
       }?>
     </table><?php
  }

}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}  
$cnx->close();  

require_once PATHBASE.'footer.php';?>