<?php
/**
 * Tags groups management
 *
 * PHP versions 4 and 5
 *
 * @framework_ Scripts
 * @package  ProjectMngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     
define("PATHBASE",'./');
require_once PATHBASE.'header.php';
$targetFile='project_tags_groups.php?';
$cnx=new connexion_db();

$displayTable=true;

// init an array for names of postit
// easier to ue in form
$postitTypeTable['US']=$text_US;
$postitTypeTable['TASK']=$text_task;	
// check token  
if (appUtils::checkToken())
{        
  // action allowed    
  switch ($_REQUEST['action'])
  {
    case 'delete_group':
      // delete tag group from DB. No impact  
      $request=new sqlRequest("DELETE FROM kados_tags_groups WHERE tag_group_id=".intval($_REQUEST['id_to_delete']),$cnx->num);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_deleted;?></div>          
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;

    case 'new_tag_group':
      // get tags that have no groups and US type
      $tagsList=array();
      $request->sqlGet("SELECT tag_id,tag_label,tag_type,tag_group_id_fk   
                        FROM kados_tags,kados_tags_projects 
                        WHERE tag_type='USR_FREE' 
                          AND tag_id=tag_id_fk 
                          AND tag_group_id_fk=0
                          AND tag_postit_type='US' 
                          AND project_id_fk=".$_SESSION['current_project_id']);
      $tagsList=$request->getArrayFields();        
      // init vars for form
      $legendLabel=$legend_creation_m.' '.lcfirst($text_tag_group);
      $tagGroupScope='PRJ';
      // init tag group var  
      $tagGroupData=new stdClass();
      $tagGroupData->tag_group_id=-1;
      $tagGroupData->tag_group_name='';
      $tagGroupData->tag_group_postit_type='US';
      // call form
      include PATHBASE.'forms/form_tag_group.php';
      $displayTable=false;
    break;
  
    case 'submit_new_tag_group':
      // create the new tag group   
      $request=new sqlRequest("INSERT INTO kados_tags_groups (tag_group_name,tag_group_postit_type,tag_group_scope,tag_group_project_id_fk) 
                               VALUES ('".$_POST['form_item_tag_group_name']."',
                                       '".$_POST['form_item_postit_type']."',
                                       'PRJ',
                                       ".$_SESSION['current_project_id'].")",$cnx->num);
      $idNew=$request->getLastId();  
      // then create the new links if there is at least one
      if (isset($_POST['linkedTags']))
      {
        $request->sqlGet("UPDATE kados_tags
                          SET tag_group_id_fk=".$idNew." 
                          WHERE tag_id IN(".implode(',',$_POST['linkedTags']).")");
      }?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_created;?></div>           
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php	
    break;
  
    case 'modify_tag_group':
      // get selected tag group 
      $request=new sqlRequest("SELECT * 
                               FROM kados_tags_groups  
                               WHERE tag_group_id=".intval($_REQUEST['id_to_modify']),$cnx->num);
      $tagGroupData=$request->getObject();
      // get tags that have no groups or that are in this group
      $tagsList=array();
      $request->sqlGet("SELECT tag_id,tag_label,tag_type,tag_group_id_fk   
                        FROM kados_tags,kados_tags_projects 
                        WHERE tag_type='USR_FREE' 
                          AND tag_id=tag_id_fk 
                          AND tag_postit_type='".$tagGroupData->tag_group_postit_type."'
                          AND (tag_group_id_fk=0 OR tag_group_id_fk=".$tagGroupData->tag_group_id.") 
                          AND project_id_fk=".$_SESSION['current_project_id']);
      $tagsList=$request->getArrayFields();
      // init form vars
      $legendLabel=$legend_changing_m.' '.lcfirst($text_tag_group);
      $tagGroupScope='PRJ';
      // get form
      include PATHBASE.'forms/form_tag_group.php';
      $displayTable=false;  	
    break;	
     
    case 'submit_modify_tag_group':
      // update name of group  
      $request=new sqlRequest("UPDATE kados_tags_groups 
	                       SET tag_group_name='".$_POST['form_item_tag_group_name']."' 
	                       WHERE tag_group_id=".$_REQUEST['tag_group_id'],$cnx->num);
      // update composition of the group
      // first delete all links and 
      $request->sqlGet("UPDATE kados_tags 
                        SET tag_group_id_fk=0 
                        WHERE tag_group_id_fk=".$_REQUEST['tag_group_id']);
      // then create the new links if there is at least one
      if (isset($_POST['linkedTags']))
      {
        $request->sqlGet("UPDATE kados_tags
                          SET tag_group_id_fk=".$_REQUEST['tag_group_id']." 
                          WHERE tag_id IN(".implode(',',$_POST['linkedTags']).")");
      }?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_updated;?></div>           
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;  
  }  	 
}  
  if ($displayTable)
  {
    // set token  
    appUtils::initToken();
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());      
            
    // get groups list
    $sqlTagsGroups="SELECT * FROM kados_tags_groups 
                    WHERE tag_group_scope='PRJ' 
                      AND tag_group_project_id_fk=".$_SESSION['current_project_id']; 
    $request=new sqlRequest($sqlTagsGroups,$cnx->num); 	  	     
    $request->countRows();
    // start page numebring object
    $pageNumberingGroup=new changePage('page_tags_groups',$request->rowCount,$targetFile,$pathImages,getParameter('PGNUBR',$cnx->num));
    // start sorting object       
    $sortColumnGroup=new sortColumn('tags_group_sort',$targetFile,$pathImages);
         
    // display button to add a tag (no criteria)
    $readOnly=true;
    if (in_array('MNGPARAMPRJ',$_SESSION['user_actions']) 
        || isActionAllowedOnProjectForUser($_SESSION['login'],'MNGPARAMPRJ',$_SESSION['current_project_id'])
        || $currentProject->adminLogin==$_SESSION['login'])    
    {     
      displayButton($button_new_tag_group,'',$targetFile.'&action=new_tag_group','tsc_awb_small tsc_awb_magenta tsc_flat');
      $readOnly=false;
    }?>
      
    <div class="clearleft"></div><?php
    // display pages navigator
    $pageNumberingGroup->displayNavigator($text_no_item);?>
     <table class="zebraTable">
       <tr>
         <th><?php echo $text_tag_group; $sortColumnGroup->displaySortButtons('tag_group_name');?></th>
         <th><?php echo $text_postit_type; $sortColumnGroup->displaySortButtons('tag_group_postit_type');?></th><?php
         if (!$readOnly)
         {?>		 
           <th><center><a href="#" tooltip="<?php echo $text_management;?>"><img src="<?php echo $pathImages;?>tools.png" border="0" /></a></center></th>       <?php
         }?>
       </tr><?php
       // get tags with page and sorting parameters
       $request=new sqlRequest($sqlTagsGroups.$sortColumnGroup->returnSqlOrderBy().$pageNumberingGroup->returnSqlLimit(),$cnx->num);
       $resultsArray=$request->getArrayFields();
              
       // list tags of the current page 
       for ($i=0;$i<count($resultsArray);$i++)
       {?>
         <tr>
           <td><?php echo $resultsArray[$i]['tag_group_name'];?></td>  
           <td><?php echo $postitTypeTable[$resultsArray[$i]['tag_group_postit_type']];?></td><?php
         if (!$readOnly)
         {?>		
           <td class="nowrap">
	      <center>
	      <a href="<?php echo $targetFile;?>&action=modify_tag_group&id_to_modify=<?php echo $resultsArray[$i]['tag_group_id'];?>" tooltip="<?php TextDisplay($action_delete);?>"><img src="<?php echo $pathImages;?>edit.png" border=0 /></a><?php
	      $request->sqlGet("SELECT COUNT(tag_id) AS nbTags 
		               FROM kados_tags
		               WHERE tag_group_id_fk=".$resultsArray[$i]['tag_group_id']);
	      $request->getObject();
	      if ($request->objet->nbTags==0)
              {?>
                <a href="<?php echo $targetFile;?>&action=delete_group&id_to_delete=<?php echo $resultsArray[$i]['tag_group_id'];?>" tooltip="<?php TextDisplay($action_delete);?>" onclick="return confirm('<?php echo $msg_confirm_delete_object;?>');"><img src="<?php echo $pathImages;?>delete.png" border=0 /></a><?php
              }?>
	      </center>
	   </td><?php
         }?>
         </tr><?php
       }?>
     </table>  <?php
  }

$cnx->close();  

require_once PATHBASE.'footer.php';?>