<?php
/**
 * projects.php
 * Projects Management
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:projects
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     

define("PATHBASE",'./');
require_once PATHBASE.'header.php';
$targetFile='projects.php?';

// set a var for dahsboard mode
if (!isset($_SESSION['dashboard_display_mode']))
{
  $_SESSION['dashboard_display_mode']='compact';
}

// init vars
$displayTable=true;

// check token  
if (appUtils::checkToken())
{        
  // action allowed 
  // choose operations to do if any
  switch ($_REQUEST['action'])
  {
    case 'delete_project':
      // deleting a project    
      $id2delete=intval($_REQUEST['id_to_delete']);
      // delete project itself  
      $request->sqlGet('DELETE FROM kados_projects WHERE project_id='.$id2delete); 
      // delete projects users (not users, only links to project)
      $request->sqlGet('DELETE FROM kados_projects_users WHERE project_id_fk='.$id2delete);  
      // delete projects settings
      $request->sqlGet('DELETE FROM kados_projects_settings WHERE project_id_fk='.$id2delete); 
      // delete colors selected for project (link only)
      $request->sqlGet('DELETE FROM kados_projects_colors WHERE project_id_fk='.$id2delete);  	
      // delete columns selected for project
      $request->sqlGet('DELETE FROM kados_projects_columns WHERE project_id_fk='.$id2delete);  		  
      // if current project is the one which is deleted, unset current project var
      if (isset($_SESSION['current_project_id']))
      {
        if ($_SESSION['current_project_id']==$id2delete)
 	{
	  unset($_SESSION['current_project_id']);
	}
      }
      // Delete bookmarks related to project
      $request->sqlGet('DELETE FROM kados_users_bookmarks WHERE project_id_fk='.$id2delete);  	?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_deleted;?></div> <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;
    
    case 'new_ext_project':
      // load form for external projects
      include PATHBASE.'forms/form_external_project.php';
      // do not display projects lists
      $displayTable=false;
    break;
      
    case 'new_project':
      // load project workflow
      $wkf=new workflow('PRJ','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language']);
      // initiate an empty object for project  
      $projectData=new stdClass();	  
      $projectData->project_status_id_fk=$wkf->init_statut();
      $projectData->status_value=$wkf->valeur_etat($projectData->project_status_id_fk);
      $projectData->project_id=0;	  
      $projectData->product_owner='';
      $projectData->project_name='';
      $projectData->project_creator='';
      $projectData->project_external_project_id=0;
      // load legend for project form
      $form_legend=$legend_creation_m.' '.lcfirst($text_project); 
      // load target for form
      $projectTargetFile='project_cockpit.php';
      // load form
      include PATHBASE.'forms/form_project.php';
      // do not display projects lists
      $displayTable=false;
    break;
    
    case 'update_ext_project':
      // Update project
      $request=new sqlRequest("UPDATE kados_projects SET  project_name='".formatStringForDB($_POST['new_name'])."' WHERE project_id=".$_POST['project2update'],$cnx->num);	  ?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_updated;?></div>           
      <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php
    break;
	
    case 'bookmark_project':
      $request=new sqlRequest("SELECT MAX(bookmark_order) AS max FROM kados_users_bookmarks WHERE user_login_fk='".$_SESSION['login']."'",$cnx->num);
      $request->getObject();
      $order=$request->objet->max+1;	
      $request->sqlGet("INSERT IGNORE INTO kados_users_bookmarks (user_login_fk,project_id_fk,bookmark_order,bookmark_color) 
                        VALUES ('".$_SESSION['login']."',".$_REQUEST['id_project'].",".$order.",'')");
    break;
	
    case 'unbookmark_project':
      $request=new sqlRequest("DELETE FROM kados_users_bookmarks WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$_REQUEST['id_project'],$cnx->num);
      //  reorder bookmarks
      $bookmarks=array();
      $request->sqlGet("SELECT project_id_fk FROM kados_users_bookmarks WHERE user_login_fk='".$_SESSION['login']."' ORDER BY bookmark_order");
      $bookmarks=$request->getArrayFirstFieldOnly();
      for ($i=0;$i<count($bookmarks);$i++)
      {
        $request->sqlGet("UPDATE kados_users_bookmarks SET bookmark_order=".($i+1)." WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$bookmarks[$i]);
      }
    break;

    case 'choose_color':
      $request=new sqlRequest("UPDATE kados_users_bookmarks SET bookmark_color='".$_REQUEST['color']."' WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$_REQUEST['id_project'],$cnx->num);
    break;	
	
    case 'bookmark_up':
      $request=new sqlRequest("SELECT bookmark_order FROM kados_users_bookmarks WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$_REQUEST['id_project'],$cnx->num);	  
      $bookmark=$request->getObject();
      $request->sqlGet("UPDATE kados_users_bookmarks SET bookmark_order=".$bookmark->bookmark_order." WHERE user_login_fk='".$_SESSION['login']."' AND bookmark_order=".($bookmark->bookmark_order-1));
      $request->sqlGet("UPDATE kados_users_bookmarks SET bookmark_order=bookmark_order-1 WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$_REQUEST['id_project']);	  
    break;
	
    case 'bookmark_down':
      $request=new sqlRequest("SELECT bookmark_order FROM kados_users_bookmarks WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$_REQUEST['id_project'],$cnx->num);	  
      $bookmark=$request->getObject();
      $request->sqlGet("UPDATE kados_users_bookmarks SET bookmark_order=".$bookmark->bookmark_order." WHERE user_login_fk='".$_SESSION['login']."' AND bookmark_order=".($bookmark->bookmark_order+1));
      $request->sqlGet("UPDATE kados_users_bookmarks SET bookmark_order=bookmark_order+1 WHERE user_login_fk='".$_SESSION['login']."' AND project_id_fk=".$_REQUEST['id_project']);	  
    break;	
    
    case 'search_project':?>
      <form class="pure-form pure-form-aligned" >
         <fieldset class="fieldset">
         <legend class="legend"><?php echo $text_search_project_by_name;?></legend> 
          <input class="std_form_field" type="text" id="search_project" />      
         </fieldset>
      </form>  
      <div id="display_results"></div>
      <div style="margin-top:15px;margin-left:10px">    <?php
        displayButton(TextFormat($button_cancel),'',$targetFile,'tsc_awb_medium tsc_awb_orange tsc_flat');	?>
      </div>    
      <script>
      $('#display_results').html('<span class="search_msg"><?php echo $text_at_least_one_char;?></span>');       
      $('#search_project').bind('keyup', function(){
        if ($(this).attr('value').length>0)
        {
          $.post('xmlhttprequest/get_project_list.php',{query:$(this).attr('value')},function(msg){
            if (msg!='[]')
            {
              var AnswerObject=JSON.parse(msg);  
              $('#display_results').html('');
              var project_list_content='<table class="betaTable" style="white-space:nowrap;margin-left:15px;">';
              for (i=0;i<AnswerObject.length;i++)
              {
                project_list_content+='<tr><td><a class="std_link" href="project_cockpit.php?fromProjectList=1&menu_lev1=cockpit&menu_lev2=cockpit&project_id='+AnswerObject[i].project_id+'"><span class="list_project_name_'+AnswerObject[i].project_id+'">'+AnswerObject[i].project_name+'</span></a></td>\n\
                 <td><div class="project_card"><span style="display:none">'+AnswerObject[i].project_id+'</span><img src="<?php echo $pathImages;?>app/card.png" /></div></td>\n\
                 <td><a href="manage_kanban.php?fromProjectList=1&menu_lev1=prj_kanban&project_id='+AnswerObject[i].project_id+'" title="<?php echo $text_goto_kanban;?>"><img src="<?php echo $pathImages;?>app/kanban.png" border="0" /></a></td>\n\
                 <td><a href="<?php echo addParamUrl($targetFile,'token='.appUtils::getToken());?>&action=bookmark_project&id_project='+AnswerObject[i].project_id+'" class="black_link"><?php echo $action_bookmark_project;?></a></td></tr>';
              }
              project_list_content+='</table>';
              $('#display_results').html(project_list_content);             
            }  
            else
            {
              $('#display_results').html('<span class="search_msg"><?php echo $text_no_project;?></span>');  
            }
          });
        }
        else
        {
          $('#display_results').html('<span class="search_msg"><?php echo $text_at_least_one_char;?></span>');   
        }
      });

      </script>   <?php
      $displayTable=false;   
    break;
  } 
}  
  
  // List projects
  if ($displayTable)
  {
    // set token  
    appUtils::initToken(); 
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());  
    
    // messages part
    if (isset($msg_error))
    {?>
      <div class="MessageBox ErrorMessageBox"><?php echo $msg_error;?></div><div class="clearleft"></div><?php
    }
    else if (isset($_GET['msg']))
    {
      $msgName='msg_'.$_GET['msg'];
      if (isset($$msgName))
      {?>
        <div class="MessageBox WarningMessageBox"><?php echo $$msgName;?></div><div class="clearleft"></div><?php
      }
    }   
    
    // load projects workflow  
    $wkf=new workflow('PRJ','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language']);

    // Get RSS parameter
    $allowRss=getParameter('RSSACT',$cnx->num);
    // Buttons line
    if (in_array('ADD_PRJ_SELF',$_SESSION['user_actions']) || in_array('ADD_PRJ_OTHERS',$_SESSION['user_actions']))
    {
      displayButton($button_new_project,'',$targetFile.'&action=new_project','tsc_awb_small tsc_awb_blue tsc_flat');
    }  
	
    // Get connections. If an active connection exists, allow to create a project from external connections
    $wkfConnection=new workflow('CON','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language']);

    // If allowed, display button to add a project
    if (in_array('ADD_EXT_PRJ_SELF',$_SESSION['user_actions']) || in_array('ADD_EXT_PRJ_OTHERS',$_SESSION['user_actions']))
    {
      $request=new sqlRequest("SELECT connection_id FROM kados_connections WHERE connection_status_id_fk=".$wkfConnection->id_etat_from_label('ACTCON'),$cnx->num);
      $request->countRows();
      if ($request->rowCount!=0)
      { 
        displayButton($button_new_ext_project,'',$targetFile.'&action=new_ext_project','tsc_awb_small tsc_awb_blue tsc_flat');
      }  
    } 
    displayButton($button_search_project,'',$targetFile.'&action=search_project','tsc_awb_small tsc_awb_yellow tsc_flat');
    // close floating left line?>
    <div class="clearleft"></div><?php
	
    $filterOnPrivateProjects='';
    if ($_SESSION['user_profile_tag']!='ADM')
    {
      $filterOnPrivateProjects="AND (project_visibility='PUB' OR (project_visibility='PRI' AND (profile_name!='' OR project_creator='".$_SESSION['login']."')))";
    }  
    // build projects bookmarks request
    $sqlProjectsBookmarks="SELECT project_id,project_name,DATE(project_creation_date) AS project_creation_date,bookmark_color,bookmark_order,project_levels,  
	                     status_translation_value AS status_value,project_external_project_id,project_external_project_connection_id,project_creator,  
	                     status_delete_available,status_update_available,CONCAT(user_firstname,' ',user_name) AS project_admin,profile_name,project_rss_key 
		           FROM framework_status,framework_status_translations,framework_users,kados_users_bookmarks book,kados_projects
			        LEFT JOIN kados_projects_users t2 ON t2.user_login_fk='".$_SESSION['login']."' AND t2.project_id_fk=project_id 
				LEFT JOIN framework_profiles ON t2.profile_id_fk=profile_id 
			   WHERE project_creator=user_login AND project_status_id_fk=status_id_fk AND status_id=status_id_fk 
			     AND status_translation_language='".$_SESSION['language']."'
                             ".$filterOnPrivateProjects."
			     AND book.user_login_fk='".$_SESSION['login']."' AND book.project_id_fk=project_id
			   ORDER BY bookmark_order";?>
    <div class="block1">
     <div class="selectColumnsTitle"><?php echo $text_my_bookmarks;?></div>
     <div style="margin-left:10px;">
     <table class="betaTable" style="box-sizing:border-box;width:100%"><?php
     
    // get bookmarks for current user  
    $request=new sqlRequest($sqlProjectsBookmarks,$cnx->num); 	  	     
    $resultsArray=$request->getArrayFields();

    // get all colors available 
    $request=new sqlRequest('SELECT * FROM kados_colors',$cnx->num); 	
    $colorsList=$request->getArrayFields();
	 
    // list all user bookmarks
    for ($i=0;$i<count($resultsArray);$i++)
    {
      // Check if there is a current release
      $currentReleaseId=0;
      // get next release based on today
      $request->sqlGet("SELECT release_id 
	                FROM kados_releases 
	                WHERE release_project_id_fk=".$resultsArray[$i]['project_id']." 
		          AND release_due_date>='".aujourdhui()."'
		        ORDER BY release_due_date ASC 
		        LIMIT 0,1");
      // if there is any, get its ID
      if ($request->countRows())
      {
        $request->getObject();
        $currentReleaseId=$request->objet->release_id;
      } 
      // Check if there is a current sprint
      $currentSprintId=0;
      // get current sprint based on today 
      $request->sqlGet("SELECT sprint_id 
                        FROM kados_sprints,kados_releases 
                        WHERE release_project_id_fk=".$resultsArray[$i]['project_id']." 
		          AND sprint_release_id_fk=release_id
		          AND sprint_start_date<='".aujourdhui()."' 
		          AND sprint_end_date>='".aujourdhui()."' 
		        ORDER BY sprint_start_date ASC 
		        LIMIT 0,1");
      // if any, get ID
      if ($request->countRows())
      {
        $request->getObject();
        $currentSprintId=$request->objet->sprint_id;
      } ?>
         <tr class="colorDisplay <?php echo $resultsArray[$i]['bookmark_color'];?>" >
            <td style="white-space: nowrap;">
                <a href="project_cockpit.php?fromProjectList=1&menu_lev1=cockpit&menu_lev2=cockpit&project_id=<?php echo $resultsArray[$i]['project_id'];?>" class="std_black_link"><span class="list_project_name_<?php echo $resultsArray[$i]['project_id'];?>"><?php echo $resultsArray[$i]['project_name'];?></span></a><?php        
	      if ($resultsArray[$i]['project_external_project_id'])
              {?>
	        <span class="upper_infos">
	          <img src="<?php echo $pathImages;?>chain.gif" tooltip="<?php echo changeDoubleQuote($text_external_project);?>" border="0"  />
                </span><?php
	      }?>
	    </td>
            <td>
              <!-- display link to kanban -->
              <a href="manage_kanban.php?fromProjectList=1&menu_lev1=prj_kanban&project_id=<?php echo $resultsArray[$i]['project_id'];?>" tooltip="<?php echo $text_goto_kanban;?>" ><img src="<?php echo $pathImages;?>app/kanban.png" border="0" /></a>
              <div class="project_card" style="display:inline-block"><span style="display:none"><?php echo $resultsArray[$i]['project_id'];?></span><img src="<?php echo $pathImages;?>app/card.png" tooltip="<?php echo $text_display_project_infos;?>" /></div></td>
	    <td style="white-space: nowrap;">
	      <!-- // allow to unset bookmark the project-->
              <a href="<?php echo $targetFile;?>&action=unbookmark_project&id_project=<?php echo $resultsArray[$i]['project_id'];?>" tooltip="<?php echo $action_unbookmark_project;?>"><img src="<?php echo $pathImages;?>app/star_off.png" border=0 /></a>
	      <div class="dropdown " style="display:inline;"><img src="<?php echo $pathImages;?>app/color.png" border="0" />
	        <div class="dropdown-content choice_color" ><?php
                for ($j=0;$j<count($colorsList);$j++)
                {?>
	          <a href="<?php echo $targetFile;?>&action=choose_color&color=<?php echo $colorsList[$j]['color_name']; ?>&id_project=<?php echo $resultsArray[$i]['project_id'];?>"><div class="colorDisplay <?php echo $colorsList[$j]['color_name']; ?>" style="display:inline-block;border-left:solid 1px #B8B8B8;border-right:solid 1px #B8B8B8;border-bottom:solid 1px #B8B8B8;"></div></a><?php
                }?>  
	        </div>
	      </div><?php
	      // Ordering
	      if ($i>0)
	      {?>
		<a href="<?php echo $targetFile;?>&action=bookmark_up&id_project=<?php echo $resultsArray[$i]['project_id'];?>" ><img src="<?php echo $pathImages;?>app/up.png" border=0 /></a><?php
	      }
	      else
              {?>
		<img src="<?php echo $pathImages;?>blank.gif" width="24" /><?php
              }
	      if ($i<count($resultsArray)-1)
	      {?>
                <a href="<?php echo $targetFile;?>&action=bookmark_down&id_project=<?php echo $resultsArray[$i]['project_id'];?>" ><img src="<?php echo $pathImages;?>app/down.png" border=0 /></a><?php
              }?> 
	    </td>		   
	    <td><?php
	      if ($currentReleaseId!=0)
	      {?>
	        <a href="manage_kanban.php?fromProjectList=1&menu_lev1=prj_kanban&project_id=<?php echo $resultsArray[$i]['project_id'];?>&release_id=<?php echo $currentReleaseId;?>" tooltip="<?php echo $action_goto_current_release;?>"><img src="<?php echo $pathImages;?>app/link2release.png" border="0" /></span></a><?php
	      }
	      if ($currentSprintId!=0)
	      {?>
	        <a href="manage_kanban.php?fromProjectList=1&menu_lev1=prj_kanban&project_id=<?php echo $resultsArray[$i]['project_id'];?>&sprint_id=<?php echo $currentSprintId;?>" tooltip="<?php echo $action_goto_current_sprint;?>"><img src="<?php echo $pathImages;?>app/link2sprint.png"  border="0" /></span></a><?php
	      }?>			 
	    </td>
            <td><?php echo $resultsArray[$i]['profile_name'];?></td>	
	    <td class="nowrap"><center><?php
              // Check if there is some related data : release,US
	      $noRelatedData=true;
	      $request->sqlGet('SELECT release_id AS nb_rel FROM kados_releases WHERE release_project_id_fk='.$resultsArray[$i]['project_id']);
              $request->countRows();
	      if ($request->rowCount!=0)
	      {
	        $noRelatedData=false;
	      }   
	      $request->sqlGet('SELECT us_id AS nb_us FROM kados_user_stories WHERE us_project_id_fk='.$resultsArray[$i]['project_id']);
              $request->countRows();
	      if ($request->rowCount!=0)
	      {
	        $noRelatedData=false;
	      }                
	      // Delete only if the template of status allows deletion, there is no related data and the current user has the right to delete a project
              if ($resultsArray[$i]['status_delete_available'] && $noRelatedData && (in_array('DELPRJ',$_SESSION['user_actions']) || isActionAllowedOnProjectForUser($_SESSION['login'],'DELPRJ',$resultsArray[$i]['project_id'])))
              {?>
                <a href="<?php echo $targetFile;?>&action=delete_project&id_to_delete=<?php echo $resultsArray[$i]['project_id'];?>" onclick="return confirm('<?php echo $msg_confirm_delete_project;?>');" tooltip="<?php echo $action_delete_project;?>"><img src="<?php echo $pathImages;?>delete.png" border=0 /></a><?php
              }?></center>
            </td>            
          </tr><?php
        }?>
      </table>
     </div>
    </div>
    <div class="block2">
     <div class="selectColumnsTitle"><?php echo $text_recent_comments;?></div>
     <div style="margin-left:10px;">
     <table class="betaTable" style="box-sizing:border-box;width:100%;">
       <tr> 
         <th><?php echo $text_project; ?></th>         		            
         <th><?php echo $text_us;?></th>
         <th><?php echo $text_comment; ?></th>         
	 <th><?php echo $text_written_by; ?></th>
       </tr>    <?php
      // get messages
      $request->sqlGet("SELECT 	postit_comment_text,user_firstname,user_name,us_number,
                                project_name,project_id,postit_comment_waved_users,us_id    
                        FROM kados_postit_comments,kados_user_stories,framework_users,
                             kados_projects, kados_users_bookmarks  
                        WHERE postit_comment_postit_type='US' 
                          AND postit_comment_user_login_fk=user_login
                          AND postit_comment_postit_id_fk=us_id 
                          AND us_project_id_fk=project_id 
                          AND project_id=project_id_fk 
                          AND user_login_fk='".$_SESSION['login']."'
                        ORDER BY postit_comment_date DESC
                        LIMIT 0,25",$cnx->num); 	  	     
      $resultsArray=$request->getArrayFields();       
      // list all user bookmarks
      for ($i=0;$i<count($resultsArray);$i++)
      {?>
       <tr>
           <td> <a class="small_link" href="project_cockpit.php?fromProjectList=1&menu_lev1=cockpit&menu_lev2=cockpit&project_id=<?php echo $resultsArray[$i]['project_id'];?>" class="small_link"><span class="list_project_name_<?php echo $resultsArray[$i]['project_id'];?>"><?php echo $resultsArray[$i]['project_name'];?></span></a></td>  
           <td><div class="commentsButtonHome">US<?php echo $resultsArray[$i]['us_number'];?><span class="hidden-div usId"><?php echo $resultsArray[$i]['us_id'];?></span></div></td>  
         <td><?php 
           $newWithUser=(strpos('-'.$resultsArray[$i]['postit_comment_waved_users'],'@['.$_SESSION['login'].']'));
           if ($newWithUser)
           {?>
                <img src="<?php echo $pathImages;?>app/newCommentUser.png" /><?php               
           }
           echo $resultsArray[$i]['postit_comment_text'];?>
         </td>  
         <td><?php echo $resultsArray[$i]['user_firstname'].' '.$resultsArray[$i]['user_name'];?></td>  
       </tr><?php
       }?>
     </table>
        </div>
    </div>    
    <div class="clearleft"></div>          <?php
	
  }
require_once PATHBASE.'footer.php';?>

