<?php
/**
 * Trash page for User Stories
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'./');
$targetFile='trash_tasks.php?menu_lev2=trash_tsk';
	  
include PATHBASE.'header.php';

$itemType='tasks_sprint';
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);

if (isset($_SESSION['current_project_id']))
{
  $showOnlyProjectLevel=true;  
  include PATHBASE.'railway_display.php';    
    
  /* Dashboard settings */
  include PATHBASE.'dashboard_settings.php';

  $allowDelete=in_array('DELTASK',$_SESSION['user_actions']) || in_array('DELTASK',$_SESSION['user_local_actions']);
  switch ($_REQUEST['action'])
  {
    case 'delete_task':
      // delete task history
      $request->sqlGet("DELETE FROM kados_postit_history 
                        WHERE history_item_postit_type='TASK'  
                          AND history_item_postit_id_fk=".$_REQUEST['task2delete']);         
      // delete attachments
      // compute directiry name  
      $filesDirectoryName=getParameter('FLPATH',$cnx->num).'/TASK/TASK'.$_REQUEST['task2delete'];
                
      // if directiry exists
      if (is_dir($filesDirectoryName))
      {
        // scan directory to get files  
        $attachmentFilesList=scandir($filesDirectoryName);      
        // delete all files in directory
        for ($nbFiles=0;$nbFiles<count($attachmentFilesList);$nbFiles++)
        { 
          // if file is not one of the two standard files, delete it
          if ($attachmentFilesList[$nbFiles]!='..' && $attachmentFilesList[$nbFiles]!='.')
          {
            unlink(PATHBASE.$filesDirectoryName.'/'.$attachmentFilesList[$nbFiles]);  
          }
        }
        // delete directory
        rmdir(PATHBASE.$filesDirectoryName);
      }  
      // delete comments
      $request->sqlGet("DELETE FROM kados_postit_comments
                        WHERE postit_comment_postit_type='TASK'  
                          AND postit_comment_postit_id_fk=".$_REQUEST['task2delete']);          
      // delete task
      $request->sqlGet("DELETE FROM kados_tasks WHERE task_id=".$_REQUEST['task2delete']);?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_deleted;?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php	  
    break;
  
    case 'cancel_trash_task':
      // get sprint of the task
      $request->sqlGet("SELECT us_sprint_id_fk FROM kados_tasks,kados_user_stories WHERE us_id_fk=us_id AND task_id=".$_REQUEST['task2reactivate']);
      $request->getObject();
      $currentSprintId=$request->objet->us_sprint_id_fk;
      // get max zpos to set reactivated task zpos
      $request->sqlGet("SELECT MAX(kados_tasks.zpos) AS maxi FROM kados_tasks,kados_user_stories WHERE kados_tasks.active=1 AND us_id_fk=us_id AND us_project_id_fk=".$_SESSION['current_project_id']);
      $maxZpos=$request->getObject();
      $request->sqlGet("UPDATE kados_tasks SET active=1,zpos=".((int)$maxZpos->maxi+1)." WHERE task_id=".$_REQUEST['task2reactivate']);
      // add history items
      $history=new history($cnx->num);
      // status
      $history->addPostitHistory('TASK',intval($_REQUEST['task2reactivate']),'trash_out','','', $_SESSION['login']);            
      // update burndown graph data
      if ($currentSprintId!=0)
      {    
        require_once PATHBASE.'progress_recording.php';	  
      }  
    break;  
  }

  // Get Tasks of trash
  $request=new sqlRequest("SELECT task_id,kados_tasks.text,kados_tasks.color,
                               task_done AS infoBottomLeft,task_raf AS infoBottomRight,
							   task_load AS header_stamp,CONCAT(task_us_number,'.',task_number) AS display_task_number 
                        FROM kados_tasks,kados_user_stories 
		 	  		    WHERE kados_tasks.active=-1 AND us_id_fk=us_id AND us_project_id_fk=".$_SESSION['current_project_id'],$cnx->num);
  $trashItemsArray=$request->getArrayFields();?>

  <div class="deck"><?php

  // init a comment object
  $commentObject=new comment($cnx->num);
  // init user object
  $userObject=new appUser($cnx->num,$_SESSION['login']);
  
  // if no Task in trash  
  if (count($trashItemsArray)==0)
  {
    // display a text    
    echo $text_trash_is_empty;
  }
  for ($k=0;$k<count($trashItemsArray);$k++)
  {?>
      <div style="float:left;">
        <div class="note_deck <?php echo $trashItemsArray[$k]['color'];?>" style="width:<?php echo $itemWidth;?>px;margin-left:18px;">
	     <div class="item-header" >
		  <span class="deck_header-left"><?php
		  if ($allowDelete)
		  {?>
		    <a href="<?php echo $targetFile.'&action=delete_task&task2delete='.$trashItemsArray[$k]['task_id'];?>" onClick="return confirm('<?php echo $msg_confirm_delete_task;?>');"><img src="<?php echo $pathImages.'app/delete.png';?>" border="0"></a> 
		    <a href="<?php echo $targetFile.'&action=cancel_trash_task&task2reactivate='.$trashItemsArray[$k]['task_id'];?>" onClick="return confirm('<?php echo $msg_confirm_activate_task;?>');"><img src="<?php echo $pathImages.'app/trash_out.png';?>" border="0"></a><?php
		  }?>	
  
                    <span class="postit_details bloc-header" id="history_<?php echo $trashItemsArray[$k]['task_id'];?>"  style="cursor:pointer"><img src="<?php echo $pathImages;?>app/history.png" border="0" /></span>	
                    
                    <script type="text/javascript">
                     $('#history_<?php echo $trashItemsArray[$k]['task_id'];?>').click( function() {
                          $('<div>').dialog({
                               position: { my: "center center", at: "center center", of: window } ,
                               modal: true,
                               open: function ()
                               {
                                  $(this).load('postit_history.php?i=<?php echo $trashItemsArray[$k]['task_id'];?>&t=task');
                               },         
                               minWidth:800,
                               height:600,
                               resizable:true,
                               title: "History"
                       });
                     });
                    </script>  
                  </span>  
		  <span class="deck_postit_id">T<?php echo $trashItemsArray[$k]['display_task_number'];?></span>
		  <span class="deck_postit_header-right"><?php 
		    if (isset($functionForHeaderStamp))
			{
		      call_user_func($functionForHeaderStamp,array($trashItemsArray[$k]['task_id'],$trashItemsArray[$k]['header_stamp'],false)); 
			}
            else
            {
              echo htmlspecialchars($trashItemsArray[$k]['header_stamp']);
            }?></span>	
            <span class="clearright"></span>
		 </div>
		 <div class="deck_postit_text" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"><?php echo make_clickable(nl2br(htmlspecialchars($trashItemsArray[$k]['text'])));?></div>
	     <div class="deck_item-footer">
		    <span class="deck_postit_footer-left"><?php if (isset($trashItemsArray[$k]['infoBottomLeft'])) { echo $trashItemsArray[$k]['infoBottomLeft'];}?></span>
		    <span class="deck_postit_footer-right"><?php if (isset($trashItemsArray[$k]['infoBottomRight'])) { echo $trashItemsArray[$k]['infoBottomRight'];}?></span>
		 </div>			 
	  </div>
      
          <div class="trash-comment-zone" id="comments_<?php echo $trashItemsArray[$k]['task_id'];?>" style="left:3px;top:6px;cursor:pointer" >
	      <img src="<?php echo $pathImages;?>app/comment.png" style="position:absolute;left:1px;top:2px" />
              <script type="text/javascript">
                     $('#comments_<?php echo $trashItemsArray[$k]['task_id'];?>').click( function() {
                          
                          $('<div>').dialog({
                               position: { my: "center center", at: "center center", of: window } ,
                               modal: true,
                               open: function ()
                               {
                                  // o is the ID of opener of the dialog
                                  $(this).load('postit_comments.php?i=<?php echo $trashItemsArray[$k]['task_id'];?>&t=task&mode=ro');
                               },         
                               minWidth:600,
                               height:600,
                               resizable:true,
                               title: "Comments",
                               close: function(ev, ui) { 
                                  // destroy dialog
                                  $(this).dialog('destroy')
                               }
                       });
                     });
                    </script>  
            <div class="new-comment-zone" style="left:-1px;top:-3px;"><?php
            $newCommentForUser=$commentObject->getPostitHasNewComment($trashItemsArray[$k]['task_id'],'us',$userObject->getUserPreviousLoginDate(),$_SESSION['login']);
              if ($newCommentForUser[1]!=0)
              {?>
                <img src="<?php echo $pathImages;?>app/newCommentUser.png" /><?php
              }
              else if ($newCommentForUser[0]!=0)
              {?>
                <img src="<?php echo $pathImages;?>app/newComment.png" /><?php
              }     ?>  
            </div>   	    <?php
            // Number of comments 
            $countComment=$commentObject->getPostitCommentsCount($trashItemsArray[$k]['task_id'],'task');?>
            <div class="comment-counter-zone" id="comments_counter_<?php echo $trashItemsArray[$k]['task_id'];?>" style="left:<?php echo ($countComment>9 ? '0' : '4');?>px;top:16px;"><?php echo $countComment;?></div>
            </div> 
       </div><?php          
  }?>
  </div> 
  <div class="clearleft"></div><?php
}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}
include PATHBASE.'footer.php';?>