<?php
/**
 * Trash page for User Stories
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'./');
$targetFile='trash_us.php?menu_lev2=trash_us';
	  
include PATHBASE.'header.php';

$itemType='us_project';
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);

if (isset($_SESSION['current_project_id']))
{
  $showOnlyProjectLevel=true;  
  include PATHBASE.'railway_display.php';    
    
  /* Dashboard settings */
  include PATHBASE.'dashboard_settings.php';
  $firstColumnFunctionForHeaderStamp='displayStatusImageButton';

  $allowDelete=in_array('DEL_US',$_SESSION['user_actions']) || in_array('DEL_US',$_SESSION['user_local_actions']);
  switch ($_REQUEST['action'])
  {
    case 'delete_us':
      // delete from decks  
      $request->sqlGet("DELETE FROM kados_users_decks WHERE item_id_fk=".$_REQUEST['us2delete']);  
      // delete linked tasks history  
      $request->sqlGet("DELETE FROM kados_postit_history 
                        WHERE history_item_postit_type='TASK'  
                          AND history_item_postit_id_fk IN(SELECT task_id 
                                                           FROM kados_tasks 
                                                           WHERE us_id_fk=".$_REQUEST['us2delete'].")");
      // delete linked tasks
      $request->sqlGet("DELETE FROM kados_tasks WHERE us_id_fk=".$_REQUEST['us2delete']);
      // delete US history
      $request->sqlGet("DELETE FROM kados_postit_history 
                        WHERE history_item_postit_type='US'  
                          AND history_item_postit_id_fk=".$_REQUEST['us2delete']); 
      // delete attachments
      // compute directiry name  
      $filesDirectoryName=getParameter('FLPATH',$cnx->num).'/US/US'.$_REQUEST['us2delete'];
                
      // if directiry exists
      if (is_dir($filesDirectoryName))
      {
        // scan directory to get files  
        $attachmentFilesList=scandir($filesDirectoryName);      
        // delete all files in directory
        for ($nbFiles=0;$nbFiles<count($attachmentFilesList);$nbFiles++)
        { 
          // if file is not one of the two standard files, delete it
          if ($attachmentFilesList[$nbFiles]!='..' && $attachmentFilesList[$nbFiles]!='.')
          {
            unlink(PATHBASE.$filesDirectoryName.'/'.$attachmentFilesList[$nbFiles]);  
          }
        }
        // delete directory
        rmdir(PATHBASE.$filesDirectoryName);
      }
      // delete comments
      $request->sqlGet("DELETE FROM kados_postit_comments
                        WHERE postit_comment_postit_type='US'  
                          AND postit_comment_postit_id_fk=".$_REQUEST['us2delete']);  
      // delete US
      $request->sqlGet("DELETE FROM kados_user_stories WHERE us_id=".$_REQUEST['us2delete']);  
      ?>
      <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_deleted;?></div>           <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg;?>).slideUp("slow");</script><?php	  
    break;
  
    case 'cancel_trash_us':
      $request->sqlGet("SELECT MAX(zpos_r) AS maxi FROM kados_user_stories WHERE active=1 AND us_project_id_fk=".$_SESSION['current_project_id']);
      $maxZpos_r=$request->getObject();
      $request->sqlGet("SELECT MAX(zpos_s) AS maxi FROM kados_user_stories WHERE active=1 AND us_project_id_fk=".$_SESSION['current_project_id']);
      $maxZpos_s=$request->getObject();
      $request->sqlGet("UPDATE kados_user_stories SET active=1,zpos_r=".((int)$maxZpos_r->maxi+1).",zpos_s=".((int)$maxZpos_s->maxi+1)." WHERE us_id=".intval($_REQUEST['us2reactivate']));
      // add history items
      $history=new history($cnx->num);
      // status
      $history->addPostitHistory('US',intval($_REQUEST['us2reactivate']),'trash_out','','', $_SESSION['login']);         
    break;  
  }

  // Get US of trash
  $request=new sqlRequest("SELECT us_id,text,status AS header_stamp,color,business_value AS infoBottomLeft,
                               complexity AS infoBottomRight,us_number 
                        FROM kados_user_stories 
		 	  		    WHERE active=-1 AND us_project_id_fk=".$_SESSION['current_project_id'],$cnx->num);
  $trashItemsArray=$request->getArrayFields();?>

  <div class="deck"><?php

  // init a comment object
  $commentObject=new comment($cnx->num);
  // init user object
  $userObject=new appUser($cnx->num,$_SESSION['login']);
  
  // if no US in trash
  if (count($trashItemsArray)==0)
  {
    // display a text  
    echo $text_trash_is_empty;
  }
  for ($k=0;$k<count($trashItemsArray);$k++)
  {?>
    <div style="float:left;">
      <div class="note_deck <?php echo $trashItemsArray[$k]['color'];?>" style="width:<?php echo $itemWidth;?>px;margin-left:18px;">
	     <div class="item-header" >
		  <span class="deck_header-left"><?php
		  if ($allowDelete)
		  {?>
		    <a href="<?php echo $targetFile.'&action=delete_us&us2delete='.$trashItemsArray[$k]['us_id'];?>" onClick="return confirm('<?php echo $msg_confirm_delete_us;?>');"><img src="<?php echo $pathImages.'app/delete.png';?>" border="0"></a> 
		    <a href="<?php echo $targetFile.'&action=cancel_trash_us&us2reactivate='.$trashItemsArray[$k]['us_id'];?>" onClick="return confirm('<?php echo $msg_confirm_activate_us;?>');"><img src="<?php echo $pathImages.'app/trash_out.png';?>" border="0"></a><?php
                  }?>		
                    <span class="postit_details bloc-header" id="history_<?php echo $trashItemsArray[$k]['us_id'];?>"  style="cursor:pointer"><img src="<?php echo $pathImages;?>app/history.png" border="0" /></span>	
                    
                    <script type="text/javascript">
                     $('#history_<?php echo $trashItemsArray[$k]['us_id'];?>').click( function() {
                          $('<div>').dialog({
                               position: { my: "center center", at: "center center", of: window } ,
                               modal: true,
                               open: function ()
                               {
                                  $(this).load('postit_history.php?i=<?php echo $trashItemsArray[$k]['us_id'];?>&t=us');
                               },         
                               minWidth:800,
                               height:600,
                               resizable:true,
                               title: "History"
                       });
                     });
                    </script>                     
		  </span>
		  <span class="deck_postit_id">US<?php echo $trashItemsArray[$k]['us_number'];?></span>
		  <span class="deck_postit_header-right"><?php 
		    if (isset($firstColumnFunctionForHeaderStamp))
			{
		      call_user_func($firstColumnFunctionForHeaderStamp,array($trashItemsArray[$k]['us_id'],$trashItemsArray[$k]['header_stamp'],false,'')); 
			}
            else
            {
              echo htmlspecialchars($trashItemsArray[$k]['header_stamp']);
            }?></span>	
            <span class="clearright"></span>
		 </div>
		 <div class="deck_postit_text" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"><?php echo make_clickable(nl2br(htmlspecialchars($trashItemsArray[$k]['text'])));?></div>
	     <div class="deck_item-footer">
		    <span class="deck_postit_footer-left"><?php if (isset($trashItemsArray[$k]['infoBottomLeft'])) { echo $trashItemsArray[$k]['infoBottomLeft'];}?></span>
		    <span class="deck_postit_footer-right"><?php if (isset($trashItemsArray[$k]['infoBottomRight'])) { echo $trashItemsArray[$k]['infoBottomRight'];}?></span>
		 </div>			 
	  </div>
          <div class="trash-comment-zone" id="comments_<?php echo $trashItemsArray[$k]['us_id'];?>" style="left:3px;top:6px;cursor:pointer" >
	      <img src="<?php echo $pathImages;?>app/comment.png" style="position:absolute;left:1px;top:2px" />
              <script type="text/javascript">
                     $('#comments_<?php echo $trashItemsArray[$k]['us_id'];?>').click( function() {
                          
                          $('<div>').dialog({
                               position: { my: "center center", at: "center center", of: window } ,
                               modal: true,
                               open: function ()
                               {
                                  // o is the ID of opener of the dialog
                                  $(this).load('postit_comments.php?i=<?php echo $trashItemsArray[$k]['us_id'];?>&t=us&mode=ro');
                               },         
                               minWidth:600,
                               height:600,
                               resizable:true,
                               title: "Comments",
                               close: function(ev, ui) { 
                                  // destroy dialog
                                  $(this).dialog('destroy')
                               }
                       });
                     });
                    </script>  
            <div class="new-comment-zone" style="left:-1px;top:-3px;"><?php
            $newCommentForUser=$commentObject->getPostitHasNewComment($trashItemsArray[$k]['us_id'],'us',$userObject->getUserPreviousLoginDate(),$_SESSION['login']);
              if ($newCommentForUser[1]!=0)
              {?>
                <img src="<?php echo $pathImages;?>app/newCommentUser.png" /><?php
              }
              else if ($newCommentForUser[0]!=0)
              {?>
                <img src="<?php echo $pathImages;?>app/newComment.png" /><?php
              }     ?>  
            </div>   	    <?php
            // Number of comments 
            $countComment=$commentObject->getPostitCommentsCount($trashItemsArray[$k]['us_id'],'us');?>
            <div class="comment-counter-zone" id="comments_counter_<?php echo $trashItemsArray[$k]['us_id'];?>" style="left:<?php echo ($countComment>9 ? '0' : '4');?>px;top:16px;"><?php echo $countComment;?></div>
            </div> 
</div>   <?php
  }?>
  </div>
  <div class="clearleft"></div><?php
}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}
include PATHBASE.'footer.php';?>