<?php
// Init step check right to write in conf/
// First Step : connect.conf 
// Second Step : update DB
// Third Step : update LDAP conf
// Fourth Step : update VERSION file with new version
define("PATHBASE","../../../");

$errorMessages['ERR_FINDFILE_LDAP']="Error : unable to find ldap conf file => Sorry, you'll have to do it manually.";
$errorMessages['ERR_CONNECTDB']='Error : unable to connect to DB';
$errorMessages['ERR_CONNECTDATA']='Error : no conf file for connection';
$errorMessages['ERR_RENAME']= "Error : impossible to rename connect.conf => Sorry, you'll have to do it manually.";
$errorMessages['ERR_FINDFILE_CONF']="Error : unable to find conf file => Sorry, you'll have to do it manually.";

// STEP 1
echo 'STEP1 : Starting connection data update.<br />';
require 'update_connect_conf.php';
if ($result=='OK' || $result=='WARN_DONE')
{?>
  <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
  if ($result=='OK')
  {
    echo 'Connection data update OK, going to next step.<br /><br />';
  }
  else if($result=='WARN_DONE')
  {
    echo 'Connection data update already done, going to next step.<br /><br />';  
  }
  // STEP 2
  echo 'STEP2 : Starting DB update.<br />';
  require PATHBASE."conf/connect.conf";
  $mysqli = new mysqli(PARAM_CNX_HOST, PARAM_CNX_USER, PARAM_CNX_PASS, PARAM_CNX_DB);  
  $mysqli->query("SET NAMES '".PARAM_CNX_CHARSET."'");
  // check if update already done
  $resultCheck=$mysqli->query("SELECT COUNT(*) FROM information_schema.columns
                               WHERE table_schema = '".PARAM_CNX_DB."' 
                                AND  table_name = 'framework_users';");
  $row = $resultCheck->fetch_row();
  if ($row[0]!=21)
  {
    $queries=file('upgrade.sql');

    $overallResult=true;
    $file=fopen('upgrade_sql_error.txt','w');
    for ($i=0;$i<count($queries);$i++)
    {
      $resultQuery=$mysqli->query($queries[$i]);
      $overallResult= $overallResult && $resultQuery;
      if (!$resultQuery)
      {
        fwrite($file,"REQUEST #".($i+1).' : '.$mysqli->error."\n");
      }
    }  
    fclose($file);
    $mysqli->close();
    if ($overallResult)
    {?>
      <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
      echo 'DB update OK, going to next step.<br /><br />'; 
    }      
    else
    {?>
      <img src='<?php echo PATHBASE;?>images/error.png'/> <?php  
      echo "At least one request was not correctly executed.<br />Here are the errors found. You will have to manually complete the upgrade.<br /><i>";
      include 'upgrade_sql_error.txt';
      echo '</i><br /><br />';
    }
  }
  else
  {
     echo 'DB update already done, going to next step.<br /><br />'; 
  }
  // STEP 3
  echo 'STEP3 : Starting LDAP conf update.<br />';
  require 'update_ldap_conf.php';
  if ($result=='OK')
  {?>
    <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
    echo 'Update LDAP conf OK, going to next step.<br /><br />';
    // STEP 4 
    echo 'STEP : Update VERSION file.<br />';
    unlink(PATHBASE.'VERSION');
    copy(PATHBASE.'VERSION_NEW',PATHBASE.'VERSION');?>
    <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
    echo 'Update VERSION file, upgrade is finished.<br /><br />';?><br />
    <a href="<?php echo PATHBASE;?>index.php" >CONNECT TO KADOS</a><?php
  }
  else
  {?>
    <img src='<?php echo PATHBASE;?>images/error.png'/> <?php  
    echo $errorMessages[$result];
    echo '<br />You will have to proceed with a manual upgrade, please refer to upgrade_FR.txt or upgrade_EN.txt in the upgrade release package';
  }
}
else
{?>
  <img src='<?php echo PATHBASE;?>images/error.png'/> <?php  
  echo $errorMessages[$result];
  echo '<br />You will have to proceed with a manual upgrade, please refer to upgrade_FR.txt or upgrade_EN.txt in the upgrade release package';
}?>