<?php

/**
 * Checking pre-requisite before installing Kados
 *
 * @category YYYYYYYYY
 * @package  XXXXXXXXX
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */

/* Checking PHP version */
/* Checking GD version */
/* Checking mbstring */

$phpVersion=phpversion();
echo ' => ';
if ($phpVersion>='5.3.0')
{
  $phpVersionStatus=true;  
  $phpVersionMsg='PHP Version : '.$phpVersion.', you have a correct version of PHP';
}
else
{
  $phpVersionStatus=false;  
  $phpVersionMsg="PHP Version : ".$phpVersion.",You must have PHP with at least version 5.3, else some part of Kados using DateInterval Class won't work.";
}

$phpVersionObsolete=false;
$phpVersionObsoleteMsg='Your PHP Version is higher than PHP 5.5, perfect!<br />';
if ($phpVersion<'5.5.0')
{
  $phpVersionObsolete=true;  
  $phpVersionObsoleteMsg='Your PHP Version is obsolete or about to be obsolete, we recommand you to install PHP 5.5 or higher.<br />';
}
$extensions=get_loaded_extensions();
if (in_array('gd',$extensions))
{
  $gdStatus=true;
  $gdMsg='GD is installed on your server.';
  $infosGD=gd_info();
  $gdVersion=$infosGD['GD Version'];
  $start=strpos($gdVersion,'(');
  $blank=strpos($gdVersion,' ',$start);
  $gdRealVersion=substr($gdVersion,$start+1,$blank-$start-1);
  if ($gdRealVersion>='2.1.0')
  {
    $gdVersionStatus=true;  
    $gdVersionMsg='Your GD version is correct : '.$gdRealVersion;
  }  
  else
  {
    $gdVersionStatus=true; 
    $gdVersionMsg="Your GD version is not correct : you won't be abe to use some graphs. You must install at least version 2.1.0";
  }           
}
else
{
  $gdStatus=true;
  $gdMsg="The GD library is not installed on your server :  you won't be abe to use graphs. You must install GD 2.1.0 at least";
}   
if (in_array('mbstring',$extensions))
{
  $mbStringStatus=true;  
  $mbStringMsg='MB String is installed on your server.';
}
else
{
  $mbStringStatus=false;    
  $mbStringMsg="MB String library is not installed on your server : you won't be abe to use the postit history feature<br />";
}  
if (in_array('ldap',$extensions))
{
  $ldapStatus=true;  
  $ldapMsg='LDAP is installed on your server.';
}
else
{
  $ldapStatus=false;    
  $ldapMsg="LDAP library is not installed on your server : you won't be abe to create an user linked to an LDAP server<br />";
}  
?>

This script will test your server configuration to check if you can deploy Kados with all features.<br /><br />

<table border="1">
    <tr><td>Setting</td><td align="center">Check</td><td>Explanation</td></tr> 
    <tr><td>PHP Version</td><td align="center"><img src="../images/<?php echo ($phpVersionStatus? 'flag_green':'flag_red'); ?>.png"/></td><td><?php echo $phpVersionMsg;?></td></tr>  
    <tr><td>PHP Version up to date ?</td><td align="center"><img src="../images/<?php echo (!$phpVersionObsolete? 'flag_green':'flag_red'); ?>.png"/></td><td><?php echo $phpVersionObsoleteMsg;?></td></tr>  
    <tr><td>GD library</td><td align="center"><img src="../images/<?php echo ($gdStatus? 'flag_green':'flag_red'); ?>.png"/></td><td><?php echo $gdMsg;?></td></tr>      
    <tr><td>GD library version</td><td align="center"><img src="../images/<?php echo ($gdVersionStatus? 'flag_green':'flag_red'); ?>.png"/></td><td><?php echo $gdVersionMsg;?></td></tr>      
    <tr><td>MB String library</td><td align="center"><img src="../images/<?php echo ($mbStringStatus? 'flag_green':'flag_red'); ?>.png"/></td><td><?php echo $mbStringMsg;?></td></tr>      
    <tr><td>LDAP library</td><td align="center"><img src="../images/<?php echo ($ldapStatus? 'flag_green':'flag_orange'); ?>.png"/></td><td><?php echo $ldapMsg;?></td></tr>      
</table>
<br />
<div><?php 
$installOK=$phpVersionStatus && !$phpVersionObsolete && $gdStatus && $gdVersionStatus && $mbStringStatus;

if ($phpVersionStatus && !$phpVersionObsolete && $gdStatus && $gdVersionStatus && $mbStringStatus)
{?>
  <img src='../images/active.gif'/> Everything is OK you can install Kados on this server<?php
}
else
{?>
  <img src='../images/warning.gif'/> Please update your server with the recommandations if you want to use Kados<?php
}?>
<br /><?php
if ($ldapStatus)
{?>
  <img src='../images/active.gif'/> The optional module is available<?php
}
else
{?>
  <img src='../images/flag_orange.png'/> The optional module is not available. If you want to use it, please update your server<?php
} ?>
</div>