<?php
/**
 * Get tags linked to a specific scope : project or global
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
session_start();

if (isset($_SESSION['login']))
{    
  define("PATHBASE",'../');
  $pathCommons=PATHBASE.'common_scripts/';
  include PATHBASE.'conf/connect.conf';
  include PATHBASE.'libraries/classes/class_connexion_mysql.php';
  include $pathCommons.'app_functions.php';
  include $pathCommons.'functions.php';

  // set DB connexion
  $cnx=new connexion_db();

  // set filter for private projects
  $filterOnPrivateProjects='';
  if ($_SESSION['user_profile_tag']!='ADM')
  {
    $filterOnPrivateProjects="AND (project_visibility='PUB' OR (project_visibility='PRI' AND (profile_name!='' OR project_creator='".$_SESSION['login']."')))";
  } 

// get list of tags that are not in a group and that are from the selected type (US or task)
$request=new sqlRequest("SELECT project_id,project_name,profile_name   
                         FROM kados_projects 
                           LEFT JOIN kados_projects_users t2 ON t2.user_login_fk='".$_SESSION['login']."' AND t2.project_id_fk=project_id 
	                   LEFT JOIN framework_profiles ON t2.profile_id_fk=profile_id                          
                         WHERE LOCATE('".$_POST['query']."',LOWER(project_name))
                             ".$filterOnPrivateProjects." 
                           AND project_id NOT IN(SELECT project_id_fk 
                                                 FROM kados_users_bookmarks 
                                                 WHERE user_login_fk='".$_SESSION['login']."')",$cnx->num);

$listProjects=$request->getArrayFields();
echo json_encode($listProjects);

}?>