<?php
/**
 * Get tags linked to a specific scope : project or global
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
session_start();

if (isset($_SESSION['login']))
{    
  define("PATHBASE",'../');
  $pathCommons=PATHBASE.'common_scripts/';
  $pathClasses=PATHBASE.'libraries/classes/';
  include PATHBASE.'conf/connect.conf';
  include PATHBASE.'libraries/classes/class_connexion_mysql.php';
  include $pathCommons.'app_functions.php';
  include $pathCommons.'functions.php';
  require_once $pathClasses.'class_workflow.php';
  
  $cnx=new connexion_db();
  $simpleItemType=strtolower($_POST['item_type']);
  $colorName=$_POST['color'];
  $listTags=array();
  // get tags for the project
  $wkf=new workflow('TAG','framework_workflows','framework_status','framework_workflows_transitions',$_SESSION['language'],PATHBASE);
  $wkf->set_profile('framework_workflows_transitions_profiles','profile_id_fk',$_SESSION['user_profile']);
  $request=new sqlRequest("(SELECT tag_id,tag_label,tag_group_id_fk,tag_group_name 
                    FROM kados_tags_projects,kados_tags 
                         LEFT JOIN kados_tags_groups ON tag_group_id_fk=tag_group_id 
		    WHERE tag_id_fk=tag_id 
		      AND project_id_fk=".$_SESSION['current_project_id']."
		      AND tag_type IN('USR_FREE','ALL_FREE') 
                      AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')." 
                      AND LOWER(tag_postit_type)='".$simpleItemType."')
		   UNION 
                   (SELECT tag_id,tag_label,tag_group_id_fk,tag_group_name  
                    FROM kados_tags
                         LEFT JOIN kados_tags_groups ON tag_group_id_fk=tag_group_id 
		    WHERE tag_type='ALL_MAND' 
                      AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')." 
                      AND LOWER(tag_postit_type)='".$simpleItemType."')
		    ORDER BY tag_group_id_fk,tag_label",$cnx->num);
  $projectTagsList=$request->getArrayFields(); 
  // get ID of tags
  $listTagsIds=array();
  for ($i=0;$i<count($projectTagsList);$i++)
  {
    $listTagsIds[$i]=$projectTagsList[$i]['tag_id'];
  }  
  // get matrix for tag and postit
  $request->sqlGet("SELECT tag_id_fk,group_concat(color separator ':') 
                    FROM kados_tags_allocations,kados_colors_uses,kados_tags  
                    WHERE use_color_id=color_use_id_fk 
                      AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')."
                      AND tag_id_fk=tag_id 
                    GROUP BY tag_id_fk ");  
  $listTagsWithAllocations=$request->getArrayFieldsOneField();
  
  
// compute which tag is allowed for which postit color
$listResultsTagsTmp=$listTagsIds;    
// for each tag that has allocations, test if the color is in allocation or not
// tags without allocations are available for sure.
foreach($listTagsWithAllocations  as $tagId => $tagAllocations)
{
  // find if color is not in the tag allocations => meaning the tag must be hidden for that color
  if(strpos('_'.$tagAllocations,$colorName)===false)  
  {
    // find which key has the tag id
    $res=array_search($tagId,$listTagsIds);
    // if key exists
    if (!($res===false))
    {
      // remove it from  the list
      unset($listResultsTagsTmp[$res]);
    }  
  }
}
  $listResultsTags=array();  
  if (count($listResultsTagsTmp)!=0)
  {
    $request=new sqlRequest("SELECT tag_id,tag_label,tag_group_id_fk,tag_group_name  
                             FROM kados_tags LEFT JOIN kados_tags_groups ON tag_group_id_fk=tag_group_id  
                             WHERE tag_id IN(".implode(',',$listResultsTagsTmp).") 
                             ORDER BY tag_group_id_fk,tag_label",$cnx->num);
    $listResultsTags=$request->getArrayFields();
  }  
  echo json_encode($listResultsTags);

}?>