<?php
/**
 * Get US (that has tasks) linked to a specific scope : project, release, sprint
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
session_start();

if (isset($_SESSION['login']))
{    
  define("PATHBASE",'../');
  $pathCommons=PATHBASE.'common_scripts/';
  $pathAppClasses=PATHBASE.'classes/';

  include PATHBASE.'conf/connect.conf';
  include PATHBASE.'libraries/classes/class_connexion_mysql.php';
  include $pathCommons.'date_hour.php';
  include $pathCommons.'app_functions.php';
  include $pathCommons.'functions.php';
  require_once $pathAppClasses.'relationship.php';
  
  $cnx=new connexion_db();

  $usId=intval($_POST['us_id']);

  // Set scope
  // default scope is project
  $scope=' us_project_id_fk='.$_SESSION['current_project_id'];
  if ($_POST['scope']=='sprint')
  {
    // Scope is sprint  
    $scope=' us_sprint_id_fk='.$_SESSION['current_sprint_id'];
  }
  else if ($_POST['scope']=='release')
  {
    // Scope is Release  
    $scope=' us_release_id_fk='.$_SESSION['current_release_id'];
  }

  // create relationship object
  $postitRelationships=new relationship($cnx->num);
  // set current US 
  $postitRelationships->setFirstUs(intval($usId));     
  // get relationship
  $relationshipsList=$postitRelationships->getUsRelationships();    
  // get list of US from the same release
  // build array with US to ignore (the current one and those already in relation to the current one
  $ignoredUs= array_merge(array(intval($usId)), array_column($relationshipsList,'us_id'));
  
  // get list of US from the same release
  $request=new sqlRequest("SELECT us_id,CONCAT(us_number,' : ',SUBSTRING(kados_user_stories.text,1,80)) AS us_text FROM kados_user_stories 
                           WHERE kados_user_stories.active=1 
                             AND us_id NOT IN(".implode(',',$ignoredUs).") 
	                     AND ".$scope,$cnx->num);
  $listUs=$request->getArrayFields();
  echo json_encode($listUs);

}?>