<?php
/**
 * Remove a relationship from a couple of US
 *
 * PHP version 5
 *
 * @category Scripts
 * @package  RelationShip
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
session_start();

// check if session is started and an user is logged
if (isset($_SESSION['login']))
{    
    
  // get lib and scripts  
  define("PATHBASE",'../');
  $pathCommons=PATHBASE.'common_scripts/';  
  include PATHBASE.'conf/connect.conf';
  include PATHBASE.'libraries/classes/class_connexion_mysql.php';
  include $pathCommons.'date_hour.php';
  include $pathCommons.'app_functions.php';
  include $pathCommons.'functions.php';
  include PATHBASE.'classes/relationship.php';
  include PATHBASE.'classes/history.php';
 
  // start link to DB
  $cnx=new connexion_db();
  date_default_timezone_set(getParameter('TZ', $cnx->num));
  // filter vars
  $postitId=intval($_POST['us_id']);
  $postitTarget=intval($_POST['us_target']);
    
  // get relationship object
  $relationshipObject=new relationship($cnx->num);
  // set reference US
  $relationshipObject->setFirstUs($postitId);
  // add relationship
  $relationshipObject->removeUsRelationship($postitTarget);
  
  // add history log
  // create history object
  $historyObject=new history($cnx->num);
  // add history for current US
  $historyObject->addPostitHistory('US', $postitId, 'relationship_del',$postitTarget,'',$_SESSION['login']);
  // add history for target US
  $historyObject->addPostitHistory('US',$postitTarget , 'relationship_del',$postitId,'',$_SESSION['login']);  
  // send feedback
  echo 'OK_'.$postitTarget;
}?>